<?php // $Id: add.php,v 1.7 2006/02/25 18:07:32 dlnsk Exp $

// Modified by Fumi.Iseki to add_multi.php  2007/03/19

require_once('../../config.php');	
require_once($CFG->libdir.'/blocklib.php');
require_once('lib.php');	
require_once('tuis_tools.php');	


$courseid = required_param('course',   PARAM_INT);	 // Course id
$mode 	  = optional_param('mode', '', PARAM_ALPHA); // one or multiply or empty

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
	error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}

if ($course->category) {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend') .' ' .
 				 get_string('add_multi','block_autoattend'), $course->fullname,
				 "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
					 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

$currenttab = 'add_multi';	
include('tabs.php');
	

// add record
if ($mode==='multiply') {
	$startday	= required_param('startday',   PARAM_INT);
	$startmonth	= required_param('startmonth', PARAM_INT);
	$startyear 	= required_param('startyear',  PARAM_INT);		
	$endday		= required_param('endday',     PARAM_INT);
	$endmonth 	= required_param('endmonth',   PARAM_INT);
	$endyear 	= required_param('endyear',    PARAM_INT);	
	$period		= required_param('period',     PARAM_INT);
	$sdays 		= optional_param('sdays', '',  PARAM_ALPHA);

	$method	 	= required_param('method',     PARAM_ALPHA);
	$shour	  	= required_param('shour',      PARAM_INT);
	$smin	   	= required_param('smin',       PARAM_INT);
	$ehour	  	= required_param('ehour',      PARAM_INT);
	$emin	   	= required_param('emin',       PARAM_INT);
	$lmin	   	= required_param('lmin',       PARAM_INT); 
	$attendkey  = required_param('attendkey');
	$allowip	= required_param('allowip'); 
	$randomkey  = optional_param('randomkey','');
	$denysameip = optional_param('denysameip','');

	if (empty($denysameip)) $denysameip = '0';

	$starttime  = $shour*ONE_HOUR + $smin*ONE_MIN + $TIME_OFFSET;
	$endtime	= $ehour*ONE_HOUR + $emin*ONE_MIN + $TIME_OFFSET;
	$latetime   = ($lmin - 1)*MIN_INTVL*ONE_MIN;
	$startdate  = mktime(0, 0, 0, $startmonth, $startday, $startyear);
	$enddate	= mktime(0, 0, 0, $endmonth,   $endday,   $endyear);

	if (empty($sdays)) {
		//redirect('add_multi.php?course='.$course->id, get_string('sdaysmiss','block_autoattend'), 3);
		global $OMITTED_DAYS;
		$sdays = array();
		$dinfo = getdate($startdate);
		$sdays['0'] = $OMITTED_DAYS["{$dinfo['wday']}"];
	}

	//get no of days and times
	$days  = (int) (floor(($enddate - $startdate) / ONE_DAY)) + 1;	// +1 is to include enddate
	$times = $endtime - $starttime;
		
	if($days <= 0) {
		error(get_string('wrongdatesselected','block_autoattend'), 
			  "$CFG->wwwroot/blocks/autoattend/add_multi.php?course=$courseid");
	}
	else if($times <= 0) {
		error(get_string('wrongtimesselected','block_autoattend'), 
			  "$CFG->wwwroot/blocks/autoattend/add_multi.php?course=$courseid");
	}
	else {
		// Getting first day of week
		$sdate = $startdate;
		$dinfo = getdate($sdate);
		if ($CFG->calendar_startwday === 0) { //week start from sunday
			$startweek = mktime(0, 0, 0, $startmonth, $startday-$dinfo['wday'], $startyear);
		} 
		else {
			$wday = $dinfo['wday']===0 ? 7 : $dinfo['wday'];
			$startweek = mktime(0, 0, 0, $startmonth, $startday-$wday+1, $startyear);
		}
		
		// Adding sessions
		while ($sdate <= $enddate) {
			if($sdate < $startweek + ONE_WEEK) {
				if(in_array(date('D',$sdate),$sdays)) {
					$count = count_records('autoattend_sessions', 'courseid', $course->id, 
																  'sessdate', $sdate, 'starttime', $starttime);
					if ($count > 0) {	
						//check whether this date is in our session days
						notify(strftime(get_string('strftimedmy', 'block_autoattend'), $sdate).': '.
										get_string('sessionexist','block_autoattend'));
						$sdate += ONE_DAY;
						continue;
					}

					$rec->courseid    = $course->id;
					$rec->creator     = $user->id;
					$rec->sessdate    = $sdate;
					$rec->method	  = $method;
					$rec->starttime   = $starttime;
					$rec->endtime     = $endtime;
					$rec->latetime    = $latetime;
					$rec->allowip     = $allowip;
					$rec->description = '';
					$rec->denysameip  = $denysameip;

					if ($method=='S') {
						if (!$attendkey and $randomkey) {
							$rec->attendkey	= tuis_randstr(5, true);
						}
						else {
							$rec->attendkey	= $attendkey;
						}
					}
					else {
						$rec->attendkey	= "";
					}

					if (insert_record('autoattend_sessions', $rec)) {
						$loginfo = "=$sdate,$starttime,$method";
						add_to_log($course->id,'autoattend','add multiply sessions','index.php?id='.$course->id,$loginfo);
					}
					else {
						error(get_string('erroringeneratingsessions','block_autoattend'), 
								"$CFG->wwwroot/blocks/autoattend/add_multi.php?course=.$courseid");
					}
					unset($rec);
				}
				$sdate += ONE_DAY;
			} 
			else {
				$startweek += ONE_WEEK * $period;
				$sdate = $startweek;
			}
		}
		notice(get_string('sessionsgenerated','block_autoattend'));
	}
}


// 追加タブの表示
if(isteacher($course->id)) { ?>
	<table align="center" class="generalbox">
	  	<tr>
			<td class="generalboxcontent">

		  		<table  border="0" align="center" cellpadding="5" cellspacing="0">
	  				<tr><td height="15" colspan="2"></td></tr>

	  				<form name="gsess" method="post" action="add_multi.php">

						<!-- multiply mode -->
	  	  				<tr>
							<td colspan="2">
			  					<h2 class="main help">
									<?php echo get_string('createmultiplesessions','block_autoattend').
						   					   helpbutton('createmultiplesessions', 
						   								  get_string('createmultiplesessions','block_autoattend'), 
														  'block_autoattend', true, false, '', true);?>
			  					</h2>
							</td>
		  				</tr>

	  					<tr>
			  				<td align="right" valign="top">
								<strong><?php print_string('sessionmethod','block_autoattend')?>: </strong>
			  				</td>
			  				<td>
								<input type='radio' name='method' value='A'>
									<?php print_string('Amethodfull','block_autoattend')?>&nbsp;&nbsp;
								<input type='radio' name='method' value='S' checked='checked'>
									<?php print_string('Smethodfull','block_autoattend')?>&nbsp;&nbsp;
								<input type='radio' name='method' value='M'>
									<?php print_string('Mmethodfull','block_autoattend')?>
			 			 	</td>
	  					</tr>

	  					<tr>
			  				<td align="right">
								<strong><?php print_string('sessionstartdate','block_autoattend')?>: </strong>
							</td>
			  				<td><?php print_date_selector("startday", "startmonth", "startyear");?></td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('sessionenddate','block_autoattend')?>: </strong>
							</td>
							<td><?php print_date_selector("endday", "endmonth", "endyear");?></td>
	  					</tr>
	  					<tr>
			  				<td align="right" valign="top">
								<strong><?php print_string('sessiondays','block_autoattend')?>: </strong>
			  				</td>
			  				<td>
								<input type="checkbox" name="sdays[]" value="Mon">
									<?php print_string('monday','calendar')?>
								<input type="checkbox" name="sdays[]" value="Tue">
									<?php print_string('tuesday','calendar')?>
								<input type="checkbox" name="sdays[]" value="Wed">
									<?php print_string('wednesday','calendar')?> <br />
								<input type="checkbox" name="sdays[]" value="Thu">
									<?php print_string('thursday','calendar')?>
								<input type="checkbox" name="sdays[]" value="Fri">
									<?php print_string('friday','calendar')?>
								<input type="checkbox" name="sdays[]" value="Sat">
									<?php print_string('saturday','calendar')?>
								<input type="checkbox" name="sdays[]" value="Sun">
									<?php print_string('sunday','calendar')?>
			 			 	</td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('period','block_autoattend')?>: </strong>
							</td>
							<td><?php choose_from_menu(array(1=>1,2,3,4,5,6,7,8), 'period', 1, false);
				  					  echo ' '.get_string('week','block_autoattend');?>
							</td>
	  					</tr>

	  					<tr>
			  				<td align="right">
								<strong><?php print_string('sessionstarttime','block_autoattend')?>: </strong>
							</td>
			  				<td>
								<?php print_time_selector("shour", "smin");?>
								<?php print_string('hourmin','block_autoattend')?>
							</td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('sessionendtime','block_autoattend')?>: </strong>
							</td>
							<td>
								<?php print_time_selector("ehour", "emin");?>
								<?php print_string('hourmin','block_autoattend')?>
							</td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('sessionlatetime','block_autoattend')?>: </strong>
							</td>
							<td><?php choose_from_menu(array(1=> 0, 5,10,15,20,25,30,35,40,45,50,55,60,
																65,70,75,80,85,90,95,100,105,110,115,120), 
																'lmin', 1, false);
				  					  echo ' '.get_string('minute','block_autoattend');?>
							</td>
	  					</tr>
						<tr>
							 <td align="right">
								  <strong><?php echo get_string('attendkey','block_autoattend');?>:</strong>
							 </td>
							 <td>
								<input type="text" name="attendkey" size="40" maxlength="30" value="">&nbsp;&nbsp;
								<input type="checkbox" name="randomkey" value="1" checked>
								<?php print_string('setrandomkey','block_autoattend');?>
							</td>
						</tr>

			  			<tr>
		  					<td align="right">
								<strong><?php echo get_string('sessionallowip','block_autoattend');?>:</strong>
							</td>
		  					<td><input type="text" name="allowip" size="60" maxlength="100" value=""></td>
		 		  		</tr>

						<tr>
							<td align="right">
								<strong><?php echo get_string('denysameip','block_autoattend');?>:</strong>
							</td>
							<td><input type="checkbox" name="denysameip" value="1" checked></td>
						</tr>

	  					<tr>
							<td>&nbsp;</td>
							<td>
								<input type="hidden" name="course" value="<?php echo $course->id?>">
		  						<input type="hidden" name="mode"   value="multiply">
		  						<input type="submit" name="addmultiplesessions" 
										value="<?php print_string('addmultiplesessions','block_autoattend')?>">
							</td>
	  					</tr>

	  				</form>

	  				<tr>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
	  				</tr>
				</table>
			</td>
		</tr>
	</table>
<?php
}

print_footer($course);
?>
