<?php // $Id: add.php,v 1.7 2006/02/25 18:07:32 dlnsk Exp $

// Modified by Fumi.Iseki to add_one.php  2007/03/19

require_once('../../config.php');	
require_once($CFG->libdir.'/blocklib.php');
require_once('lib.php');	
require_once('tuis_tools.php');	


$courseid = required_param('course',	PARAM_INT);		// Course id
$mode	  = optional_param('mode', '', PARAM_ALPHA);	// one or empty

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
	 error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}

if ($course->category) {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend').' '.
				 		get_string('add_one','block_autoattend'), $course->fullname,
				 "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 		get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

$currenttab = 'add_one';	
include('tabs.php');

if ($mode==='one') {
	$sday 		= required_param('sday',	PARAM_INT);
	$smonth		= required_param('smonth', 	PARAM_INT);
	$syear 		= required_param('syear',  	PARAM_INT);		

	$method	 	= required_param('method', 	PARAM_ALPHA);		
	$shour		= required_param('shour',  	PARAM_INT);		
	$smin		= required_param('smin',	PARAM_INT);		
	$ehour		= required_param('ehour',  	PARAM_INT);		
	$emin		= required_param('emin',	PARAM_INT);		
	$lmin		= required_param('lmin',	PARAM_INT);		
	$attendkey  = required_param('attendkey');		
	$allowip	= required_param('allowip');		
	$desc 		= required_param('desc');		
	$randomkey  = optional_param('randomkey','');		
	$denysameip = optional_param('denysameip','');		

	if (empty($denysameip)) $denysameip = '0';

	$starttime  = $shour*ONE_HOUR + $smin*ONE_MIN + $TIME_OFFSET;
	$endtime	= $ehour*ONE_HOUR + $emin*ONE_MIN + $TIME_OFFSET;
	$latetime	= ($lmin - 1)*MIN_INTVL*ONE_MIN;
	$sessdate	= mktime(0, 0, 0, $smonth, $sday, $syear);

	$count = count_records('autoattend_sessions', 'courseid', $course->id, 
												  'sessdate', $sessdate, 'starttime', $starttime);
	if ($count!=0)	{	//duplicate session exists
		error(get_string('sessionalreadyexists', 'block_autoattend'),
			  "$CFG->wwwroot/blocks/autoattend/add_one.php?course=$courseid");	
	}
	else {	
		// insert session
		$rec->courseid	  = $course->id;
		$rec->creator	  = $USER->id;
		$rec->sessdate	  = $sessdate;
		$rec->method	  = $method;
		$rec->starttime	  = $starttime;
		$rec->endtime	  = $endtime;
		$rec->latetime	  = $latetime;
		$rec->allowip	  = $allowip;
		$rec->description = $desc;
		$rec->denysameip  = $denysameip;

		if (!$attendkey and $randomkey) {
			$rec->attendkey = tuis_randstr(5, true);
	  	}
	 	else {
			$rec->attendkey = $attendkey;
		}

		if(insert_record('autoattend_sessions', $rec)) {
			$loginfo = "=$sessdate,$starttime,$method";
			add_to_log($course->id, 'autoattend', 'add one session', 'index.php?id='.$course->id, $loginfo);
			notice(get_string('sessionadded','block_autoattend'));
		} 
		else {
			error(get_string('errorinaddingsession', 'block_autoattend'), 
				  "$CFG->wwwroot/blocks/autoattend/add_one.php?course=$courseid");
		}
	}
} 



// 追加タブの表示
if(isteacher($course->id)) { ?>
	<table align="center" class="generalbox">
	  	<tr>
			<td class="generalboxcontent">

		  		<table  border="0" align="center" cellpadding="5" cellspacing="0">
	  				<tr><td height="15" colspan="2"></td></tr>

	  				<form name="gsess" method="post" action="add_one.php">

	  					<tr>
			  				<td colspan="2" align="left">
								<h2 class="main help">
									<?php echo get_string('createonesession','block_autoattend').
													helpbutton('createonesession', 
														get_string('createonesession','block_autoattend'), 
															'block_autoattend', true, false, '', true);?>
								</h2>
			  				</td>
						</tr>


	  					<tr>
			  				<td align="right" valign="top">
								<strong><?php print_string('sessionmethod','block_autoattend')?>: </strong>
			  				</td>
			  				<td>
								<input type='radio' name='method' value='A' >
									<?php print_string('Amethodfull','block_autoattend')?>&nbsp;&nbsp;
								<input type='radio' name='method' value='S' checked='checked'>
									<?php print_string('Smethodfull','block_autoattend')?>&nbsp;&nbsp;
								<input type='radio' name='method' value='M'>
									<?php print_string('Mmethodfull','block_autoattend')?>
			 			 	</td>
	  					</tr>

	  		  			<tr>
							<td align="right">
								<strong><?php print_string('sessiondate','block_autoattend');?>: </strong>
							</td>
							<td><?php print_date_selector("sday", "smonth", "syear");?></td>
	  		  			</tr>

	  					<tr>
			  				<td align="right">
								<strong><?php print_string('sessionstarttime','block_autoattend')?>: </strong>
							</td>
			  				<td>
								<?php print_time_selector("shour", "smin");?>
								<?php print_string('hourmin','block_autoattend')?>
							</td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('sessionendtime','block_autoattend')?>: </strong>
							</td>
							<td>
								<?php print_time_selector("ehour", "emin");?>
								<?php print_string('hourmin','block_autoattend')?>
							</td>
	  					</tr>
	  					<tr>
							<td align="right">
								<strong><?php print_string('sessionlatetime','block_autoattend')?>: </strong>
							</td>
							<td><?php choose_from_menu(array(1=> 0, 5,10,15,20,25,30,35,40,45,50,55,60,
																65,70,75,80,85,90,95,100,105,110,115,120), 
																'lmin', 1, false);
				  					  echo ' '.get_string('minute','block_autoattend');?>
							</td>
	  					</tr>

			  			<tr>
	  						<td align="right">
								<strong><?php echo get_string('attendkey','block_autoattend');?>:</strong>
							</td>
	  						<td>
								<input type="text" name="attendkey" size="40" maxlength="30" value="">
								<input type="checkbox" name="randomkey" value="1" checked>
								<?php print_string('setrandomkey','block_autoattend');?>
							</td>
	 		  			</tr>

			  			<tr>
	  						<td align="right">
								<strong><?php echo get_string('sessionallowip','block_autoattend');?>:</strong>
							</td>
	  						<td><input type="text" name="allowip" size="60" maxlength="100" value=""></td>
	 		  			</tr>

			  			<tr>
	  						<td align="right">
								<strong><?php echo get_string('denysameip','block_autoattend');?>:</strong>
							</td>
	  						<td><input type="checkbox" name="denysameip" value="1" checked></td>
	 		  			</tr>

			  			<tr>
	  						<td align="right">
								<strong><?php echo get_string('description','block_autoattend');?>:</strong>
							</td>
	  						<td><input type="text" name="desc" size="60" maxlength="100" value=""></td>
	 		  			</tr>

	 		  			<tr>
							<td>&nbsp;</td>
							<td>
								<input type="hidden" name="course" value="<?php echo $course->id ?>">
		  		  				<input type="hidden" name="mode"	value="one">
		  		  				<input type="submit" name="addsession" 
											value="<?php print_string('addsession','block_autoattend');?>">
							</td>
	  		  			</tr>
	  				</form>
				</table>
			</td>
		</tr>
	</table>
<?php
}

print_footer($course);
?>	
