<?php 
//
// Automatic Attendance Block 
// Modified Attendance Block by Fumi.Iseki 2007/03/19
//
	
require_once($CFG->dirroot.'/blocks/autoattend/lib.php');


class block_autoattend extends block_base 
{

	function init() {
		$this->title   = get_string('autoattendblock', 'block_autoattend');
		$this->version = 2007032917;
		$this->release = '1.0.0';
	}


	function get_content() {
		global $CFG, $USER;

		if ($this->content !== NULL) {
			return $this->content;
		}
		
		$id = optional_param('id', 0);
		if ($id != 0) {
			if (!$course = get_record('course', 'id', $id)) {
				error(get_string('courseidwrong','block_autoattend'));
			}
		} 
		else {
			return '';
		}

		$this->content = new stdClass; 
		$this->content->items  = array();
		$this->content->icons  = array(); 
		$this->content->footer = '';
		
		if(isteacher($course->id)) {	// Teacher
			$this->content->text = '<a href="'.$CFG->wwwroot.'/blocks/autoattend/index.php?course='.$course->id.
					'&amp;from=home">'.get_string('takemanualattend','block_autoattend').'</a><br />';
			$this->content->text .= '<a href="'.$CFG->wwwroot.'/blocks/autoattend/report.php?course='.$course->id.
					'&amp;view=weeks">'.get_string('report','block_autoattend').'</a><br />';
			$this->content->text .= '<a href="'.$CFG->wwwroot.'/blocks/autoattend/settings.php?course='.$course->id.
					'&sel=settings">'.get_string('settings','block_autoattend').'</a><br />';
		}	
		elseif (isguest()) {
			$this->content->text = '';	// Guest
		} 
		else {							// Student
			$comqry = "select count(*) as cnt 
              			from {$CFG->prefix}autoattend_students std, {$CFG->prefix}autoattend_sessions ses 
              			where attsid=ses.id and ses.courseid={$course->id} and std.studentid={$USER->id}
						and std.status<>'Y' ";
 			$comdata = get_record_sql($comqry);

			$complete = $comdata->cnt;
			if($complete == 0) {		//autoattend not generated yet
				$this->content->text .= get_string('attendnotstarted','block_autoattend');
			}
			else {						//autoattend taken
				$settings = autoattend_get_settings($course->id);
				foreach($settings as $set) {
					$desc = get_string($set->status.'acronymfull', 'block_autoattend');
					$this->content->text .= $desc.': '.
							autoattend_get_status_num($USER->id,$course->id,$set->status).'<br />';
				}
				$percent = sprintf("%0.1f", autoattend_get_percent($USER->id,$course->id));
				$grade   = autoattend_get_grade($USER->id,$course->id);
				$this->content->text .= get_string('attendpercent','block_autoattend').': '.$percent.' %<br />';
				$this->content->text .= get_string('attendgrade','block_autoattend').": $grade<br />";
				$this->content->text .= '<a href="'.$CFG->wwwroot.'/blocks/autoattend/index.php?course='.
										$course->id.'">'.get_string('indetail','block_autoattend').'</a>';
			}

		}	

		return $this->content;
	}
}

?>
