<?php // $Id: delete.php,v 1.3 2006/02/08 18:39:15 dlnsk Exp $

// Modified by Fumi.Iseki 2007/03/23


require_once("../../config.php");	
require_once($CFG->libdir.'/blocklib.php');

$courseid = required_param('course', PARAM_INT);  // Course id
$attsid	  = required_param('attsid', PARAM_INT);
$confirm  = optional_param('confirm','');
$action   = optional_param('action','');
$submit   = optional_param('submit','');
	
if (!empty($submit) && $submit==get_string('cancel')) {
	redirect('index.php?course='.$courseid);
}

if (!$course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
	error(get_string('notaccessstudent','block_autoattend'));
}

if (!$user = get_record('user', 'id', $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}


// Delete Record Check
if ($action=='deleteselects') {
	foreach($_POST as $key => $value) {
		if (substr($key,0,6) == 'delete') {
  			$delid  = substr($key, 6, strlen($key)-6);
			if ($att = get_record('autoattend_sessions', 'id', $delid) ) {
   				$deletes[$delid]  = $att;
			}
	 	}
	}
}
else {
	if (!$att = get_record('autoattend_sessions', 'id', $attsid) ) {
		error(get_string('nosuchsession','block_autoattend'));
	}
}

if ($action=='deleteselects' and empty($deletes)) {
	redirect('index.php?course='.$courseid);
}



// Delete!!!
if (!empty($confirm)) {
	if (!empty($submit) && $submit==get_string('deleteok','block_autoattend')) {
		if ($action=='deleteselects') {
			foreach($deletes as $key => $value) {
				delete_records('autoattend_students', 'attsid', $key);
				delete_records('autoattend_sessions', 'id', $key);
				$loginfo = "=$key,".$deletes[$key]->sessdate.",".$deletes[$key]->starttime.",".$deletes[$key]->method;
				add_to_log($course->id, 'autoattend', 'delete session', 'index.php?course='.$course->id, $loginfo);
			}
		}
		else {
			delete_records('autoattend_students', 'attsid', $attsid);
			delete_records('autoattend_sessions', 'id', $attsid);
			$loginfo = "=$attsid,".$att->sessdate.",".$att->starttime.",".$att->method;
			add_to_log($course->id, 'autoattend', 'delete session', 'index.php?course='.$course->id, "=".$attsid);
		}
		redirect('index.php?course='.$course->id, get_string('sessiondeleted','block_autoattend'), 1);
	}
}



// Confirm Form
if ($course->category) {
	print_header(get_string('delete'). ' ' .get_string('session','block_autoattend') , $course->fullname,
				 "<a href=\"{$CFG->wwwroot}/course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 "<a href=\"index.php?course=$course->id\">".get_string('autoattend','block_autoattend')."</a> -> ".
				 get_string('delete','block_autoattend'),"", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}


if ($action=='deleteselects') {
	$deleteattend = '';
	foreach($deletes as $key => $att) {
		$deleteattend .= '<tr><td><b>'.
						 strftime(get_string('strftimedmyw', 'block_autoattend'), $att->sessdate).'&nbsp;&nbsp;'.
						 strftime(get_string('strftimehourmin', 'block_autoattend'), $att->starttime).'-&nbsp;&nbsp;&nbsp;'.
						 get_string('description','block_autoattend').': '.
				 		 ($att->description ? $att->description : get_string('nodescription', 'block_autoattend')).
						 '<input type="hidden" name="delete'.$key.'" value="1">'.
						 '<input type="hidden" name="action" value="deleteselects">'.
						 '</b></td></tr>';
	}
	$deleteattend .= '<input type="hidden" name="attsid" value="-1">';
}
else {
	$deleteattend = '<tr><td><b>'.
					strftime(get_string('strftimedmyw', 'block_autoattend'), $att->sessdate).'&nbsp;&nbsp;'.
					strftime(get_string('strftimehourmin', 'block_autoattend'), $att->starttime).'-&nbsp;&nbsp;&nbsp;'.
					get_string('description','block_autoattend').': '.
				 	($att->description ? $att->description : get_string('nodescription', 'block_autoattend')).
					'<input type="hidden" name="attsid" value="'.$attsid.'">'.
					'</b></td></tr>';
}


print_heading(get_string('deletingsession','block_autoattend').' :: ' .$course->fullname);
print_simple_box_start('center', '60%', '', 5, 'generalbox', 'notice');
?>

<table  border="0" align="center">
	<form name="delete" action="delete.php" method="post">
		<tr>
			<td>
				<h2><center><strong><?php print_string('deleteconfirm','block_autoattend');?></strong></center></h2>
			</td>
		</tr>
		<tr>
			<td class="generalboxcontent">
				<table border="0" align="center">
					<?php echo $deleteattend;?>
				</table>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td class="generalboxcontent">
				<table border="0" align="center">
					<tr>
						<td>
					 		<input type="hidden" name="confirm" value="1">
							<input type="hidden" name="course" value="<?php echo $course->id;?>">  
							<input type="submit" name="submit" value="<?php print_string('deleteok','block_autoattend')?>">
						</td>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
						<td>
							<input type="submit" name="submit" value="<?php print_string('cancel');?>"> 
						</td>
				</table>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
		</tr>
	</form>
</table>

<?php
print_simple_box_end();

print_footer($course);
?>
