<?php // $Id: index.php,v 1.9 2006/04/16 20:32:51 dlnsk Exp $
	
// Modified by Fumi.Iseki 2007/03/19

require_once('../../config.php');	
require_once('lib.php');
require_once('automaticlib.php');
	

$courseid   = required_param('course', PARAM_INT); 
$action		= optional_param('action', '');
$from		= optional_param('from', '');
$studentid	= optional_param('student', 0, PARAM_INT);
$printing	= optional_param('printing', '');

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);
	
if (! $user = get_record('user', 'id', $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}


// Printing
if ($printing) {
	print_header('', $course->fullname);
	if (isteacher($course->id)) {
		if ($student = get_record('user', 'id', $studentid) ) {
			autoattend_print_user($student, $course, 'printing');
		}
		else {
			error(get_string('nosuchuser','block_autoattend'));
		}
	}
	else {
		autoattend_print_user($user, $course, 'printing');
	}
	exit();
}
 

// DownLoad
if (isteacher($course->id)) {  
	if($action == 'excel') {
		add_to_log($course->id, 'autoattend', 'download Excel', 'index.php?course='.$course->id.'&amp;action=excel');
		autoattend_download($course->id, 'xls');
		exit();
	}
	else if($action == 'text') {
		add_to_log($course->id, 'autoattend', 'download Text',  'index.php?course='.$course->id.'&amp;action=text');
		autoattend_download($course->id,'txt');
		exit();
	}
}



// Print Navi Header
if ($course->category) {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 '<a href="'.$CFG->wwwroot."/course/view.php?id={$course->id}\">$course->shortname</a> -> ".
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

	
// for Teacher
if (isteacher($course->id)) {
	if(!count_records('autoattend_sessions', 'courseid', $course->id)) {	
		$currenttab = 'autoattend';
		include('tabs.php');
		print_heading(get_string('nosessionexists','block_autoattend'));	
	}
	else {
		if($studentid > 0) {	// 個人データを出力
			$currenttab = 'none';
			include('tabs.php');
			//print_heading(get_string('attendforuser','block_autoattend').' :: ' .$course->fullname);
			if ($student = get_record('user', 'id', $studentid) ) {
				autoattend_print_user($student, $course);
				add_to_log($course->id, 'autoattend', 'view teacher', 'index.php?course='.$course->id, $student->studentid);
			} 
			else {
				error(get_string('nosuchuser','block_autoattend'));
			}
		} 
		else {					// 出欠項目のデータを出力
			add_to_log($course->id, 'autoattend', 'view teacher', 'index.php?course='.$course->id);
			$currenttab = 'autoattend';
			include('tabs.php');
			print_sessions_list($course);
		}
	}	
}

// for Guest
else if(isguest()) {
	print_heading(get_string('notaccessguest', 'block_autoattend'));
} 

// for Student
else {
	add_to_log($course->id, 'autoattend', 'view own', 'index.php?course='.$course->id);
	print_heading(get_string('attendforuser','block_autoattend').' :: ' .$course->fullname);
	autoattend_print_user($user, $course);
}

print_footer($course);

	


	
//	
// 出欠リスト一覧の表示
//
function print_sessions_list($course) {
	global $CFG;
	
	$sesss = get_records('autoattend_sessions', 'courseid', $course->id, 'sessdate, starttime asc');
	?>

	<script language="JavaScript">
		function select_all() {
			var ls = document.forms['delete'].elements;
   			for (var i=0; i<ls.length; i++) {
				if (ls[i].type == "checkbox") {
					ls[i].checked = true;
  				}
  			}
		}	
	</script>
	<script language="JavaScript">
	function clear_all() {
		var ls = document.forms['delete'].elements;
		for (var i=0; i<ls.length; i++) {
			if (ls[i].type == "checkbox") {
				ls[i].checked = false;
			}
		}
	}
	</script>


	<table align="center" class="generalbox">
	  	<tr>
			<td class="generalboxcontent">
				<table  border="0" width="100%" align="justify">
					<tr>
						<td>
							<form name="flush" action="refreshSessions.php" method="post">
								<input type="hidden" name="course" value="<?php echo $course->id;?>">
								<input type="submit" value="<?php print_string('refreshdata','block_autoattend')?>">
							</form>
						</td>
						<td align="right">
							<?php echo helpbutton('abouthelp',get_string('about','block_autoattend'),
																	'block_autoattend',true, true,'', true)?>
						</td>
					</tr>
				</table>

				<form name="delete" action="delete.php" method="post">
					<table border="1" align="center" cellpadding="5" cellspacing="0">
						<tr>
				  			<th align="center">#</th>
				  			<th align="center"><?php print_string('date')?></th>
			  				<th align="center"><?php print_string('starttime','block_autoattend')?></th>
			  				<th align="center"><?php print_string('endtime','block_autoattend')?></th>
			  				<th align="center"><?php print_string('description','block_autoattend')?></th>
			  				<th align="center"><?php print_string('keyword','block_autoattend')?></th>
				  			<th align="center"><?php print_string('callmethod','block_autoattend')?></th>
				  			<th align="center"><?php print_string('callstate','block_autoattend')?></th>
				  			<th align="center"><?php print_string('actions')?></th>
						</tr>
					<?php 
					$i = 0;
					$ttlcount = count(get_course_students($course->id));
					foreach($sesss as $key=>$sessdata) { 
						$usercount = count_records_select('autoattend_students', "attsid=$key AND status<>'Y'");
						$i++;
						?>
				  		<tr>
							<td><?php echo $i;?></td>
							<td>
								<?php echo strftime(get_string('strftimedmyw','block_autoattend'),$sessdata->sessdate);?>
							</td>
							<td>
								<?php echo '<center>'.strftime(get_string('strftimehourmin','block_autoattend'),
																					$sessdata->starttime).'</center>';?>
							</td>
							<td>
								<?php echo '<center>'.strftime(get_string('strftimehourmin','block_autoattend'),
																					$sessdata->endtime).'</center>';?>
							</td>
							<td>
								<?php echo ($sessdata->description ? $sessdata->description:
													get_string('nodescription', 'block_autoattend')); ?>
							</td>
							<td>
								<?php echo '<center>'.($sessdata->attendkey ? $sessdata->attendkey:
													get_string('novalue', 'block_autoattend')).'</center>';?>
							</td>
							<td>
								<?php echo '<center>'.get_string($sessdata->method.'methodfull', 'block_autoattend').
										   '</center>'; ?>
							</td>
							<td>
								<?php 
								echo '<center>'.get_string($sessdata->state.'statefull', 'block_autoattend');
								if ($sessdata->state=='O') {
									echo '&nbsp;('.$usercount.'/'.$ttlcount.')';
								}
								echo '</center>'; 
								?>
							</td>

							<td>
								<?php
								$title = get_string('takeattendance','block_autoattend');
								echo "<a title=\"$title\" href=\"updateAttendance.php?course={$course->id}
															&amp;attsid={$sessdata->id}\">";
								if($sessdata->state=='C') {
									echo "<img src=\"{$CFG->pixpath}/t/go.gif\" alt=\"$title\" /></a>&nbsp;";
								}
								else if($sessdata->state=='O') {
									echo "<img src=\"{$CFG->pixpath}/b.gif\" alt=\"$title\" /></a>&nbsp;";
								}
								else {
									echo "<img src=\"{$CFG->pixpath}/t/stop.gif\" alt=\"$title\" /></a>&nbsp;";
								}
	
								$title = get_string('editsession','block_autoattend');
								echo "<a title=\"$title\" href=\"updateSession.php?course={$course->id}
															&amp;attsid={$sessdata->id}\">";
								echo "<img src=\"{$CFG->pixpath}/t/edit.gif\" alt=\"$title\" /></a>";

								/* 
								$title = get_string('deletesession','block_autoattend');
								echo "<a title=\"$title\" href=\"delete.php?course={$course->id}
															&amp;attsid={$sessdata->id}\">";
								echo "<img src=\"{$CFG->pixpath}/t/delete.gif\" alt=\"$title\" /></a>&nbsp;";
								*/
								?>
								<input type="checkbox" name="delete<?php echo $sessdata->id;?>" value="1">
							</td>
						</tr>
					<?php												
					}		//end of foreach
					?>
		  			</table>

		  			<table  border="0" align="right">
						<tr>
							<td>
								<a href="javascript:select_all();">
									[<?php print_string('selectall', 'block_autoattend');?>]
								</a>&nbsp;
							</td>
							<td>
								<a href="javascript:clear_all();">
									[<?php print_string('clearall', 'block_autoattend');?>]
								</a>&nbsp;
							</td>
							<td>
								<input type="hidden" name="course" value="<?php echo $course->id;?>">
								<input type="hidden" name="attsid" value="-1">
								<input type="hidden" name="action" value="deleteselects">
								<input type="submit" value="<?php print_string('deleteselect','block_autoattend')?>">
							</td>
						</tr>
		  			</table>

				</form>
		  	</td>
	  	</tr>

	  	<tr>
			<td>&nbsp;</td>
	  	</tr>

	  	<tr>
			<td class="generalboxcontent">
		  		<table width="50%"  border="0" align="center">
				  	<tr>				
				  		<td width="50%" align="center" height="50">
							<form name="download" action="index.php" method="get">
								<input type="hidden" name="course" value="<?php echo $course->id;?>">
								<input type="hidden" name="action" value="excel">
								<input type="submit" value="<?php print_string('downloadexcel','block_autoattend')?>">
							</form>							
						</td>
						<td>&nbsp;&nbsp;</td>
						<td width="50%" align="center">
							<form name="download" action="index.php" method="get">
								<input type="hidden" name="course" value="<?php echo $course->id;?>">
								<input type="hidden" name="action" value="text">
								<input type="submit" value="<?php print_string('downloadtext','block_autoattend')?>">
							</form>				
						</td>
				  	</tr>
		  		</table>

		  	</td>
	  	</tr>
	</table>
<?php
}
?>	
