<?php

// by Fumi.Iseki 2007/03/28

require_once("../../config.php");	
require_once("lib.php");	
require_once("automaticlib.php");	

$courseid = required_param('courseid', PARAM_INT);  // Course id
$attsid	  = required_param('attsid', PARAM_INT);
$confirm  = optional_param('confirm','');
$submit   = optional_param('submit','');
$checkkey = optional_param('checkkey','');


if (!empty($submit) && $submit==get_string('cancel')) {
	redirect('index.php?course='.$courseid);
}

if (!$course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (isguest()) {
	error(get_string('notaccessguest','block_autoattend'));
}

if (!$user = get_record('user', 'id', $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}

if (!$att = get_record('autoattend_sessions', 'id', $attsid)) {
	error(get_string('nosuchsession','block_autoattend'));
}


$iperrmesg	= "";
$keyerrmesg = "";
$submitmesg	= "";

$attendkey = $att->attendkey;
$iperrmesg = autoattend_check_invalid_semiautoip($att);
//print "IPMESG -> $iperrmesg <br/>";

// Submit!!
if (!empty($confirm)) {
	if (!empty($submit) && $submit==get_string('submitok','block_autoattend')) {
		// $B4D6-$N:F%A%'%C%/!%IT@5%"%/%;%9$G$J$1$l$PDL2a$9$k$O$:!%(B
		if ($att->method!='S' or $att->state!='O') {
			error(get_string('nosuchsession','block_autoattend'));
		}
		if (!$stdnt = autoattend_get_user_atsession($att->id, $user->id)) {
			error(get_string('nosuchuser','block_autoattend'));
		}

		if (!$iperrmesg) {
			if ($checkkey and $attendkey==$checkkey) {
				global $TIME_OFFSET;

				$ntime  = time();
				$status = 'P';
				if ($att->latetime!=0) {
					$ctime = $att->sessdate + $att->starttime - $TIME_OFFSET + $att->latetime;
					if ($ntime > $ctime) $status = 'L';
				}
				$rec->id 	 	 = $stdnt['id'];
				$rec->attsid 	 = $att->id;
				$rec->studentid  = $stdnt['studentid'];	
				$rec->status	 = $status;
				$rec->called	 = 'S';
				$rec->calledby   = CALLED_BY_SEMIAUTO;
				$rec->calledtime = $ntime;
				$rec->ipaddress  = getremoteaddr();
	
				$result = update_record("autoattend_students", $rec);
				if ($result) {
					$loginfo =SEMIAUTO_SUBMIT_LOG."={$att->id},{$stdnt['studentid']},Y,$status";
					add_to_log($course->id, 'autoattend', 'submit semiautoattend', 
						'semiautoattend.php?courseid='.$course->id.'&amp;attsid='.$att->id, $loginfo);
					redirect('index.php?course='.$course->id, get_string('attendsubmitted','block_autoattend'), 1);
				}
				else {
					redirect('index.php?course='.$course->id, get_string('attendsubmiterr','block_autoattend'), 3);
				}
			}
			$keyerrmesg = get_string('mismatchkey','block_autoattend');
		}
	}
}


if ($iperrmesg) {
	$submitmesg = $iperrmesg."<br /><br />".get_string('iperrattention','block_autoattend');
}
else if ($keyerrmesg) {
	$submitmesg = $keyerrmesg."<br /><br />".get_string('keyerrattention','block_autoattend').
												'<br /><input type="text" name="checkkey" value="">';
}
else if ($attendkey) {
	$submitmesg = get_string('needkeyword','block_autoattend').
												'<br /><input type="text" name="checkkey" value="">';
}



// Confirm Form
if ($course->category) {
	print_header(get_string('submitattend','block_autoattend'). ' ' .get_string('session','block_autoattend'), 
				 $course->fullname,
				 "<a href=\"{$CFG->wwwroot}/course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 "<a href=\"index.php?course=$course->id\">".get_string('autoattend','block_autoattend')."</a> -> ".
				 get_string('submitattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}


$submitsession = strftime(get_string('strftimedmyw', 'block_autoattend'), $att->sessdate).'&nbsp;&nbsp;'.
				 strftime(get_string('strftimehourmin', 'block_autoattend'), $att->starttime).'-&nbsp;&nbsp;&nbsp;'.
				 get_string('description','block_autoattend').': '.
				 ($att->description ? $att->description : get_string('nodescription', 'block_autoattend'));




print_heading(get_string('submitattend','block_autoattend').' :: ' .$course->fullname);
print_simple_box_start('center', '60%', '', 5, 'generalbox', 'notice');
?>

<table  border="0" align="center">
	<form name="semiautoattend" action="semiautoattend.php" method="post">
		<tr>
			<td>
				<?php
				if ($iperrmesg) { ?>
					<h2><center><strong><?php print_string('iperroccur','block_autoattend');?></strong></center></h2>
					<?php
				}
				else if ($keyerrmesg) { ?>
					<h2><center><strong><?php print_string('keyerroccur','block_autoattend');?></strong></center></h2>
					<?php
				}
				else { ?>
					<h2><center><strong><?php print_string('semiautoconfirm','block_autoattend');?></strong></center></h2>
					<?php
				} ?>
			</td>
		</tr>
		<tr>
			<!--<td class="generalboxcontent">-->
			<td>
				<table border="0" align="center">
					<tr>
						<td align="center"><b><?php echo $submitsession;?></b></td>
					</tr>
					<tr>
						<td>&nbsp;</td>
					</tr>
					<tr>
						<td><h3><center><?php echo $submitmesg;?></center></h3></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="generalboxcontent">
				<table border="0" align="center">
					<tr>
						<input type="hidden" name="attsid"   value="<?php echo $attsid;?>">
						<input type="hidden" name="courseid" value="<?php echo $course->id;?>">  
						<?php
						if (empty($iperrmesg)) { ?>
							<td>
					 			<input type="hidden" name="confirm" value="1">
								<input type="submit" name="submit" value="<?php print_string('submitok','block_autoattend')?>">
							</td>
							<td>&nbsp;</td>
							<td>&nbsp;</td>
							<?php
						} ?>
						<td>
							<input type="submit" name="submit" value="<?php print_string('cancel');?>"> 
						</td>
				</table>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
		</tr>
	</form>
</table>

<?php
print_simple_box_end();

print_footer($course);
?>
