<?php 
// $Id: settings.php, 2005/09/21
/*
	Author 	: Ashok kumar Pola
	Company : Human-Logic
	Email 	: ashok_pola@human-logic.com
*/

// Modified by Fumi.Iseki 2007/03/23

require_once('../../config.php');	
require_once('lib.php');	

$courseid	    = required_param('course', PARAM_INT);	// Course id
$page			= optional_param('page', 0, PARAM_INT); // which page to show
$submitsettings	= optional_param('submitsettings', '');

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
    error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}



function config_save()
{
	$grade	 = required_param('grade',PARAM_INT);
	$restore = optional_param('restore',0,PARAM_INT);
	
	global $course, $user;

	$status = array('P','L','E','X','Y');
	
	//restore defaults	
	if($restore) {
		delete_records('autoattend_settings', 'courseid', $course->id);
		add_to_log($course->id, 'autoattend', 'restore settings', 'settings.php?course='.$course->id);
		return;
	}	

	//update settings
	for ($i=0; $i<count($status); $i++) {
		if ($rec = get_record('autoattend_settings', 'courseid', $course->id, 'status', $status[$i])) {
			$update = true;
		}
		$rec->courseid = $course->id;
		$rec->status   = $status[$i];
		$rec->grade    = $grade[$i];

		if (@$update) {
			$result = update_record('autoattend_settings', $rec);
			if (!$result) break;
		}
		else {
			$result = insert_record('autoattend_settings', $rec);
			if (!$result) break;
		}
		unset($rec);
		add_to_log($course->id, 'autoattend', 'update settings', 'settings.php?course='.$course->id);
	}

	if ($result) {
		notice(get_string('variablesupdated','block_autoattend'), 'settings.php?course='.$course->id);
	}
	else {
		notice(get_string('variablesupdateerror','block_autoattend'), 'settings.php?course='.$course->id);
	}
}



$baseurl = $CFG->wwwroot.'/blocks/autoattend/index.php?course='.$course->id;

/// Print headers
if ($course->category) {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend') .' '.
										get_string('settings','block_autoattend'), $course->fullname,
				 "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}


$currenttab = 'settings';	
include('tabs.php');


if(isteacher($course->id)) {
	if ($submitsettings) {
		config_save();
	}

	?>
	<form name="gsess" method="post" action="settings.php" onSubmit="return validateSession()">
	<table align="center" class="generalbox">
  		<tr>
			<td class="generalboxcontent">  
				<table align="center">
					<tr>
	  					<td>
							<table  border="0" align="center" cellpadding="0" cellspacing="0">
		  						<tr>
									<th height="50" align="left">
										<h1 class="main help">
											<?php echo get_string('myvariables','block_autoattend').
												helpbutton ('myvariables', get_string('myvariables','block_autoattend'), 
															'block_autoattend', true, false, '', true);?>
										</h1>
									</th>
		  						</tr>

		  						<tr>
									<td>
										<table border="0" align="center" cellpadding="5" cellspacing="0">
											<tr>
				  								<th>#</th>
				  								<th height="24">
													<strong><?php print_string('status','block_autoattend');?> </strong>
												</th>
				  								<th height="24">
													<strong><?php print_string('acronym','block_autoattend');?> </strong>
												</th>
				  								<th><strong><?php print_string('description');?> </strong></th>
				  								<th width="100" align="center">
													<strong><?php print_string('grade');?> </strong>
												</th>
											</tr>
											<?php
					  						$i = 1;
											$settings = autoattend_get_settings($course->id);
											foreach($settings as $set) {
												?>
												<tr>
												<?php
												if ($set->status!='Y') { ?>
					  								<td align="center"><?php echo $i;?>.</td>
					  								<td height="24" align="center"><?php echo $set->status;?></td>
					  								<td height="24" align="center">
														<?php echo get_string($set->status.'acronym', 'block_autoattend');?>
													</td>
						  							<td align="center">
														<?php echo get_string($set->status.'acronymfull','block_autoattend');?>
													</td>
						  							<td width="100" align="center">
														<input type="text" name="grade[]" size="4" maxlength="4" 
																						value="<?php echo $set->grade;?>" />
													</td>
													<?php
												}
												else {?>
													<input type="hidden" name="grade[]" value="<?php echo $set->grade;?>" />
													<?php
												} 
												$i++; ?>
												</tr>
												<?php
			  								}
				  							?>	
											<tr>
					  							<td height="40" colspan="5" align="center">
													<input type="checkbox" name="restore" value="1" />
													<?php echo get_string('restoredefaults','block_autoattend').
																	helpbutton ('defaultstatuses', 
																		get_string('showdefaults','block_autoattend'), 
																		'block_autoattend', true, false, '', true);
													?> 
												</td>
											</tr>
											<tr>
				  								<td colspan="5" align="center">
													<input type="hidden" name="course" value="<?php echo $courseid;?>">
													<input type="submit" name="submitsettings" 
																value="<?php echo get_string("update",'block_autoattend');?>">
												</td>
											</tr>
				 						</table>
									</td>
		  						</tr>
		  						<tr>
									<td height="30">&nbsp;</td>
		  						</tr>
							</table>
						</td>
					</tr>
  				</table>
			</td>
  		</tr>
	</table>
	</form>
	<?php
}

print_footer($course);
?>	
