<?php // $Id: updateAttendance.php,v 1.10 2006/06/13 01:23:46 dlnsk Exp $

// Modified by Fumi.Iseki 2007/03/28

require_once('../../config.php');	
require_once($CFG->libdir.'/blocklib.php');
require_once('lib.php');

$courseid = required_param('course', PARAM_INT);	 // Course id
$attsid	  = required_param('attsid');
$sort 	  = optional_param('sort','lastname');

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
    error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}
	

/// Print headers
if ($course->category) {
	print_header(get_string('updatesessionattend','block_autoattend'). ' ' .
				 get_string('autoattend','block_autoattend'), $course->fullname,
				 "<a href=\"{$CFG->wwwroot}/course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 "<a href=\"index.php?course=$course->id\">".get_string('autoattend','block_autoattend')."</a> -> ".
				 get_string('updatesessionattend','block_autoattend'),"", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

echo "<script type=\"text/javascript\">
<!--
function select_all_radio_in(elTagName, elClass, elId) {
	var inputs = document.getElementsByTagName('INPUT');
	inputs = filterByParent(inputs, function(el) {return findParentNode(el, elTagName, elClass, elId);});
	for(var i = 0; i < inputs.length; ++i) {
		if(inputs[i].type == 'radio') {
			inputs[i].checked = 'checked';
		}
	}
}
//-->
</script>";
	

if (!$sessdata = get_record('autoattend_sessions', 'id', $attsid) ) {
	error(get_string('reqinfomiss', 'block_autoattend'), "index.php?course=".$courseid);
}

$update = count_records('autoattend_students', 'attsid', $attsid);
	
if ($update) {
	print_heading(get_string('update','block_autoattend').'&nbsp;&nbsp;&nbsp;' .
				  get_string('attendforsession','block_autoattend').' :: ' .$course->fullname);
} 
else {
	print_heading(get_string('attendforsession','block_autoattend').' :: ' .$course->fullname);
}
	

$sort = $sort == 'firstname' ? 'firstname' : 'lastname';
if ($currentgroup = setup_and_print_groups($course, VISIBLEGROUPS, 
						"updateAttendance.php?course={$course->id}&amp;attsid=$attsid
						&amp;sort=$sort")) {
	$students = get_group_users($currentgroup);
} 
else {
	$students = get_course_students($course->id, "u.$sort ASC");
}


$table->data[][] = get_string('sessiondate','block_autoattend').': '.
				   '<b>'.strftime(get_string('strftimedmyw',    'block_autoattend'), $sessdata->sessdate)."&nbsp;&nbsp;".
						 strftime(get_string('strftimehourmin', 'block_autoattend'), $sessdata->starttime)."-".
						 strftime(get_string('strftimehourmin', 'block_autoattend'), $sessdata->endtime).'</b>'.
						 "&nbsp;&nbsp;".
						 get_string('callmethod', 'block_autoattend').': '.
				   '<b>'.get_string($sessdata->method.'methodfull', 'block_autoattend')." ".'</b>'.
						"&nbsp;&nbsp;".
						get_string('description', 'block_autoattend').': '.
				   '<b>'.' "'.($sessdata->description ? $sessdata->description : 
													   get_string('nodescription', 'block_autoattend')).'"</b>';

$help = helpbutton('updatesessionattend', get_string('updatesessionatten', 'block_autoattend'), 
															'block_autoattend', true, false, '', true);
print_simple_box_start('center', '98%', '', 5, 'generalbox', 'notice');

echo '<h2 class="main help">';
echo get_string('updatesessionattend','block_autoattend').$help;
echo '</h2>';

print_table($table);
echo '<br />';
	

$settings = autoattend_get_settings($course->id);
$i = 0;
foreach($settings as $set) {
	$cell   = $i + 3;
	$status = get_string($set->status.'acronym', 'block_autoattend');
	$tabhead[] = "<a href=\"javascript:select_all_radio_in('TD', 'cell c{$cell}', null);\"><u>$status</u></a>";
	$i++;
}

$tabhead[] = get_string('callmethod', 'block_autoattend');
$tabhead[] = get_string('ipaddress', 'block_autoattend');
$tabhead[] = get_string('remarks', 'block_autoattend');
	
$firstname = "<a href=\"updateAttendance.php?course={$course->id}&amp;attsid=$attsid
					&amp;sort=firstname\">".get_string('firstname').'</a>';
$lastname  = "<a href=\"updateAttendance.php?course={$course->id}&amp;attsid=$attsid
					&amp;sort=lastname\">".get_string('lastname').'</a>';

if ($CFG->fullnamedisplay == 'lastname firstname') { // for better view (dlnsk)
	$fullnamehead = "$lastname / $firstname";
} 
else {
	$fullnamehead = "$firstname / $lastname";
}
	

if ($students) {
	unset($table);
	$table->width   = '0%';
	$table->head [] = '#';
	$table->align[] = 'center';
	$table->size [] = '20px';
	
	$table->head [] = '';
	$table->align[] = '';
	$table->size [] = '1px';
		
	$table->head [] = $fullnamehead;
	$table->align[] = 'left';
	$table->size [] = '';
	$table->wrap [2]= 'nowrap';

	foreach ($tabhead as $hd) {
		$table->head [] = $hd;
		$table->align[] = 'center';
		$table->size [] = '20px';
		$table->wrap [] = 'nowrap';
	}

	$i = 0;
	foreach($students as $student) {
		$i++;
		$att = get_record('autoattend_students', 'attsid', $attsid, 'studentid', $student->id);
		$table->data[$student->id][] = $i; 
		$table->data[$student->id][] = print_user_picture($student->id, $course->id, $student->picture, 20, true, true);
		$table->data[$student->id][] = "<a href=\"index.php?course={$course->id}&amp;student={$student->id}\">".
										fullname($student).'</a>';

		if ($att) {
			$status = $att->status;
			$called = $att->called;
		} 
		else {
			$status = 'Y';
			$called = 'D';
		}

		foreach($settings as $set) {
			 $table->data[$student->id][] = '<input name="statusid'.$student->id.
											'" type="radio" value="'.$set->status.'" '.
											($set->status==$status ? 'checked' : '').'>';
		}
		$table->data[$student->id][] = '<input type="hidden" name="prvstatus'.$student->id.'" value="'.$status.'">'.
									   get_string($called.'methodfull', 'block_autoattend');
		$table->data[$student->id][] = $att->ipaddress ? $att->ipaddress : get_string('novalue', 'block_autoattend');
		$table->data[$student->id][] = '<input type="text"  name="remarks'.$student->id.
									   		'" size="20" maxlength="40" value="'.($att ? $att->remarks : '').'">';
	}

	echo '<form name="takeattend" method="post" action="attendaction.php">';
	print_table($table);
	echo '<br />';
	echo '<input type="hidden" name="course" value="'.$course->id.'">';
	echo '<input type="hidden" name="attsid" value="'.$attsid.'">';
    echo '<input type="hidden" name="fromform" value="updateAttendance">';
	echo '<center>';
	echo '<input type="submit" name="esv" value="'.get_string('ok').'">';
	echo '&nbsp;&nbsp;';
	echo '<input type="reset"  name="esv" value="'.get_string('reset').'">';
	echo '&nbsp;&nbsp;';
	echo '<input type="submit" name="esv" value="'.get_string('return', 'block_autoattend').'">';
	echo '</center>';
	echo '</form>';
} 
else {
	print_heading(get_string('nothingtodisplay'), 'center');
}
	 
echo '<br />&nbsp;&nbsp;<strong>'.get_string('status','block_autoattend').':</strong><br />'; 
foreach($settings as $set) {
	$status = get_string($set->status.'acronym', 'block_autoattend');
	$desc   = get_string($set->status.'acronymfull', 'block_autoattend');
	echo '&nbsp;&nbsp;&nbsp;&nbsp;'.$status.' - '.$desc.'<br />';
}

print_simple_box_end();

print_footer($course);
?>	
