<?php // $Id: updateSession.php,v 1.3 2006/02/02 09:28:06 dlnsk Exp $

// Modified by Fumi.Iseki 2007/03/19

require_once('../../config.php');	
require_once($CFG->libdir.'/blocklib.php');
require_once('lib.php');	
require_once('tuis_tools.php');	

$courseid = required_param('course', PARAM_INT);
$attsid	  = required_param('attsid');
$action   = optional_param('action', '', PARAM_ALPHA);
$submit   = optional_param('submit', '');

if (!empty($submit) && $submit==get_string('return', 'block_autoattend')) {
    redirect('index.php?course='.$courseid);
}


if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
    error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $USER->id) ) {
	error(get_string('nosuchuser','block_autoattend'));
}

if (!$att = get_record('autoattend_sessions', 'id', $attsid) ) {
	error(get_string('nosuchsession','block_autoattend'));
}

if ($course->category) {
	print_header(get_string('updatesessioninfo','block_autoattend'). ' ' .get_string('autoattend','block_autoattend') .' ' .
				 get_string('date','block_autoattend'), $course->fullname,
				 "<a href=\"{$CFG->wwwroot}/course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 "<a href=\"index.php?course=$course->id\">".get_string('autoattend','block_autoattend')."</a> -> ".
				 get_string('updatesessioninfo','block_autoattend'),"", "", true, "&nbsp;", navmenu($course));
}
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

print_heading(get_string('update','block_autoattend').'&nbsp;&nbsp;&nbsp;' .
			  get_string('attendforsession','block_autoattend').' :: ' .$course->fullname);


if ($action=="update") {
	$newday     = required_param('newday',	  PARAM_INT);
	$newmonth   = required_param('newmonth',  PARAM_INT);
	$newyear    = required_param('newyear',   PARAM_INT);

	$method     = required_param('newmethod', PARAM_ALPHA);
	$shour	    = required_param('newshour',  PARAM_INT);
	$smin	    = required_param('newsmin',   PARAM_INT);
	$ehour	    = required_param('newehour',  PARAM_INT);
	$emin	    = required_param('newemin',   PARAM_INT);
	$lmin	    = required_param('newlmin',   PARAM_INT);
	$attendkey  = required_param('attendkey');
	$allowip    = required_param('allowip');
	$desc 	    = required_param('desc');
	$randomkey  = optional_param('randomkey','');
	$denysameip = optional_param('denysameip','');

	if (empty($denysameip)) $denysameip = '0';

	$stime	   = $shour*ONE_HOUR + $smin*ONE_MIN;
	$etime	   = $ehour*ONE_HOUR + $emin*ONE_MIN;
	$starttime = $stime + $TIME_OFFSET;				// GMT
	$endtime   = $etime + $TIME_OFFSET;				// GMT
	$latetime  = ($lmin - 1)*MIN_INTVL*ONE_MIN;
	$newdate   = mktime(0, 0, 0, $newmonth, $newday, $newyear);

	$times = $endtime - $starttime;
	if($times <= 0) {
		error(get_string('wrongtimesselected','block_autoattend'),
			  "$CFG->wwwroot/blocks/autoattend/updateSession.php?course=$courseid&amp;attsid=$attsid");
	}

	$count = count_records('autoattend_sessions','courseid', $course->id, 
												 'sessdate', $newdate, 'starttime', $starttime);
	if ($count!=0 and ($newdate!=$att->sessdate or $starttime!=$att->starttime)) {		//duplicate session exists
		error(get_string('sessionalreadyexists','block_autoattend'),
			  "$CFG->wwwroot/blocks/autoattend/updateSession.php?course=".$courseid."&amp;attsid=".$attsid);	
	}
	else {	
		$ntime = time();
		if ($ntime < $newdate+$stime) $state = 'N';
		else if ($ntime>=$newdate+$stime and $ntime<=$newdate+$etime) $state = 'O';
		else $state = 'C';

		$prvstate		   = $att->state;
		$prvmethod		   = $att->method;
		$att->sessdate	   = $newdate;
		$att->timemodified = $ntime;
		$att->method	   = $method;
		$att->state		   = $state;
		$att->starttime	   = $starttime;
		$att->endtime	   = $endtime;
		$att->latetime	   = $latetime;
		$att->allowip	   = $allowip;
		$att->denysameip   = $denysameip;
		$att->description  = $desc;

		if (!$attendkey and $randomkey) {
			$att->attendkey = tuis_randstr(5, true);
		}	
		else {		   
			$att->attendkey = $attendkey;
		}

		$result = update_record('autoattend_sessions', $att);
		if ($result) {
			$loginfo = "=$attsid,$prvmethod,$method,$prvstate,$state";
			add_to_log($course->id, 'autoattend', 'update session', 'index.php?course='.$course->id, $loginfo);
		}
		else {
			error(get_string('sessionupdateerror','block_autoattend'),
			  		"$CFG->wwwroot/blocks/autoattend/updateSession.php?course=".$courseid."&amp;attsid=".$attsid);	
		}
	}	
	//redirect('index.php?course='.$course->id, get_string('sessionupdated','block_autoattend'), 1);
	redirect('updateSession.php?course='.$course->id.'&amp;attsid='.$attsid, 
														get_string('sessionupdated','block_autoattend'), 1);
}


$acheck = '';
$scheck = '';
$mcheck = '';
if	    ($att->method=='A') $acheck = 'checked="checked"';
else if ($att->method=='S') $scheck = 'checked="checked"';
else if ($att->method=='M') $mcheck = 'checked="checked"';

$late_time  = (int)($att->latetime/ONE_MIN);
$late_order = (int)($late_time/5) + 1;

?>


<table align="center" class="generalbox">
	<tr>
		<td class="generalboxcontent">
			<table border="0" align="center" cellpadding="5" cellspacing="0">

				<tr>
	  				<th colspan="2" align="left">
						<h1 class="main help">
							<?php echo get_string('changesession','block_autoattend').
									   helpbutton('changesession', get_string('changesession', 'block_autoattend'), 
												  'block_autoattend', true, false, '', true);?>
						</h1>
					</th>
				</tr>

				<?php
				if ($att->state!='N') {
					?>
					<tr>
						<td align="right" valign="top">
							<strong><?php print_string('callstate','block_autoattend')?>: </strong>
						</td>
						<td>
							<table>
								<tr>
									<?php print_string('Cstatefull','block_autoattend')?>&nbsp;&nbsp;&nbsp;&nbsp;
									<form name="returntoN" method="post" action="returntoN.php">
										<input type="hidden" name="course" value="<? echo $course->id;?>" >
										<input type="hidden" name="attsid" value="<? echo $attsid;?>" >
										<input type="submit" name="submit" 
												value="<?php print_string("returntoN",'block_autoattend');?>">
									</form>
								</tr>
							</table>
						</td>
					</tr>
					<?php
				}
				?>

				<form name="gsess" method="post" action="updateSession.php">
					<tr>
						<td align="right" valign="top">
							<strong><?php print_string('sessionmethod','block_autoattend')?>: </strong>
						</td>
						<td>
							<input type='radio' name='newmethod' value='A' <?php echo $acheck;?> >
								<?php print_string('Amethodfull','block_autoattend')?>&nbsp;&nbsp;
							<input type='radio' name='newmethod' value='S' <?php echo $scheck;?> >
								<?php print_string('Smethodfull','block_autoattend')?>&nbsp;&nbsp;
							<input type='radio' name='newmethod' value='M' <?php echo $mcheck;?> >
								<?php print_string('Mmethodfull','block_autoattend')?>
						</td>
					</tr>

					<tr><td colspan="0"><hr /></td></tr>

					<tr>
		  				<td align="right">
							<strong><?php echo get_string('olddate','block_autoattend');?>: </strong>
						</td>
		  				<td><?php echo strftime(get_string('strftimedate'), $att->sessdate);?></td>
					</tr>
					<tr>
		  				<td align="right">
							<strong><?php echo get_string('newdate','block_autoattend');?>: </strong>
						</td>
		  				<td><?php print_date_selector("newday", "newmonth", "newyear", $att->sessdate);?></td>
					</tr>


					<tr>
		  				<td align="right">
							<strong><?php echo get_string('oldsessionstarttime','block_autoattend');?>: </strong>
						</td>
		  				<td>
							<?php echo strftime(get_string('strftimehourmin', 'block_autoattend'), $att->starttime);?>
						</td>
					</tr>
					<tr>
						<td align="right">
							<strong><?php print_string('newsessionstarttime','block_autoattend')?>: </strong>
						</td>
						<td>
							<?php print_time_selector("newshour", "newsmin", $att->starttime);?>
							<?php print_string('hourmin','block_autoattend')?>
						</td>
					</tr>

					<tr>
		  				<td align="right">
							<strong><?php echo get_string('oldsessionendtime','block_autoattend');?>: </strong>
						</td>
		  				<td><?php echo strftime(get_string('strftimehourmin', 'block_autoattend'), $att->endtime);?></td>
					</tr>
					<tr>
						<td align="right">
							<strong><?php print_string('newsessionendtime','block_autoattend')?>: </strong>
						</td>
						<td>
							<?php print_time_selector("newehour", "newemin", $att->endtime);?>
							<?php print_string('hourmin','block_autoattend')?>
						</td>
					</tr>

					<tr>
		  				<td align="right">
							<strong><?php echo get_string('oldsessionlatetime','block_autoattend');?>: </strong>
						</td>
		  				<td><?php echo $late_time.' '.get_string('minute', 'block_autoattend');?></td>
					</tr>
					<tr>
						<td align="right">
							<strong><?php print_string('newsessionlatetime','block_autoattend')?>: </strong>
						</td>
						<td><?php choose_from_menu(array(1=> 0, 5,10,15,20,25,30,35,40,45,50,55,60,
															65,70,75,80,85,90,95,100,105,110,115,120),
															'newlmin', $late_order, false);
								  echo ' '.get_string('minute','block_autoattend');?>
						</td>
					</tr>
				 
					<?php
					if ($att->method=='S') { ?>
						<tr>
							 <td align="right">
								  <strong><?php echo get_string('attendkey','block_autoattend');?>:</strong>
						 	</td>
						 	<td>
								<input type="text" name="attendkey" size="40" maxlength="30"
																	value="<?php echo $att->attendkey;?>">
								<input type="checkbox" name="randomkey" value="1" 
														<?php echo ($att->attendkey ? '': 'checked') ?> >

								<?php print_string('setrandomkey','block_autoattend');?>
							</td>
						</tr>
						<?php
					}
					else { ?>
						<input type="hidden" name="attendkey" size="40" maxlength="30" 
														value="<?php echo $att->attendkey;?>">
						<input type="hidden" name="randomkey" value=$randomkey>
						<?php
					} ?>


					<?php
					if ($att->method=='A' or $att->method=='S') { ?>
						<tr>
							<td align="right">
								<strong><?php echo get_string('sessionallowip','block_autoattend');?>:</strong>
							</td>
							<td>
								<input type="text" name="allowip" size="60" maxlength="100" 
														value="<?php echo $att->allowip;?>">
							</td>
						</tr>
						<?php
					}
					else { ?>
						<input type="hidden" name="allowip" size="60" maxlength="100" 
														value="<?php echo $att->allowip;?>">
						<?php
					} ?>

					<?php
					if ($att->method=='S') { ?>
						<tr>
							<td align="right">
								<strong><?php echo get_string('denysameip','block_autoattend');?>:</strong>
							</td>
							<td>
								<input type="checkbox" name="denysameip" value="1" 
											<?php echo ($att->denysameip=='0' ? '': 'checked') ?> >
							</td>
						</tr>
						<?php
					}
					else { ?>
						<input type="hidden" name="denysameip" value="<?php echo $att->denysameip;?>" >
						<?php
					} ?>

					<tr>
		  				<td align="right">
							<strong><?php echo get_string('description','block_autoattend');?>:</strong>
						</td>
		  				<td>
							<input type="text" name="desc" size="60" maxlength="100" 
														value="<?php echo $att->description;?>">
						</td>
					</tr>
	
					<tr>
		  				<td>&nbsp;</td>
		  				<td>
							<input type="hidden" name="course" value="<?php echo $courseid?>">
							<input type="hidden" name="attsid" value="<?php echo $attsid;?>">
							<input type="hidden" name="action" value="update">
							<input type="submit" name="submit" value="<?php print_string("update",'block_autoattend');?>">
							&nbsp;
							<input type="reset"  name="submit" value="<?php print_string("reset");?>">
							&nbsp;
							<input type="submit" name="submit" value="<?php print_string("return",'block_autoattend');?>">
		  				</td>
					</tr>

					<tr>
		  				<td colspan="2">&nbsp;</td>
					</tr>
				</form>

  			</table>
		</td>
  	</tr>
</table>

<?php
	print_footer($course);
?>
