<?php 
// $Id: updateUser.php,v 1.0 2007/03/20 Fumi.Iseki $
// Modified from updateAttendance.php at attendance block

require_once('../../config.php');	
require_once($CFG->libdir.'/blocklib.php');
require_once('lib.php');

$courseid = required_param('course', PARAM_INT);
$userid   = required_param('userid', PARAM_INT);

if (! $course = get_record('course', 'id', $courseid)) {
	error(get_string('courseidwrong','block_autoattend'));
}

require_login($course->id);

if (!isteacher($course->id)) {
	error(get_string('notaccessstudent','block_autoattend'));
}

if (! $user = get_record("user", "id", $userid) ) {
	error(get_string('nosuchuser','block_autoattend'));
}
	

/// Print headers
if ($course->category) {
	print_header(get_string('updateuserattend','block_autoattend').' '.
				 get_string('autoattend','block_autoattend'), $course->fullname,
				 "<a href=\"{$CFG->wwwroot}/course/view.php?id=$course->id\">$course->shortname</a> -> ".
				 "<a href=\"index.php?course=$course->id\">".get_string('autoattend','block_autoattend')."</a> -> ".
				 get_string('updateuserattend','block_autoattend'),"", "", true, "&nbsp;", navmenu($course));
} 
else {
	print_header("$course->shortname: ".get_string('autoattend','block_autoattend'), $course->fullname,
				 get_string('autoattend','block_autoattend'), "", "", true, "&nbsp;", navmenu($course));
}

echo "<script type=\"text/javascript\">
<!--
function select_all_radio_in(elTagName, elClass, elId) {
	var inputs = document.getElementsByTagName('INPUT');
	inputs = filterByParent(inputs, function(el) {return findParentNode(el, elTagName, elClass, elId);});
	for(var i = 0; i < inputs.length; ++i) {
		if(inputs[i].type == 'radio') {
			inputs[i].checked = 'checked';
		}
	}
}
//-->
</script>";
	
$summary = autoattend_get_usersummary($course->id, $user->id);
$attitems = $summary['attitems'];
if (!$attitems) {
	error(get_string('reqinfomiss', 'block_autoattend'), "index.php?course=".$courseid);
}


// Title
print_heading(get_string('update','block_autoattend').'&nbsp;&nbsp;&nbsp;' .
				  get_string('attendforuser','block_autoattend').' :: ' .$course->fullname);


// Sub Title 
$complete = $summary['complete'];
$settings = $summary['settings'];

$useratt = '';
foreach($settings as $set) {                                 
	$desc = get_string($set->status.'acronymfull', 'block_autoattend');
	$useratt .= $desc.':<strong>'.$summary[$set->status].'</strong>'.'&nbsp;&nbsp;';
} 
//$desc = get_string('Yacronymfull', 'block_autoattend');
//$useratt .= $desc.':<strong>'.$summary['Y'].'</strong>'.'&nbsp;&nbsp;';

$percent  = $summary['percent'].'%';
$grade    = $summary['grade'];    
$maxgrade = $summary['maxgrade'];    
$table->data[][] = 
		print_user_picture($student->id, $course->id, $user->picture, 40, true, true).'<br />'.
		"<a href=\"index.php?course={$course->id}&amp;student={$user->id}\">".fullname($user).'</a>'.
		'&nbsp;&nbsp;'.
        get_string('sessionscompleted','block_autoattend').":<strong>$complete</strong>".
		'&nbsp;&nbsp;'.$useratt.
		get_string('attendpercent','block_autoattend').":<strong>$percent</strong>".
		'&nbsp;&nbsp;'.
		get_string('attendgrade',  'block_autoattend').":<strong>$grade</strong>/$maxgrade";


$help = helpbutton ('updateuserattend', get_string('updateuserattend','block_autoattend'), 'block_autoattend', true, false, '', true);
print_simple_box_start('center', '98%', '', 5, 'generalbox', 'notice');

echo '<h2 class="main help">';
echo get_string('updateuserattend','block_autoattend').$help;
echo '</h2>';

print_table($table);
echo '<br />';
	

// Display Attendance Table
$i = 0;
foreach($settings as $set) {
    $cell   = $i + 5;
    $status = get_string($set->status.'acronym', 'block_autoattend');
    $tabhead[] = "<a href=\"javascript:select_all_radio_in('TD', 'cell c{$cell}', null);\"><u>$status</u></a>";
    $i++;
}

if ($attitems) {
	unset($table);
	$table->width   = '0%';
	$table->head [] = '#';
	$table->align[] = 'center';
	$table->size [] = '20px';
	
	$table->head [] = get_string('sessiondate', 'block_autoattend');
	$table->align[] = 'center';
	$table->size [] = '';

	$table->head [] = get_string('starttime', 'block_autoattend');
	$table->align[] = 'center';
	$table->size [] = '';

	$table->head [] = get_string('endtime', 'block_autoattend');
	$table->align[] = 'center';
	$table->size [] = '';

	$table->head [] = get_string('description', 'block_autoattend');
	$table->align[] = 'left';
	$table->size [] = '';

	foreach ($tabhead as $hd) {
		$table->head [] = $hd;
		$table->align[] = 'center';
		$table->size [] = '20px';
	}

	$table->head [] = get_string('callmethod', 'block_autoattend');
	$table->align[] = 'center';
	$table->size [] = '';

	$table->head [] = get_string('ipaddress', 'block_autoattend');
	$table->align[] = 'center';
	$table->size [] = '';

	$table->head [] = get_string('remarks','block_autoattend');
	$table->align[] = 'left';
	$table->size [] = '';

	$i = 0;
	foreach($attitems as $att) {
		$i++;
		$table->data[$att->attsid][] = $i; 
		$table->data[$att->attsid][] = strftime(get_string('strftimedmyw',    'block_autoattend'), $att->sessdate);
		$table->data[$att->attsid][] = strftime(get_string('strftimehourmin', 'block_autoattend'), $att->starttime);
		$table->data[$att->attsid][] = strftime(get_string('strftimehourmin', 'block_autoattend'), $att->endtime);
		$table->data[$att->attsid][] = ($att->description ? $att->description : 
														get_string('nodescription', 'block_autoattend'));
		foreach($settings as $set) {
			 $table->data[$att->attsid][] = '<input name="statusid'.$att->attsid.
						'" type="radio" value="'.$set->status.'" '.($set->status==$att->status ? 'checked' : '').'>';
		}
		$table->data[$att->attsid][] = '<input type="hidden" name="prvstatus'.$att->attsid.'" value="'.$att->status.'">'.
														get_string($att->called.'methodfull', 'block_autoattend');
		$table->data[$att->attsid][] = $att->ipaddress ? $att->ipaddress : get_string('novalue','block_autoattend');
		$table->data[$att->attsid][] = '<input type="text" name="remarks'.$att->attsid.
												'" size="20" maxlength="40" value="'.($att ? $att->remarks : '').'">';
	}

	echo '<form name="takeautoattend" method="post" action="attendaction.php">';
	print_table($table);
	echo '<br />';
	echo '<input type="hidden" name="course" value="'.$course->id.'">';
	echo '<input type="hidden" name="userid" value="'.$user->id.'">';
	echo '<input type="hidden" name="fromform" value="updateUser">';
	echo '<center>';
	echo '<input type="submit" name="esv" value="'.get_string('ok').'">';
	echo '&nbsp;&nbsp;';
	echo '<input type="reset"  name="esv" value="'.get_string('reset').'">';
    echo '&nbsp;&nbsp;';
    echo '<input type="submit" name="esv" value="'.get_string('return','block_autoattend').'">';
	echo '</center>';
	echo '</form>';
} 
else {
	print_heading(get_string('nothingtodisplay'), 'center');
}
 
echo '<br />&nbsp;&nbsp;<strong>'.get_string('status','block_autoattend').':</strong><br />';
foreach($settings as $set) {
    $status = get_string($set->status.'acronym', 'block_autoattend');
    $desc   = get_string($set->status.'acronymfull', 'block_autoattend');
    echo '&nbsp;&nbsp;&nbsp;&nbsp;'.$status.' - '.$desc.'<br />';
}

print_simple_box_end();

print_footer($course);
?>	
