<?PHP // $Id: index.php,v 1.2 2006/02/01 12:00:47 dlnsk Exp $

/// This page lists all the instances of autoattendmod in a particular course
/// Replace autoattendmod with the name of your module

require_once("../../config.php");
require_once("lib.php");

$id = required_param('id', PARAM_INT);   // course


if (! $course = get_record("course", "id", $id)) {
	error("Course ID is incorrect");
}

require_login($course->id);

add_to_log($course->id, "autoattendmod", "view all", "index.php?id=$course->id", "");


/// Get all required strings
$strautoattendmods = get_string("modulenameplural", "autoattendmod");
$strautoattendmod  = get_string("modulename", "autoattendmod");


/// Print the header
if ($course->category) {
	$navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
}

print_header("$course->shortname: $strautoattendmods", "$course->fullname", 
						"$navigation $strautoattendmods", "", "", true, "", navmenu($course));

/// Get all the appropriate data
if (! $autoattendmods = get_all_instances_in_course("autoattendmod", $course)) {
	notice("There are no autoattendmods", "../../course/view.php?id=$course->id");
	die;
}

/// Print the list of instances (your module will probably extend this)
$timenow  = time();
$strname  = get_string("name");
$strweek  = get_string("week");
$strtopic = get_string("topic");

if ($course->format == "weeks") {
	$table->head  = array ($strweek, $strname);
	$table->align = array ("CENTER", "LEFT");
} 
else if ($course->format == "topics") {
	$table->head  = array ($strtopic, $strname);
	$table->align = array ("CENTER", "LEFT", "LEFT", "LEFT");
} 
else {
	$table->head  = array ($strname);
	$table->align = array ("LEFT", "LEFT", "LEFT");
}

foreach ($autoattendmods as $autoattendmod) {
	if (!$autoattendmod->visible) {
		//Show dimmed if the mod is hidden
		$link = "<A class=\"dimmed\" HREF=\"view.php?id=$autoattendmod->coursemodule\">$autoattendmod->name</A>";
	} 
	else {
		//Show normal if the mod is visible
		$link = "<A HREF=\"view.php?id=$autoattendmod->coursemodule\">$autoattendmod->name</A>";
	}

	if ($course->format == "weeks" or $course->format == "topics") {
		$table->data[] = array ($autoattendmod->section, $link);
	} else {
		$table->data[] = array ($link);
	}
}

echo "<br />";

print_table($table);

/// Finish the page
print_footer($course);

?>
