<?PHP  //shows an analysed view of feedback

   require_once("../../config.php");
   require_once("lib.php");
 
   $id = required_param('id', PARAM_INT);  //the POST dominated the GET
   $courseid = optional_param('courseid', false, PARAM_INT);
   
   if ($id) {
      if (! $cm = get_record("course_modules", "id", $id)) {
         error("Course Module ID was incorrect");
      }
    
      if (! $course = get_record("course", "id", $cm->course)) {
         error("Course is misconfigured");
      }
    
      if (! $feedback = get_record("feedback", "id", $cm->instance)) {
         error("Course module is incorrect");
      }
   }

   require_login($course->id);
   
   if( !( (intval($feedback->publish_stats) == 1) || isteacher($course->id) || isadmin())) {
      error(get_string('error'));
   }
   
/// Print the page header


   $strfeedbacks = get_string("modulenameplural", "feedback");
   $strfeedback  = get_string("modulename", "feedback");
   $navigation = '';

   $feedbackindex = "<a href=\"index.php?id=$course->id\">$strfeedbacks</a> ->";
   if ($course->category) {
      $navigation = "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> ->";
   }else if ($courseid > 0 AND $courseid != SITEID) {
      $usercourse = get_record('course', 'id', $courseid);
      $navigation = "<a href=\"../../course/view.php?id=$usercourse->id\">$usercourse->shortname</a> ->";
      $feedbackindex = '';
   }

   print_header("$course->shortname: $feedback->name", "$course->fullname",
                "$navigation $feedbackindex $feedback->name", 
                "", "", true, update_module_button($cm->id, $course->id, $strfeedback), 
                navmenu($course, $cm));

   print_heading($feedback->name);
      
   print_continue('view.php?id='.$id.'&courseid='.$courseid);
   
   //analysierte Items ausgeben
   print_simple_box_start("center", '80%');

   if( isteacher($course->id) || isadmin()) {
      //button "export to excel"
      echo '<div align="center"><form action="analysis_to_excel.php" method="get">';
      echo '<button type="submit">'. get_string('export_to_excel', 'feedback') . '</button>';
      echo '<input type="hidden" name="sesskey" value="' . $USER->sesskey . '" />';
      echo '<input type="hidden" name="id" value="'.$id.'" />';
      echo '</form></div>';
   }
   
   //get the groupid
   //lstgroupid is the choosen id
   $mygroupid = $SESSION->lstgroupid;

   //get completed feedbacks
   $completedscount = feedback_get_completeds_group_count($feedback, $mygroupid);
   
   //show the count
   echo '<b>'.get_string('completed_feedbacks', 'feedback').': '.$completedscount. '</b><br />';
   
   // get the items of the feedback
   $items = get_records_select('feedback_item', 'feedback = '. $feedback->id . ' AND hasvalue = 1', 'position');
   //show the count
   if(is_array($items)){
   	echo '<b>'.get_string('questions', 'feedback').': ' .sizeof($items). ' </b><hr />';
   } else {
	$items=array();
   }

   echo '<div align="center"><table width="80%" cellpadding="10"><tr><td>';
   $itemnr = 0;
   //print the items in an analysed form
   foreach($items as $item) {
      echo '<table width="100%" class="generalbox">';	
      $feedback_print_analysed_func = 'feedback_print_analysed_'.$item->typ;
      $itemnr = $feedback_print_analysed_func($item, $itemnr, $mygroupid);
      echo '</table>';
   }
   echo '</td></tr></table></div>';
   print_simple_box_end();
   
   print_footer($course);

?>
