<?php

   require_once("../../config.php");
   require_once("lib.php");
   require_once("$CFG->libdir/tablelib.php");
   
   $id = required_param('id', PARAM_INT); // Course Module ID, or
   $searchcourse = optional_param('searchcourse', '', PARAM_ALPHANUM);
   $coursefilter = optional_param('coursefilter', '', PARAM_INT);
   $courseid = optional_param('courseid', false, PARAM_INT);
   
   if ($id) {
      if (! $cm = get_record("course_modules", "id", $id)) {
         error("Course Module ID was incorrect");
      }
   
      if (! $course = get_record("course", "id", $cm->course)) {
         error("Course is misconfigured");
      }
      
      if (! $feedback = get_record("feedback", "id", $cm->instance)) {
         error("Course module is incorrect");
      }
   }
   
   require_login($course->id);
   
   if (!isteacher($course->id)) {
    error ('Only teachers are allowed to access this page');
   }
   
   if ($coursefilter) {
      $map->feedbackid = $feedback->id;
      $map->courseid = $coursefilter;
      // insert a map only if it does exists yet
      $sql = "select id, feedbackid from {$CFG->prefix}feedback_sitecourse_map where feedbackid = $map->feedbackid and courseid = $map->courseid";
      if (!get_records_sql($sql) && !insert_record('feedback_sitecourse_map', $map)) {
         error("Database problem, unable to map feedback = $feedback->id to course = $course->id");
      }
   }
   
   /// Print the page header
   $strfeedbacks = get_string("modulenameplural", "feedback");
   $strfeedback = get_string("modulename", "feedback");
   $navigation = '';
   
   $feedbackindex = "<a href=\"index.php?id=$course->id\">$strfeedbacks</a> ->";
   if ($course->category) {
      $navigation = "<a href=\"../../course/view.php?id=$course->id\">$course->shortname</a> ->";
   }else if ($courseid > 0 AND $courseid != SITEID) {
      $usercourse = get_record('course', 'id', $courseid);
      $navigation = "<a href=\"../../course/view.php?id=$usercourse->id\">$usercourse->shortname</a> ->";
      $feedbackindex = '';
   }
   
   print_header("$course->shortname: $feedback->name", "$course->fullname",
            "$navigation $feedbackindex <a href=\"view.php?id=$id\">$feedback->name</a> -> ".get_string('mapcourses', 'feedback'),
            "", "", true, update_module_button($cm->id, $course->id, $strfeedback), navmenu($course, $cm));
   
   print_simple_box(get_string('mapcourseinfo', 'feedback'), 'center', '80%');
   print_simple_box_start('center', '70%');
   echo '<form method="get">';
   echo '<input type="hidden" name="id" value="'.$id.'" />';
   
   $sql = "select c.id, c.shortname from {$CFG->prefix}course c
         where
            c.shortname ".sql_ilike()." '%{$searchcourse}%'
         OR c.fullname ".sql_ilike()." '%{$searchcourse}%'";
   
   if (($courses = get_records_sql_menu($sql)) && !empty($searchcourse)) {
      echo ' ' . get_string('courses') . ': ';
      choose_from_menu ($courses, 'coursefilter', $coursefilter, 'choose');
      echo '<input type="submit" value="'.get_string('mapcourse', 'feedback').'"/>';
      helpbutton('mapcourses', '', 'feedback', true, true);
      echo '<input type="button" value="'.get_string('searchagain').'" onclick="document.location=\'mapcourse.php?id='.$id.'\'"/>';
      echo '<input type="hidden" name="searchcourse" value="'.$searchcourse.'"/>';
      echo '<input type="hidden" name="feedbackid" value="'.$feedback->id.'"/>';
      helpbutton('searchcourses', '', 'feedback', true, true);
   } else {
      echo '<input type="text" name="searchcourse" value="'.$searchcourse.'"/> <input type="submit" value="'.get_string('searchcourses').'"/>';
      helpbutton('searchcourses', '', 'feedback', true, true);
   }
   
   echo '</form>';
   
   // $sql = "select f.id, f.courseid, c.fullname
            // from {$CFG->prefix}feedback_sitecourse_map f, {$CFG->prefix}course c
            // where c.id = f.courseid
            // and f.feedbackid = $feedback->id
            // order by c.fullname";
   
   // if ($coursemap = get_records_sql($sql)) {
   if($coursemap = feedback_get_courses_from_sitecourse_map($feedback->id)) {
      $table = new flexible_table('coursemaps');
      $table->define_columns( array('course'));
      $table->define_headers( array(get_string('mappedcourses', 'feedback')));
   
      $table->setup();
   
      foreach ($coursemap as $cmap) {
         $table->add_data(array("<a href=\"unmapcourse.php?id=$cmap->id&return_url=$ME?id=$id\"><img src=\"{$CFG->pixpath}/t/delete.gif\" alt=\"Delete\" /></a> ".'('.$cmap->shortname.') '.$cmap->fullname));
      }
   
      $table->print_html();
   } else {
      echo '<h3>'.get_string('mapcoursenone', 'feedback').'</h3>';
   }
   
   
   print_simple_box_end();
   
   print_footer($course);

?>