<?php // fukuyama: forum attachment download
    require_once("../../config.php");
    require_once("lib.php");

    $f      = required_param('f', PARAM_INT);         // Forum ID
    if (!$discussions = forum_get_discussions($f)) {
        die (get_string('nodiscussions', 'forum'));
    }

    $args = array();
    foreach ($discussions as $discussion) {
        if (! $discussion = get_record("forum_discussions", "id", $discussion->discussion)) {
            error("Discussion ID was incorrect or no longer exists");
        }

        if (! $course = get_record("course", "id", $discussion->course)) {
            error("Course ID is incorrect - discussion is faulty");
        }

        if (! $forum = get_record("forum", "id", $discussion->forum)) {
            notify("Bad forum ID stored in this discussion");
        }

        if ($forum->type == "teacher") {
            require_login($course->id);

            if (!isteacher($course->id)) {
                error("You must be a $course->teacher to view this forum");
            }
        } elseif ($forum->type == "news") {
            if (!((isadmin() and !empty($CFG->admineditalways))
                        || isteacher($course->id)
                        || (!empty($USER->id) && $USER->id == $discussion->userid)
                        || (($discussion->timestart == 0 || $discussion->timestart <= time())
                            && ($discussion->timeend == 0 || $discussion->timeend > time())))) {
                error('Discussion ID was incorrect or no longer exists', "$CFG->wwwroot/mod/forum/view.php?f=$forum->id");
            }
            require_login($course->id);
        } else {
            if (! $cm = get_coursemodule_from_instance("forum", $discussion->forum, $course->id)) {
                error("Course Module ID was incorrect");
            }
            require_course_login($course, false, $cm);
        }

        $logparameters = "d=$discussion->id";


        unset($SESSION->fromdiscussion);

        $parent = $discussion->firstpost;

        if (!forum_user_can_view_post($parent, $course, $cm, $forum, $discussion)) {
            error('You do not have permissions to view this post', "$CFG->wwwroot/mod/forum/view.php?f=$forum->id");
        }

        if (! $post = forum_get_post_full($parent)) {
            error("Discussion no longer exists", "$CFG->wwwroot/mod/forum/view.php?f=$forum->id");
        }
    
        $args[] = array($course, $forum, $discussion, $post, $displaymode, $canreply);

    }

    download_attachment_all($args);

?>
