<?php //$Id: backuplib.php,v 1.5 2004/09/12 21:43:56 gustav_delius Exp $
    //This php script contains all the stuff to backup/restore
    //mieattendance mods

    //This is the "graphical" structure of the mieattendance mod:
    //
    //                    mieattendance                                      
    //                    (CL,pk->id)
    //                        |
    //                        |
    //                        |
    //                  mieattendance_roll 
    //               (UL,pk->id, fk->dayid)     
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    function mieattendance_backup_mods($bf,$preferences) {
        
        global $CFG;

        $status = true;

        //Iterate over mieattendance table
        $mieattendances = get_records ('mieattendance','course',$preferences->backup_course,'id');
        if ($mieattendances) {
            foreach ($mieattendances as $mieattendance) {
                //Start mod
                fwrite ($bf,start_tag('MOD',3,true));
                //Print choice data
                fwrite ($bf,full_tag('ID',4,false,$mieattendance->id));
                fwrite ($bf,full_tag('MODTYPE',4,false,'mieattendance'));
                fwrite ($bf,full_tag('NAME',4,false,$mieattendance->name));
                fwrite ($bf,full_tag('DAY',4,false,$mieattendance->day));
                fwrite ($bf,full_tag('HOURS',4,false,$mieattendance->hours));
                fwrite ($bf,full_tag('ROLL',4,false,$mieattendance->roll));
                fwrite ($bf,full_tag('NOTES',4,false,$mieattendance->notes));
                fwrite ($bf,full_tag('TIMEMODIFIED',4,false,$mieattendance->timemodified));
                fwrite ($bf,full_tag('DYNSECTION',4,false,$mieattendance->dynsection));
                fwrite ($bf,full_tag('EDITED',4,false,$mieattendance->edited));
                fwrite ($bf,full_tag('AUTOATTEND',4,false,$mieattendance->autoattend));
                //if we've selected to backup users info, then execute backup_mieattendance_roll
                if ($preferences->mods['mieattendance']->userinfo) {
                    $status = backup_mieattendance_roll($bf,$preferences,$mieattendance->id);
                }
                //End mod
                $status =fwrite ($bf,end_tag('MOD',3,true));
            }
        }
        return $status;
    }

    //Backup mieattendance_roll contents (executed from mieattendance_backup_mods)
    function backup_mieattendance_roll ($bf,$preferences,$mieattendance) {

        global $CFG;

        $status = true;

        $mieattendance_rolls = get_records('mieattendance_roll','dayid',$mieattendance,'id');
        //If there is rolls
        if ($mieattendance_rolls) {
            //Write start tag
            $status =fwrite ($bf,start_tag('ROLLS',4,true));
            //Iterate over each roll
            foreach ($mieattendance_rolls as $att_rol) {
                //Start roll
                $status =fwrite ($bf,start_tag('ROLL',5,true));
                //Print roll contents
                fwrite ($bf,full_tag('ID',6,false,$att_rol->id));
                fwrite ($bf,full_tag('USERID',6,false,$att_rol->userid));
                fwrite ($bf,full_tag('HOUR',6,false,$att_rol->hour));
                fwrite ($bf,full_tag('STATUS',6,false,$att_rol->status));
                fwrite ($bf,full_tag('NOTES',6,false,$att_rol->notes));
                //End roll
                $status =fwrite ($bf,end_tag('ROLL',5,true));
            }
            //Write end tag
            $status =fwrite ($bf,end_tag('ROLLS',4,true));
        }
        return $status;
    }
   
   ////Return an array of info (name,value)
   function mieattendance_check_backup_mods($course,$user_data=false,$backup_unique_code) {
        //First the course data
        $info[0][0] = get_string('modulenameplural','mieattendance');
        if ($ids = mieattendance_ids ($course)) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        //Now, if requested, the user_data
        if ($user_data) {
            $info[1][0] = get_string('entries');
            if ($ids = mieattendance_roll_ids_by_course ($course)) {
                $info[1][1] = count($ids);
            } else {
                $info[1][1] = 0;
            }
        }
        return $info;
    }






    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of mieattendances id
    function mieattendance_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT a.id, a.course
                                 FROM {$CFG->prefix}mieattendance a
                                 WHERE a.course = '$course'");
    }
   
    //Returns an array of mieattendance_rolls id
    function mieattendance_roll_ids_by_course ($course) {

        global $CFG;

        return get_records_sql ("SELECT r.id , r.dayid
                                 FROM {$CFG->prefix}mieattendance_roll r,
                                      {$CFG->prefix}mieattendance a
                                 WHERE a.course = '$course' AND
                                       r.dayid = a.id");
    }
?>
