<?php

class calendar {

    var $wfrom;
    var $beforeandafterday;

    var $link = array();
    var $style = array();

    var $kind;
    var $bgcolor;
    var $week;
    var $holiday;
    var $holiday_name;

    //  constructor
    function calendar($arg1 = 0, $arg2 = 0) {
        
        // start weekday.
        $this->wfrom = $arg1;
        
        // Do you display a date except this month? (0 - not display / 1 -  display )
        $this->beforeandafterday = $arg2;
        
        // style
        $this->style["table"] = " class=\"calendarmonth\"";
        $this->style["th"] = " class=\"header\"";
        $this->style["tr"] = "";
        $this->style["td"] = "";
        $this->style["tf"] = "";

        // weekday color (0-weekday, 1-satday, 2-sunday or holiday, 3-weekday except this month, 4-On that day
        $this->bgcolor = array("", "", "", "", "");
        $this->kind = array(2, 0, 0, 0, 0, 0, 1);

        // name of a day
        $this->week = array(get_string('sunday','mieattendance'), get_string('monday','mieattendance'), get_string('tuesday','mieattendance'),
                                       get_string('wednesday','mieattendance'), get_string('thursday','mieattendance'), get_string('friday','mieattendance'),
                                       get_string('saturday','mieattendance'));
    }

    function show_calendar($year, $month, $day = 0) {

        // I acquire numerical value to assume a start of the moon
        $from = 1;
        while(date("w", mktime(0, 0, 0, $month, $from, $year)) <> $this->wfrom) {
            $from--;
        }

        list($ny, $nm, $nj) = explode("-", date("Y-n-j", mktime(0, 0, 0, $month+1, 1, $year)));
        list($by, $bm, $bj) = explode("-", date("Y-n-j", mktime(0, 0, 0, $month-1, 1, $year)));

        // today.
        $arr = getdate();
        $summary = get_string('calendar','mieattendance');
        echo '<size="2"><table'.$this->style["table"]." summary=\"$summary\">\n";
        echo "<tr>\n";
        echo "<th".$this->style["th"]." colspan=\"7\">\n";
        $year_t = get_string('numyears','mieattendance',$year);
        $month_t = get_string('nummonth','mieattendance',$month);
        echo "$year_t $month_t";
        echo "</th>\n";
        echo "</tr>\n";
        
        // vew week.
        echo "<tr".$this->style["tr"]." style=\"text-align:center\">\n";
        for($i = 0; $i < 7; $i++) {
            $wk = ($this->wfrom + $i) % 7;
            echo "<td".$this->style["td"]." bgcolor=\"".$this->bgcolor[$this->kind[$wk]]."\">".$this->week[$wk]."</td>\n";
        }
        echo "</tr>\n";
        $tday = $from;
        $mday = date("t", mktime(0, 0, 0, $month, 1, $year));
        while($tday <= $mday) {

        echo "<tr".$this->style["tr"].">\n";

        for($i = 0; $i < 7; $i++) {
            $fstyle = "";
            $wk = ($this->wfrom + $i) % 7;
            $bgcolor = $this->bgcolor[$this->kind[$wk]];

            if($tday >= 1 && $tday <= $mday) {
                if($arr["year"] == $year && $arr["mon"] == $month && $arr["mday"] == $tday) {
                    $fstyle = " style=\"font-weight:bold\"";
                    $bgcolor = $this->bgcolor[4];
                } else if ($this->holiday[$tday] == 1) {
                    $bgcolor = $this->bgcolor[2];
                }
            } else {
                if($wk > 0 && $wk < 6) $bgcolor = $this->bgcolor[3];
            }

            echo "<td".$this->style["td"]." bgcolor=\"".$bgcolor."\"".$fstyle.">\n";
            list($lyear, $lmonth, $lday) = explode("-", date("Y-n-j", mktime(0, 0, 0, $month, $tday, $year)));

            if(($tday >= 1 && $tday <= $mday) || $this->beforeandafterday) {
                if(isset($this->link[$tday])) {
                    echo "<a href=\"".$this->link[$tday]["url"]."\" title=\"".$this->link[$tday]["title"]."\">".$lday."</a>"; 
                } else {
                    echo $lday;
                }
                echo "</td>\n";
            } else {
                echo "&nbsp;";
            }
            $tday++;
        } 
        echo '</tr>';    
        }
        echo '</table></font>';
    }

    function set_link($day, $url, $title) {
        $this->link[$day]["url"] = $url;
        $this->link[$day]["title"] = $title;
    }

    function clear_link() {
        $this->link = array();
    }

    function set_holiday($year, $month) {
        $day = 1;
        while(date("w",mktime(0 ,0 ,0 , $month, $day, $year)) <> 1) {
            $day++;
        }

        switch($month){
        case 1:
            // New first day (1/1)
            $this->holiday[1] = 1;
            $this->holiday_name[1] = "ö"; 

            // ͤ
            if($year < 2000) {
            $this->holiday[15] = 1;
            $this->holiday_name[15] = "ͤ"; 
            } else {
            $this->holiday[$day+7] = 1;
            $this->holiday_name[$day+7] = "ͤ"; 
            }
            break;

        case 2:
            // ǰ
            $this->holiday[11] = 1;
            $this->holiday_name[11] = "ǰ"; 
            break;

        case 3:
            // ʬ
            if($year > 1979 && $year < 2100) {
            $tmp = floor(20.8431+($year-1980)*0.242194-floor(($year-1980)/4));
            $this->holiday[$tmp] = 1;
            $this->holiday_name[$tmp] = "ʬ"; 
            }
            break;

        case 4:
            // ŷ or ߤɤ
            $this->holiday[29] = 1;
            if($year < 1989) {
            $this->holiday_name[29] = "ŷ";
            } else {
            $this->holiday_name[29] = "ߤɤ";
            } 
            break;

        case 5:
            // ˡǰ
            $this->holiday[3] = 1;
            $this->holiday_name[3] = "ˡǰ";

            // Ҥɤ
            $this->holiday[5] = 1;
            $this->holiday_name[5] = "Ҷ";
            break;

        case 7:
            // 
            if($year > 2002) {
                $this->holiday[$day+14] = 1;
                $this->holiday_name[$day+14] = "";
            } elseif($year > 1994) {
                $this->holiday[21] = 1;
                $this->holiday_name[21] = "";
            }
            break;

        case 9:
            // Ϸ
            if($year < 2003) {
                $this->holiday[15] = 1;
                $this->holiday_name[15] = "Ϸ";
            } else {
                $this->holiday[$day+14] = 1;
                $this->holiday_name[$day+14] = "Ϸ";
            }

            // ʬ
            if($year > 1979 && $year < 2100) {
                $tmp = floor(23.2488+($year-1980)*0.242194-floor(($year-1980)/4));
                $this->holiday[$tmp] = 1;
                $this->holiday_name[$tmp] = "ʬ";
            }
            break;

        case 10;
            // ΰ
            if($year < 2000) {
                $this->holiday[10] = 1;
                $this->holiday_name[10] = "ΰ";
            } else {
                $this->holiday[$day+7] = 1;
                $this->holiday_name[$day+7] = "ΰ";
            }
            break;

        case 11:
            // ʸ
            $this->holiday[3] = 1;
            $this->holiday_name[3] = "ʸ";
            
            // ϫդ
            $this->holiday[23] = 1;
            $this->holiday_name[23] = "ϫդ";
            break;

        case 12:        
            // ŷ
            if($year > 1988) {
                $this->holiday[23] = 1;
                $this->holiday_name[23] = "ŷ";
            }
            break;    
        }

        // ̱ε򥻥å
        if($year > 1985) {
            for($i = 1;$i < date("t",mktime(0,0,0,$month,1,$year));$i++) {
                if(isset($this->holiday[$i]) && isset($this->holiday[$i+2])) {
                    $this->holiday[$i+1] = 1;
                    $this->holiday_name[$i+1] = "̱ε";
                    $i = $i + 3;
                }
            }
        }
        
        // ؤ򥻥å
        $sday = $day - 1;
        if($sday == 0) $sday = 7;
            for($i = $sday;$i < date("t",mktime(0, 0, 0, $month, 1, $year));$i = $i + 7) {
                if(isset($this->holiday[$i])) {
                    $this->holiday[$i+1] = 1;
                    $this->holiday_name[$i+1] = "ص";
                }
            }
        }
    }

?>
