<?php
//================================================
// Dwonload EXCEL format.
//
    if ( isset($encode) &&  isset($excel) ) {
        require_once("$CFG->libdir/excel/Worksheet.php");
        require_once("$CFG->libdir/excel/Workbook.php");

        // HTTP headers
        header("Content-type: application/vnd.ms-excel");
        $filename = get_string('modulename','mieattendance').'_'.$mieattendance->scheduleid.'.xls';
        $fname = mieattendance_encording_convert($filename, $encode);
        header("Content-Disposition: attachment; filename=$fname");
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
        header("Pragma: public");

        // Creating a workbook
        $workbook = new Workbook('-');
        // Creating the first worksheet
        $wsname = mieattendance_encording_convert(get_string('modulenameplural','mieattendance'),$encode);
        $worksheet =& $workbook->add_worksheet("$wsname");

        // set format.
        $format_head =& $workbook->add_format();
        $format_head->set_bold(1);
        $format_head->set_border(1);
        $format_head->set_text_wrap();

        // Output Header.-------------------------------------------------------
        // for each day of mieattendance
        $worksheet->set_column(0,0,20);
        $worksheet->set_column(1,1,5);
        $strfirstname = get_string('name','mieattendance');
        $strid = get_string('identifier','mieattendance');
        $worksheet->write_string(1,0,mieattendance_encording_convert($strfirstname,$encode),$format_head);
        $worksheet->write_string(1,1,mieattendance_encording_convert($strid,$encode),$format_head);
        $pos=2;
        if ($dlsub== "all") {
            for($k=0;$k<$numatt;$k++)  {
                // put notes for the date in the date heading
                $worksheet->set_column($pos,$pos,12);
                $strdate = userdate($atts[$k]->mieattendance->day,"%m/%0d");
                $strauto = mieattendance_encording_convert(get_string('auto','mieattendance'),$encode);
                $auto = $atts[$k]->mieattendance->autoattend  ? "($strauto)" : '';
                $strattendhead = mieattendance_encording_convert($strdate,$encode)."$auto:".
                                          mieattendance_encording_convert($atts[$k]->mieattendance->notes,$encode);
                $worksheet->write_string(1,$pos,$strattendhead,$format_head);
                $pos++;
            }
        }
        $worksheet->write_string(1,$pos,mieattendance_encording_convert(get_string('total'),$encode),$format_head);
        $worksheet->set_column($pos,$pos,5);

        $format =& $workbook->add_format();
        $format->set_border(1);
        // $format->set_align('left');

        // attendance information. ---------------------------------------------
        /// generate the mieattendance rolls for the body of the spreadsheet
        if (isstudent($course->id) && !isteacher($course->id)) {
            $students[0] = $USER;
        } else { // must be a teacher
            $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);
        }
        $i=0;
        $A = get_string('absentshort','mieattendance');
        $T = get_string('tardyshort','mieattendance');
        $P = get_string('presentshort','mieattendance');
        $N = get_string('nonentryshort','mieattendance');
        $row=2;
        if ($students) {
            $abs = $tar = 0;
            foreach ($students as $student) {
                $name = mieattendance_encording_convert(fullname($student),$encode);
                $worksheet->write_string($row, 0, $name, $format);
                $studentid=($student->idnumber != '') ? $student->idnumber : ' ';
                $worksheet->write_number($row,1,$studentid,$format);
                $pos=2; 
                if ($dlsub== 'all') {
                    for ($i=0; $i<$numatt; $i++) { // for each day of mieattendance for the student
                        // set the mieattendance defaults for each student
                        $status =  isset ($atts[$i]->sroll[$student->id]) ?
                                          $atts[$i]->sroll[$student->id]->status : $CFG->mieattendance_default_student_status;
                        switch ( $status ) {
                            case ATTEND_PRESENT: $status=$P; break;
                            case ATTEND_TARDY:    $status=$T; $tar++; break;
                            case ATTEND_ABSENT:  $status=$A; $abs++; break;
                            case ATTEND_NOFIX:     $status=$N; break;
                        }
                        $worksheet->write_string($row,$pos,mieattendance_encording_convert($status,$encode),$format);
                        $pos++;
                    }
                }
                $tot=mieattendance_tally_overall_absences_decimal($abs,$tar);
                $worksheet->write_number($row,$pos,$tot,$format);
                unset($student,$abs,$tar);
                $row++;
            }
        }
        $workbook->close();
        exit;
    }

//================================================
// Download TEXT format.
//
    if ( isset($encode) && isset($text) ) {
        header("Content-Type: application/download\n"); 
        $strfilename = get_string('modulename','mieattendance').'_'.$mieattendance->scheduleid.'.txt';
        $strencodename = mieattendance_encording_convert($strfilename,$encode);
        header("Content-Disposition: attachment; filename=\"$strencodename\"");

        /// Print names of all the fields
        $output = "$strfirstname \t $strlastname \t strid";

        if ($dlsub== 'all') {
            for($k=0;$k<$numatt;$k++)  {
                // put notes for the date in the date heading
                $output .= "\t" . userdate($atts[$k]->mieattendance->day,"%m/%0d");
                $output .= (($atts[$k]->mieattendance->notes != "")?" ".$atts[$k]->mieattendance->notes:"");
                for ($i=2;$i<=$atts[$k]->mieattendance->hours;$i++) { $output .= "\t$i"; }
            }
        }  // if dlsub==all
        $output .= "\t". $strtotal ."\n";
        
        /// generate the mieattendance rolls for the body of the spreadsheet
        if (isstudent($course->id) && !isteacher($course->id)) { 
            $students[0] = $USER;
        } else { // must be a teacher
            $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);
        }
        $i=0;
        $A = get_string('absentshort','mieattendance');
        $T = get_string('tardyshort','mieattendance');
        $P = get_string('presentshort','mieattendance');
        $N = get_string('nonentryshort','mieattendance');
        $row=3;
        if ($students) foreach ($students as $student) {
            $output .= $student->lastname;
            $output .= "\t".$student->firstname;
            $studentid=(($student->idnumber != "") ? $student->idnumber : " ");
            $output .= "\t". $studentid;
            if ($dlsub== 'all') {
                for($k=0;$k<$numatt;$k++)  { // for each day of mieattendance for the student
                    // set the mieattendance defaults for each student
                    $status =  isset ($atts[$i]->sroll[$student->id]) ?
                                    $atts[$i]->sroll[$student->id]->status : $CFG->mieattendance_default_student_status;
                    switch ( $status ) {
                         case ATTEND_PRESENT: $status=$P; break;
                         case ATTEND_TARDY:    $status=$T; $tar++; break;
                         case ATTEND_ABSENT:  $status=$A; $abs++; break;
                         case ATTEND_NOFIX:     $status=$N; break;
                     }
                    $output .= "\t".$status;
                }
            }
            $tot=mieattendance_tally_overall_absences_decimal($abs,$tar);
            $output .= "\t".$tot."\n";
            unset($abs,$tar);
            $row++;
        }
        $output = mieattendance_encording_convert($output,$encode);
        echo $output;
        exit;
    }

?>
