<?php  // $Id: lib.php,v 1.20 2005/03/10 13:30:46 moodler Exp $

/// Library of functions and constants for mieattendance module
// error_reporting(E_ALL);

// Status.
define('ATTEND_PRESENT',0);
define('ATTEND_TARDY',1);
define('ATTEND_ABSENT',2);

// Entry method.
define('ENTRY_METHOD_STUDENT',0);
define('ENTRY_METHOD_AUTO',1);
define('ENTRY_METHOD_WEEK',2);

// mail status.
define('MAIL_STATUS_NEUTRAL',0);
define('MAIL_STATUS_SEND',0);
define('MAIL_STATUS_COMPLETION',0);

// view command.
define('TAB_ID_DEFAULT',0);
define('TAB_ID_EDIT',1);
define('TAB_ID_SENDMAIL',2);
define('TAB_ID_REPORT',3);

define('TAB_ID_DEBUG',10);
define('TIME_WEEK',604800);
define('TIME_DAY',86400);

// infomation for edit menu.
$TAB_EDIT_MENU_S = array ( TAB_ID_DEFAULT => get_string('modulename','mieattendance').get_string('situation', 'mieattendance'),
                                                       TAB_ID_EDIT => get_string('entrystudents', 'mieattendance'),
                                                       TAB_ID_REPORT => get_string('reports', 'mieattendance') );

$TAB_EDIT_MENU_T = array ( TAB_ID_DEFAULT => get_string('modulename','mieattendance').get_string('situation', 'mieattendance'),
                                                       TAB_ID_EDIT => get_string('teacheredit', 'mieattendance'),
                                                       TAB_ID_SENDMAIL => get_string('mailtostudents', 'mieattendance'),
//                                                       TAB_ID_DEBUG => DEBUG,
                                                       TAB_ID_REPORT => get_string('reports', 'mieattendance') );

$TAB_EDIT_MENU_AUTO_S = array ( TAB_ID_DEFAULT => get_string('modulename','mieattendance').get_string('situation', 'mieattendance'),
                                                       TAB_ID_REPORT => get_string('reports', 'mieattendance') );

$TAB_EDIT_MENU_AUTO_T = array ( TAB_ID_DEFAULT => get_string('modulename','mieattendance').get_string('situation', 'mieattendance'),
                                                       TAB_ID_REPORT => get_string('reports', 'mieattendance') );

function mieattendance_add_module(&$mod) {
    require_once("../../course/lib.php");
    if (! $mod->instance = mieattendance_add_instance($mod)) {
        error("Could not add a new instance of $mod->modulename"); return 0;
    }
    // course_modules and course_sections each contain a reference 
    // to each other, so we have to update one of them twice.
    if (! $mod->coursemodule = add_course_module($mod) ) {
        error("Could not add a new course module"); return 0;
    }
    if (! $sectionid = add_mod_to_section($mod) ) {
        error('Could not add the new course module to that section'); return 0;
    }
    if (! set_field('course_modules', 'section', $sectionid, 'id', $mod->coursemodule)) {
        error('Could not update the course module with the correct section'); return 0;
    }
    add_to_log($mod->course, 'course', 'add mod', 
             "../mod/$mod->modulename/view.php?id=$mod->coursemodule", 
             "$mod->modulename $mod->instance"); 
    rebuild_course_cache($mod->course);
}

function mieattendance_add_instance($mieattendance) {
    global $mod;

    $mieattendance->timemodified = time();
    $mieattendance->dynsection = !empty($mieattendance->dynsection) ? 1 : 0;
    $mieattendance->autoattend = !empty($mieattendance->autoattend) ? 1 : 0;
    $mieattendance->grade = !empty($mieattendance->grade) ? 1 : 0;

    if (empty($mieattendance->day)) {
        // make_timestamp($year, $month=1, $day=1, $hour=0, $minute=0, $second=0, $timezone=99, $applydst=true)
        $mieattendance->day = make_timestamp($mieattendance->theyear, 
                                                           $mieattendance->themonth, $mieattendance->theday);
    }

    if ( !empty($mieattendance->openhour ) or ( !empty($mieattendance->closehour) )) {
        $mieattendance->timeopen =  make_timestamp($mieattendance->theyear, $mieattendance->themonth,
                                                     $mieattendance->theday, $mieattendance->openhour, $mieattendance->openminute);
        $mieattendance->timeclose =  make_timestamp($mieattendance->theyear, $mieattendance->themonth,
                                                     $mieattendance->theday,$mieattendance->closehour, $mieattendance->closeminute);
    } else {
        $mieattendance->timeopen = $mieattendance->timeclose = 0;
    }

    $mieattendance->notes = $mieattendance->name;
    $mieattendance->name=userdate($mieattendance->day, get_string('strftimedate'));
    if ($mieattendance->notes) { 
        $mieattendance->name = $mieattendance->name . ' - ' .  $mieattendance->notes;
    }
    $mieattendance->edited = 0;
    if ($mieattendance->dynsection) {
        if ($mod->course) {
            if (! $course = get_record('course', 'id', $mod->course)) {
                error('Course is misconfigured');
            }
        }
        if ($course->format =='weeks') {
            //  floor($date_relative / TIME_WEEK) + 1
            $mieattendance->section = floor(($mieattendance->day - $course->startdate)/TIME_WEEK) +1;

            if ($mieattendance->section > $course->numsections) {
                $mieattendance->section = 0;
            }
            // change a registration section.
            $mod->section = "$mieattendance->section";
        }
    }
    // insert the main record first
    return $mieattendance->id = insert_record('mieattendance', $mieattendance);
}


function mieattendance_update_instance($mieattendance) {
    global $mod;
    $mieattendance->timemodified = time();
//    $mieattendance->oldid=$mieattendance->id;
    $mieattendance->id = $mieattendance->instance;
    $mieattendance->dynsection = !empty($mieattendance->dynsection) ? 1 : 0;
    $mieattendance->autoattend = !empty($mieattendance->autoattend) ? 1 : 0;
    $mieattendance->grade = !empty($mieattendance->grade) ? 1 : 0;

    $mieattendance->day = make_timestamp($mieattendance->theyear,$mieattendance->themonth, $mieattendance->theday);
    $mieattendance->notes = $mieattendance->name;
    $mieattendance->name=userdate($mieattendance->day, get_string('strftimedate'));

    if ($mieattendance->notes) {
        $mieattendance->name = $mieattendance->name . ' - ' .  $mieattendance->notes;
    }

    if ( !empty($mieattendance->openhour ) or ( !empty($mieattendance->closehour) )) {
        $mieattendance->timeopen =  make_timestamp($mieattendance->theyear, $mieattendance->themonth,
                                                     $mieattendance->theday, $mieattendance->openhour, $mieattendance->openminute);
        $mieattendance->timeclose =  make_timestamp($mieattendance->theyear, $mieattendance->themonth,
                                                     $mieattendance->theday,$mieattendance->closehour, $mieattendance->closeminute);
    } else {
        $mieattendance->timeopen = $mieattendance->timeclose = 0;
    }

    if(!update_record('mieattendance', $mieattendance)){
        error("Couldn't update record");
    }

    if ($mieattendance->dynsection) {

        //get info about the course
        if (! $course = get_record('course', 'id', $mieattendance->course)) {
            error('Course is misconfigured');
        }
        //get info about the course modules
        if (! $cm = get_record('course_modules', 'id', $mieattendance->coursemodule)) {
            error('--------Course module is misconfigured');
        }

        //work out which section this should be in
        $mieattendance->section = floor(($mieattendance->day - $course->startdate)/TIME_WEEK) +1;
        if (($mieattendance->section > $course->numsections) || ($mieattendance->section < 0)){
            $mieattendance->section = 0;
        }

        if ( $mieattendance->section != get_field('course_sections', 'section', 'id', $cm->section)) {
            if (! delete_mod_from_section($cm->id, $cm->section)) {
                error('Could not delete module from existing section');
            }
            if (! $sectionid = add_mod_to_section($mieattendance) ) {
                error('Could not add the new course module to that section'); return 0;
            }
            //update course with new module location
            if(! set_field('course_modules', 'section', $sectionid, 'id', $cm->id)){
                 notice('Could not update course module list');
            }
        }
        rebuild_course_cache($mieattendance->course);
    }
    return true;
}

function mieattendance_delete_instance($id) {
    $result = true;

    if (! $mieattendance = get_record('mieattendance', 'id', $id)) {
        return false;
    }
    /// delete all the rolls for the day
    delete_records('mieattendance_roll', 'dayid', $mieattendance->id);
    
    if (! delete_records('mieattendance', 'id', $mieattendance->id)) {
        $result = false;
    }
    return $result;
}

function mieattendance_user_outline($course, $user, $mod, $mieattendance) {
/// Return a small object with summary information about what a 
/// user has done with a given particular instance of this module
/// Used for user activity reports.
/// $return->time = the time they did it
/// $return->info = a short text description
/// for mieattendance, this would be a list present and tardy for every hour of the day
    $tardies=count_records('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $user->id, 'status', 1);
    $absences=count_records('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $user->id, 'status', 2);

    // build longer string for tardies
    if ($tardies > 0) {
        $tardyrecs=mieattendance_get_records('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $user->id, 'status', 1, 'hour ASC');
        if ($tardies == 1) {
            $tardystring = 'Tardy in hour ' . $tardyrecs[0]->hour . '. ';
        } elseif ($tardies == $mieattendance->hours) { 
            $tardystring = 'Tardy in all hours. (' . $mieattendance->hours . ') ';
        } else { 
            // build array of all tardies
            $tarr = array();
            if ($tardyrecs) foreach ($tardyrecs as $tardyrec) {
                array_push($tarr, $tardyrec->hour);
                $tardystring = $tardystring . ', ' . $tardyrec->hour;
            }
            $end=array_pop($tarr);
            $tardystring = 'Tardy in hours ' . implode(', ', $tarr) . ' and '. $end . '. ';
        }
    } else {
        $tardystring = '';
    }
    // build longer string for absences
    if ($absences > 0) {
        $absrecs=mieattendance_get_records('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $user->id, 'status', 2, 'hour ASC');
        if ($absences == 1) {
            $absstring = 'Absent in hour ' . $absrecs[0]->hour . '.';
        } elseif ($absences == $mieattendance->hours) { 
            $absstring = 'Absent in all hours. (' . $mieattendance->hours . ')';
        } else { 
            // build array of all absences
            $aarr = array();
            if ($absrecs) foreach ($absrecs as $absrec) {
                array_push($aarr, $absrec->hour);
            }
            $end=array_pop($aarr);
            $absstring = 'Absent in hours ' . implode(', ', $aarr) . ' and '. $end . '.';
        }
    } else { $absstring = '';}
        $return->info=$tardystring . $absstring;
        if ($return->info == '') $return->info = 'No Tardies or Absences';
    return $return;
}

function mieattendance_user_complete($course, $user, $mod, $mieattendance) {
/// Print a detailed representation of what a  user has done with 
/// a given particular instance of this module, for user activity reports.
    // get the mieattendance record for that day and user
    $A = get_string('absentshort','mieattendance');
    $T = get_string('tardyshort','mieattendance');
    $P = get_string('presentshort','mieattendance');

    $attrecs=mieattendance_get_records('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $user->id, '', '', 'hour ASC');
    // fill an array with the absences and tardies, as those are the only records actually stored
    
    $grid = array();
    if ($attrecs) { foreach ($attrecs as $attrec) { $grid[$attrec->hour]=$attrec->status; } }
    echo '<table><tr><th>Hour:</th>';
    // echo out the table header
    for($j=1;$j<=$mieattendance->hours;$j++) {
        echo '<th valign="top" align="center" nowrap class="generaltableheader">'.$j.'</th>';
    }
    echo '</tr><tr><th>Status:</th>';
    for($j=1;$j<=$mieattendance->hours;$j++) {
        // set the mieattendance defaults for each student
        if (isset($grid[$j])) {
            $status = (($grid[$j] == 1) ? $T : $A);
        } else {$status=$P;}
        echo '<td align="left" nowrap class="generaltablecell" style="border-left: 1px dotted; border-top: 1px solid;">'.$status.'</td>';
    }
    echo '</tr></table>';
    return true;
}


function mieattendance_cron () {
    global $CFG;

    // look for all mieattendance instances set to autoattend
    if (!$mieattendances = get_records('mieattendance', 'autoattend', 1, 'course ASC')) {
        return true;
    }
    $timenow = time();

    foreach($mieattendances as $mieattendance) {
        if ( !$mieattendance->edited && ($timenow > $mieattendance->timeclose)) {
            // get students
            if (! $course = get_record('course','id',$mieattendance->course)) {
                error('Course ID was incorrect');
            }
            $module = get_record('modules','name','mieattendance');
            if (! $cm = get_record('course_modules','module',$module->id,'instance',$mieattendance->id)) {
                error('Course Module ID was incorrect');
            }
            $groupmode = groupmode($course, $cm);
            $groupid =  $groupmode ? $mieattendance->groupid : '';
            $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);
            if ( ! $students ) continue;

            foreach ( $students  as $student ) {
                // first, clear out the records that may be there already

                $wc = "userid = '$student->id' AND course = '$course->id' AND ".
                          "time >= '$mieattendance->timeopen' AND time < '$mieattendance->timeclose'";
                $count = get_record('log',$wc,'COUNT(*) as c');
                $status = $count ? ATTEND_PRESENT : ATTEND_ABSENT;

                if ( $roll = get_record('mieattendance_roll', 'dayid', $mieattendance->id, 'userid', $student->id)) {
                    $roll->status = $status;
                    if (! update_record('mieattendance_roll',$roll)) {
                         error('Could not update your mieattendance_roll because of a database error');
                    }
                } else {
                    $roll = NULL;
                    $roll->status = $status;
                    $roll->dayid = $mieattendance->id;
                    $roll->userid = $student->id;
                    if (! insert_record('mieattendance_roll',$roll)) {
                        error('Could not save your mieattendance_roll');
                    }
                }
                unset($student,$wc);
            }
            $mieattendance->edited = 1;
            $mieattendance->timemodified = $timenow;
            if (! update_record('mieattendance',$mieattendance)) {
                error('Could not update your mieattendance because of a database error');
            }
            unset($course,$cm,$students);
        }
    }
    return true;
}

function mieattendance_grades($mieattendanceid) {
    /// Must return an array of grades for a given instance of this module, 
    /// indexed by user.  It also returns a maximum allowed grade.
    $mieattendance = get_record('mieattendance', 'id', $mieattendanceid);
    if ($mieattendance->grade == '1') {
        $students = get_course_students($mieattendance->course);
        if ($students) {
            foreach ($students as $student) {
                 $rolls = mieattendance_get_records('mieattendance_roll', 'dayid',$mieattendance->id,'userid',$student->id);
                 $abs=$tar=0;
                if ($rolls) {
                    foreach ($rolls as $roll) {
                        if ($roll->status == 1) {$tar++;}
                        elseif ($roll->status == 2) {$abs++;}
                    }
                    $total = $mieattendance->hours - mieattendance_tally_overall_absences_decimal($abs, $tar);
                    $percent = ($total != 0)?$total/$mieattendance->hours:0;
                    $return->grades[$student->id] = ($percent == 0)?0.0:$mieattendance->maxgrade * $percent;
                } else  { $return->grades[$student->id] = $mieattendance->maxgrade; }
            }
        }
        $return->maxgrade = $mieattendance->maxgrade;
    } else {
        $return = NULL;
    }
    return $return;
}

/**
* Returns user records for all users who have DATA in a given mieattendance instance
*
* This function is present only for the backup routines.  It won't return meaningful data
* for an mieattendance roll because it only returns records for users who have been counted as
* tardy or absent in the rolls for a single mieattendance instance, since these are the only
* records I store in the database - for brevity's sake of course.
*
* @param        int     $mieattendanceid   the id of the mieattendance record we're looging for student data from
* @return       (object)recordset       associative array of records containing the student records we wanted
*/
function mieattendance_get_participants($mieattendanceid) {
//Returns the users with data in one mieattendance
//(users with records in mieattendance_roll, students)
    global $CFG;

    //Get students
    $students = get_records_sql("SELECT DISTINCT u.id, u.id
                                 FROM {$CFG->prefix}user u,
                                      {$CFG->prefix}mieattendance_roll a
                                 WHERE a.dayid = '$mieattendanceid' and
                                       u.id = a.userid");

    //Return students array (it contains an array of unique users)
    return ($students);
}


//////////////////////////////////////////////////////////////////////////////////////
/// Any other mieattendance functions go here.  Each of them must have a name that 
/// starts with mieattendance_

/**
* get a list of all students enrolled in a given course - modified version
* 
*  THIS IS JUST THE GET_COURSE_STUDENTS FUNCTION WITH THE INCLUSION OF THE 
*     STUDENT ID INTO THE RECORDSET
* if courseid = 0 then return ALL students in all courses
*
* @param    int $courseid   the id of the course
* @param    string  $sort   a field name and ASC or DESC for a SQL 'ORDER BY' clause (optional)
* @return   array(recorset) a list of all students in the specified course
 Returns 
*/
function mieattendance_get_course_students($courseid, $sort='u.lastaccess DES', $groupid='') {
    global $CFG;

    // make sure it works on the site course
    $select = $from  = '';
    if ($courseid != SITEID) {
        if ( $groupid ) {
            $from = ", {$CFG->prefix}groups_members gm";
            $select = "gm.groupid = '$groupid' AND u.id = gm.userid  AND ";
        } else {
            $select = "s.userid = u.id AND ";
        }
    }

    $sql = "SELECT u.id, u.username, u.firstname, u.lastname, u.maildisplay, u.mailformat,
                           u.email, u.city, u.country, u.lastaccess, u.lastlogin, u.picture, u.idnumber
                           FROM {$CFG->prefix}user u, 
                                     {$CFG->prefix}user_students s $from 
                           WHERE  s.course = '$courseid' AND  $select 
                                     u.deleted = '0' 
                                     ORDER BY $sort";
    return get_records_sql($sql);
}

/**
* Find total absences based on number of tardies per absence
* 
* Given a number of tardies and absences, determine the total
* number of equivalent absences it adds up to.
*
* @param    int $absences   the total number of absences for a span of time
* @param    int $tardies    the total number of tardies for a span of time
* @return   float   the number of absences it adds up to - may be a decimal!
*/
function mieattendance_tally_overall_absences_decimal($absences, $tardies) {
    global $CFG;
    if (isset($CFG->mieattendance_tardies_per_absence) && ($CFG->mieattendance_tardies_per_absence>0)) {
        return $absences + ($tardies/$CFG->mieattendance_tardies_per_absence);
    } else { return $absences; }
}

/**
* Find total absences based on number of tardies per absence and put it in a string
* 
* Given a number of tardies and absences, determine the total
* number of equivalent absences it adds up to and express it as a string with
* a possible fractional remainder
*
* @param    int $absences   the total number of absences for a span of time
* @param    int $tardies    the total number of tardies for a span of time
* @return   string  the number of absences it adds up to - may have a fractional component!
*/
function mieattendance_tally_overall_absences_fraction($absences, $tardies) {
    global $CFG;
    if (isset($CFG->mieattendance_tardies_per_absence) && ($CFG->mieattendance_tardies_per_absence>0)) {
        $whole = floor($tardies/$CFG->mieattendance_tardies_per_absence);
        $fractional=$tardies-($whole * $CFG->mieattendance_tardies_per_absence);
        if ($absences + $whole > 0) {
            return ($absences + $whole) . (($fractional > 0) ? ' '.$fractional.'/'.$CFG->mieattendance_tardies_per_absence : '');
        } else  {
            return (($fractional > 0) ? $fractional. '/'. $CFG->mieattendance_tardies_per_absence : '0');
        }
    } else {
      return $absences.'';
    }
}

/**
* get a list of records from a table with multiple criteria
* 
* This one is different from the datalib.php one (called get_records) in the sense that it 
* allows for multiple criteria to be easily supplied as parameters, but doesn't
* give the ability to specify sort, fields, or limits
*
*/
function mieattendance_get_records($table, $field1='', $value1='', $field2='', $value2='', $field3='', $value3='', $sort='', $fields='*', $limitfrom='', $limitnum='') {

    global $CFG;

    if ($field1) {
        $select = "WHERE $field1 = '$value1'";
        if ($field2) {
            $select .= " AND $field2 = '$value2'";
            if ($field3) {
                $select .= " AND $field3 = '$value3'";
            }
        }
    } else {
        $select = '';
    }

    if ($limitfrom !== '') {
        switch ($CFG->dbtype) {
        case "mysql":
            $limit = "LIMIT $limitfrom,$limitnum";
            break;
        case "postgres7":
            $limit = "LIMIT $limitnum OFFSET $limitfrom";
            break;
        default: 
             $limit = "LIMIT $limitnum,$limitfrom";
        }
    } else {
        $limit = '';
    }

    if ($sort != '') {
        $sort = "ORDER BY $sort";
    }

    return get_records_sql("SELECT $fields FROM $CFG->prefix$table $select $sort $limit");
}

/**
* Return all mieattendance records that are in the same section as the instance specified
* 
* This function uses course_modules, modules, and mieattendance tables together to determine
* first what section the specified mieattendance instance in the course is in, then all the
* mieattendance records that are in the same section, regardless of the format of the course
*
* @param    int $instance   id of the mieattendance instance in course_modules
* @param    int $courseid   the id of the course for which we're getting records
* @return   (object)recordset   associative array of records containing the mieattendance records we wanted 
*/
function get_mieattendance_for_section($instance, $courseid) {
    global $CFG;
    // first, get the section for the instance specified
    $sql = "SELECT cm.section
                           FROM {$CFG->prefix}course_modules cm,
                                {$CFG->prefix}modules md, 
                                {$CFG->prefix}mieattendance a 
                           WHERE cm.course = '$courseid' AND 
                                 cm.instance = a.id AND 
                                 md.name = 'mieattendance' AND 
                                 md.id = cm.module AND
                                 a.id = '$instance'";
    $sectarray = get_record_sql($sql);
    $section = $sectarray->section;

    // then get all the mieattendance instances in that section
    $sql = "SELECT a.*
                           FROM {$CFG->prefix}course_modules cm, 
                                {$CFG->prefix}modules md, 
                                {$CFG->prefix}mieattendance a 
                           WHERE cm.course = '$courseid' AND 
                                 cm.section = '$section' AND 
                                 md.name = 'mieattendance' AND 
                                 md.id = cm.module AND
                                 a.id = cm.instance order by a.day ASC";
    return get_records_sql($sql);
}

/**
* Return all mieattendance records that are in the same 7 day span as the instance specified
* 
* This function uses the course and mieattendance tables together to find all the mieattendance 
* records that are for days within the same week span as the instance specified.  The week is
* determined based NOT on calendar week, but instead on the week span as it occurs in a 
* weekly formatted course - I find this by starting with the startdate of the course and 
* then skipping ahead by weeks til I find the range that fits the instance, then I use that
* range as min and max to query the mieattendance table for all the other records.  Note that this
* function will work with non-weekly formatted courses, though the results won't easily 
* correlate with the course view.  But it will work regardless.
*
* @param    int $id the id of the mieattendance record we're using as a basis for the query
* @param    int $courseid   the id of the course for which we're getting records
* @return   (object)recordset   associative array of records containing the mieattendance records we wanted 
*/
function get_mieattendance_for_week($id, $courseid) {
    global $CFG;
    if (! $mieattendance = get_record('mieattendance', 'id', $id)) {
         error('MieAttendance module is incorrect');
    }
    if (! $course = get_record('course', 'id', $courseid)) {
        error("Course is incorrect");
    }
    // the offset is for weeks that don't start on Monday
    $day = $mieattendance->day;
    // determine the week range for the select, based on the day
    for ($maxday=$course->startdate;$day>$maxday;$maxday=$maxday+TIME_WEEK);

    $minday = $maxday-TIME_WEEK;

    $sql = "SELECT * FROM {$CFG->prefix}mieattendance a
         WHERE a.course = '$courseid' AND a.day<$maxday AND a.day>=$minday order by a.day ASC;";
    return get_records_sql($sql);
}

/**
* Finds the beginning of the day for the date specified
* 
* This function returns the timestamp for midnight of the day specified in the timestamp
*
* @param    timestamp $d    The time to find the beginning of the day for
* @return   timestamp   midnight for that day
*/
function mieattendance_find_today($d) {
    $damon = gmdate('m',$d);
    $daday = gmdate('d',$d);
    $dayear = gmdate('Y',$d);
    return gmmktime(0,0,0,$damon, $daday, $dayear);
}

/**
* Finds the beginning of the day following the date specified
* 
* This function returns the timestamp for midnight of the day after the timestamp specified
*
* @param    timestamp $d    The time to find the next day of
* @return   timestamp   midnight of the next day
*/
function mieattendance_find_tomorrow($d) {
    // add 24 hours to the current time - to solve end of month date issues
    return mieattendance_find_today($d+TIME_DAY);
}

/*******************************************************************/
function mieattendance_tab_menu($tabsinfo, $selected='', $link='', $onclick='') {
    // prints the question types for when editing and adding a page
    $tabs = array();
    $tabrows = array();

    foreach ($tabsinfo as $tabid => $tabname) {
        $tabrows[] = new tabobject($tabid, "$link&amp;tabid=$tabid\" onClick=\"$onclick\"", $tabname);
    }
    $tabs[] = $tabrows;
    print_tabs($tabs, $selected);
    echo "<input type=\"hidden\" name=\"tabid\" value=\"$selected\" > \n";
}

/*******************************************************************/
function mieattendance_check_config_setteing () {
    global $CFG;

    if (! isset($CFG->mieattendance_dynsection)) {
        $config = array( 'mieattendance_dynsection' => 0,
                                  'mieattendance_default_hours' => 1,
                                  'mieattendance_tardies_per_absence' => 0,
                                  'mieattendance_hours_in_full_report' => 10,
                                  'mieattendance_default_student_status' => 0,
                                  'mieattendance_autoattend' => 0,
                                  'mieattendance_grade' => 0,
                                  'mieattendance_maxgrade' => 0);

        foreach ($config as $name => $value) {
            set_config($name, $value);
        }
    }
}

function mieattendance_choose_from_radio ($options, $name, $checked='', $vertical='0', $mobile='false') {
    if (!$name) { $name = 'unnamed'; }

    if (!empty($options)) {
        switch ($vertical) {
        case '0':  // CHOICE_DISPLAY_HORIZONTAL
            if ( $mobile ) {
                $output = '';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>';
                    $output .= $text.'&nbsp;&nbsp;';
                }
            } else {
                $output = '<table cellpadding="0" align="center"><tr>';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '<td align="center" valign="top">';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>'.$text;
                    $output .= '</td>';
                }
                $output .= '</tr></table>';
            }
            break;
        case '1':  // CHOICE_DISPLAY_VERTICAL
            if ( $mobile ) {
                $output = '';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>';
                    $output .= '&nbsp;'.$text.'<br>';
                }
            } else {
                $output = '<table align="center">';
                $displayoptions->para = false;
                print_spacer(10);
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '<tr><td align="left" valign="top">';
                    $output .= '<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>'.$text;
                    $output .= '</td></tr>';
                }
                $output .= '</table>';
            }
            break;
        }
    }
    return $output;
}

/**
 * Print a nicely formatted table.
 *
 * @param array $table is an object with several properties.
 *     <ul<li>$table->head - An array of heading names.
 *     <li>$table->align - An array of column alignments
 *     <li>$table->size  - An array of column sizes
 *     <li>$table->wrap - An array of "nowrap"s or nothing
 *     <li>$table->data[] - An array of arrays containing the data.
 *     <li>$table->width  - A percentage of the page
 *     <li>$table->border  - A border
 *     <li>$table->cellpadding  - Padding on each cell
 *     <li>$table->cellspacing  - Spacing between cells
 * </ul>
 * @return boolean
 * @todo Finish documenting this function
 */
function mieattendance_print_table($table) {

    if (isset($table->align)) {
        foreach ($table->align as $key => $aa) {
            if ($aa) {
                $align[$key] = ' align="'. $aa .'"';
            } else {
                $align[$key] = '';
            }
        }
    }
    if (isset($table->valign)) {
        foreach ($table->valign as $key => $vv) {
            if ($aa) {
                $valign[$key] = ' valign="'. $vv .'"';
            } else {
                $valign[$key] = '';
            }
        }
    }
    if (isset($table->size)) {
        foreach ($table->size as $key => $ss) {
            if ($ss) {
                $size[$key] = ' width="'. $ss .'"';
            } else {
                $size[$key] = '';
            }
        }
    }
    if (isset($table->wrap)) {
        foreach ($table->wrap as $key => $ww) {
            if ($ww) {
                $wrap[$key] = ' nowrap="nowrap" ';
            } else {
                $wrap[$key] = '';
            }
        }
    }

    if (empty($table->width)) {
        $table->width = '80%';
    }
    if (empty($table->cellpadding)) {
        $table->cellpadding = 5;
    }
    if (empty($table->cellspacing)) {
        $table->cellspacing = 1;
    }
    if (empty($table->class)) {
        $table->class = 'generaltable';
    }
    if (empty($table->border)) {
        $table->border = 0;
    }
    $tableid = empty($table->id) ? '' : 'id="'.$table->id.'"';

    print_simple_box_start('center', $table->width, '#ffffff', 0);
    echo "<table width=\"100%\" border=\"$table->border\" align=\"center\" ";
    echo " cellpadding=\"$table->cellpadding\" cellspacing=\"$table->cellspacing\" class=\"$table->class\" $tableid>\n";

    $countcols = 0;
    if (!empty($table->head)) {
        $countcols = count($table->head);
        echo '<tr>';
        foreach ($table->head as $key => $heading) {

            if (!isset($size[$key])) {
                $size[$key] = '';
            }
            if (!isset($align[$key])) {
                $align[$key] = '';
            }
            $p1 = !empty($valign[$key]) ? $valign[$key] : '';
            $p2 = !empty($align[$key]) ?  $align[$key] : '';
            $p3 = !empty($size[$key]) ? $size[$key] : '';
            echo '<th '.$p1.$p2.$p3.' nowrap="nowrap" class="header c'.$key.'">'. $heading .'</th>';
        }
        echo '</tr>';
    }

    if (!empty($table->data)) {
        $oddeven = 1;
        foreach ($table->data as $key => $row) {
            $oddeven = $oddeven ? 0 : 1;
            echo '<tr class="r'.$oddeven.'">';
            if ($row == 'hr' and $countcols) {
                echo '<td colspan="'. $countcols .'"><div class="tabledivider"></div></td>';
            } else {  /// it's a normal row of data
                foreach ($row as $key => $item) {
                    if (!isset($size[$key])) {
                        $size[$key] = '';
                    }
                    if (!isset($align[$key])) {
                        $align[$key] = '';
                    }
                    if (!isset($wrap[$key])) {
                        $wrap[$key] = '';
                    }
                    echo '<td '. $align[$key].$size[$key].$wrap[$key] .' class="cell c'.$key.'">'. $item .'</td>';
                }
            }
            echo '</tr>';
        }
    }
    echo '</table>';
    print_simple_box_end();

    return true;
}
function mieattendance_print_group($courseid, $groupmode) {
    if ( $group = get_current_group($courseid, true)) {
        $strgroupname = $group->name;
    } else {
        $strgroupname = get_string('everybody');
    }
    $strgroupmodes = array('groupsnone','groupsseparate','groupsvisible');
//    print_simple_box_start('center','*');
    echo '<center>'.get_string("$strgroupmodes[$groupmode]")."&nbsp;:&nbsp;$strgroupname</center><br>";
//    print_simple_box_end();
}
/**
 * Send an email to a specified user
 *
 * @uses $CFG
 * @uses $_SERVER
 * @uses SITEID
 * @param user $user  A {@link $USER} object
 * @param user $from A {@link $USER} object
 * @param string $subject plain text subject line of the email
 * @param string $messagetext plain text version of the message
 * @param string $messagehtml complete html version of the message (optional)
 * @param string $attachment a file on the filesystem, relative to $CFG->dataroot
 * @param string $attachname the name of the file (extension indicates MIME)
 * @param boolean $usetrueaddress determines whether $from email address should
 *          be sent out. Will be overruled by user profile setting for maildisplay
 * @return boolean|string Returns "true" if mail was sent OK, "emailstop" if email
 *          was blocked by user and "false" if there was another sort of error.
 */
function mieattendance_email_to_user($user, $from, $subject, $messagetext, $messagehtml='', $attachment='', $attachname='', $usetrueaddress=true, $repyto='', $replytoname='') {
    global $CFG, $FULLME;

    global $course;                // This is a bit of an ugly hack to be gotten rid of later
    if (!empty($course->lang)) {   // Course language is defined
        $CFG->courselang = $course->lang;
    }
    if (!empty($course->theme)) {   // Course language is defined
        $CFG->coursetheme = $course->theme;
    }

    include_once("$CFG->dirroot/lib/phpmailer/class.phpmailer.php");

    if (empty($user)) {
        return false;
    }

    if (!empty($user->emailstop)) {
        return 'emailstop';
    }

    if (over_bounce_threshold($user)) {
        error_log("User $user->id (".fullname($user).") is over bounce threshold! Not sending.");
        return false;
    }

    $mail = new phpmailer;

    $mail->IsMail();                                                         // use PHP mail()
    $mail->Version = "Moodle $CFG->version";                 // mailer version
    $mail->PHPMailer();                                                  // plugin directory (eg smtp plugin)

    if (current_language() != 'en') {
//        $mail->CharSet = get_string('thischarset');
        $mail->CharSet = 'ISO-2022-JP';
    }
    $dbcharset = get_string('thischarset');

/*==================================================
    if ($CFG->smtphosts == 'qmail') {
        $mail->IsQmail();                              // use Qmail system
    } else if (empty($CFG->smtphosts)) {
        $mail->IsMail();                               // use PHP mail() = sendmail
    } else {
        $mail->IsSMTP();                               // use SMTP directly
        if ($CFG->debug > 7) {
            echo '<pre>';
            $mail->SMTPDebug = true;
        }
        $mail->Host = $CFG->smtphosts;               // specify main and backup servers

        if ($CFG->smtpuser) {                          // Use SMTP authentication
            $mail->SMTPAuth = true;
            $mail->Username = $CFG->smtpuser;
            $mail->Password = $CFG->smtppass;
        }
    }
==================================================*/

    $adminuser = get_admin();

    // make up an email address for handling bounces
    if (!empty($CFG->handlebounces)) {
        $modargs = 'B'.base64_encode(pack('V',$user->id)).substr(md5($user->email),0,16);
        $mail->Sender = generate_email_processing_address(0,$modargs);
    } else {
        $mail->Sender = $adminuser->email;
    }
    if (is_string($from)) { // So we can pass whatever we want if there is need
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding($from, 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else if ($usetrueaddress and $from->maildisplay) {
        $mail->From = $from->email;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else {
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from), 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
        if (empty($replyto)) {
            $mail->AddReplyTo($CFG->noreplyaddress,get_string('noreplyname'));
        }
    }
    if (!empty($replyto)) {
        $mail->AddReplyTo($replyto,$replytoname);
    }
    $subject = mb_convert_encoding($subject, 'ISO-2022-JP',$dbcharset);
    $mail->Subject = substr(stripslashes($subject), 0, 900);

    /* 
    if (! $kmailuser = get_record('user_profile_sub','userid',$user->id)) {
        $username = fullname($user);
        error("ERROR : kmail user $username");
    }
    */
    $username = mb_encode_mimeheader(mb_convert_encoding(fullname($user),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    // $mail->AddAddress($kmailuser->email,$username);
    $mail->AddAddress($user->email,$username);

    $mail->WordWrap = 79;                               // set word wrap

    if (!empty($from->customheaders)) {                 // Add custom headers
        if (is_array($from->customheaders)) {
            foreach ($from->customheaders as $customheader) {
                $mail->AddCustomHeader($customheader);
            }
        } else {
            $mail->AddCustomHeader($from->customheaders);
        }
    }

    if (!empty($from->priority)) {
        $mail->Priority = $from->priority;
    }

    $messagetext = mb_convert_encoding($messagetext,'JIS',$dbcharset);
    if ($messagehtml && $user->mailformat == 1) { // Don't ever send HTML to users who don't want it
        $mail->IsHTML(true);
        $mail->Encoding = 'quoted-printable';           // Encoding to use
        $mail->Body    =  $messagehtml;
        $mail->AltBody =  "\n$messagetext\n";
    } else {
        $mail->IsHTML(false);
        $mail->Body =  "\n$messagetext\n";
    }

    if ($attachment && $attachname) {
        if (ereg( "\\.\\." ,$attachment )) {    // Security check for ".." in dir path
            $adminname =  mb_convert_encoding(fullname($adminuser),'SIO-2022-JP',$dbcharset);
            $mail->AddAddress($adminuser->email, $adminname);
            $mail->AddStringAttachment('Error in attachment.  User attempted to attach a filename with a unsafe name.', 'error.txt', '8bit', 'text/plain');
        } else {
            require_once($CFG->libdir.'/filelib.php');
            $mimetype = mimeinfo('type', $attachname);
            $mail->AddAttachment($CFG->dataroot .'/'. $attachment, $attachname, 'base64', $mimetype);
        }
    }
    if ($mail->Send()) {
        set_send_count($user);
        return true;

    } else {
        mtrace('ERROR: '. $mail->ErrorInfo);
        add_to_log(SITEID, 'library', 'mailer', $FULLME, 'ERROR: '. $mail->ErrorInfo);
        return false;
    }

}


/**
 * Send an email to a specified user
 *
 * @uses $CFG
 * @uses $_SERVER
 * @uses SITEID
 * @param user $user  A {@link $USER} object
 * @param user $from A {@link $USER} object
 * @param string $subject plain text subject line of the email
 * @param string $messagetext plain text version of the message
 * @param string $messagehtml complete html version of the message (optional)
 * @param string $attachment a file on the filesystem, relative to $CFG->dataroot
 * @param string $attachname the name of the file (extension indicates MIME)
 * @param boolean $usetrueaddress determines whether $from email address should
 *          be sent out. Will be overruled by user profile setting for maildisplay
 * @return boolean|string Returns "true" if mail was sent OK, "emailstop" if email
 *          was blocked by user and "false" if there was another sort of error.
 */
function tmpmieattendance_email_to_user($user, $from, $subject, $messagetext, $messagehtml='', $attachment='', $attachname='', $usetrueaddress=true, $repyto='', $replytoname='') {
    global $CFG, $FULLME;

    global $course;                // This is a bit of an ugly hack to be gotten rid of later
    if (!empty($course->lang)) {   // Course language is defined
        $CFG->courselang = $course->lang;
    }
    if (!empty($course->theme)) {   // Course language is defined
        $CFG->coursetheme = $course->theme;
    }

    include_once("$CFG->dirroot/lib/phpmailer/class.phpmailer.php");

    if (empty($user)) {
        return false;
    }

    if (!empty($user->emailstop)) {
        return 'emailstop';
    }

    if (over_bounce_threshold($user)) {
        error_log("User $user->id (".fullname($user).") is over bounce threshold! Not sending.");
        return false;
    }

    $mail = new phpmailer;

    $mail->IsMail();                                                         // use PHP mail()
    $mail->Version = "Moodle $CFG->version";                 // mailer version
    $mail->PHPMailer();                                                  // plugin directory (eg smtp plugin)

    if (current_language() != 'en') {
//        $mail->CharSet = get_string('thischarset');
        $mail->CharSet = 'ISO-2022-JP';
    }
    $dbcharset = get_string('thischarset');

/*==================================================
    if ($CFG->smtphosts == 'qmail') {
        $mail->IsQmail();                              // use Qmail system
    } else if (empty($CFG->smtphosts)) {
        $mail->IsMail();                               // use PHP mail() = sendmail
    } else {
        $mail->IsSMTP();                               // use SMTP directly
        if ($CFG->debug > 7) {
            echo '<pre>';
            $mail->SMTPDebug = true;
        }
        $mail->Host = $CFG->smtphosts;               // specify main and backup servers

        if ($CFG->smtpuser) {                          // Use SMTP authentication
            $mail->SMTPAuth = true;
            $mail->Username = $CFG->smtpuser;
            $mail->Password = $CFG->smtppass;
        }
    }
==================================================*/

    $adminuser = get_admin();

    // make up an email address for handling bounces
    if (!empty($CFG->handlebounces)) {
        $modargs = 'B'.base64_encode(pack('V',$user->id)).substr(md5($user->email),0,16);
        $mail->Sender = generate_email_processing_address(0,$modargs);
    } else {
        $mail->Sender = $adminuser->email;
    }
    if (is_string($from)) { // So we can pass whatever we want if there is need
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding($from, 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else if ($usetrueaddress and $from->maildisplay) {
        $mail->From = $from->email;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else {
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from), 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
        if (empty($replyto)) {
            $mail->AddReplyTo($CFG->noreplyaddress,get_string('noreplyname'));
        }
    }
    if (!empty($replyto)) {
        $mail->AddReplyTo($replyto,$replytoname);
    }
    $subject = mb_convert_encoding($subject, 'ISO-2022-JP',$dbcharset);
    $mail->Subject = substr(stripslashes($subject), 0, 900);

    /*
    if (! $kmailuser = get_record('user_profile_sub','userid',$user->id)) {
        $username = fullname($user);
        error("ERROR : kmail user $username");
    }
    */
    $username = mb_encode_mimeheader(mb_convert_encoding(fullname($user),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    // $mail->AddAddress($kmailuser->k_mail,$username);
    $mail->AddAddress($user->email,$username);

    $mail->WordWrap = 79;                               // set word wrap

    if (!empty($from->customheaders)) {                 // Add custom headers
        if (is_array($from->customheaders)) {
            foreach ($from->customheaders as $customheader) {
                $mail->AddCustomHeader($customheader);
            }
        } else {
            $mail->AddCustomHeader($from->customheaders);
        }
    }

    if (!empty($from->priority)) {
        $mail->Priority = $from->priority;
    }

    $messagetext = mb_convert_encoding($messagetext,'JIS',$dbcharset);
    if ($messagehtml && $user->mailformat == 1) { // Don't ever send HTML to users who don't want it
        $mail->IsHTML(true);
        $mail->Encoding = 'quoted-printable';           // Encoding to use
        $mail->Body    =  $messagehtml;
        $mail->AltBody =  "\n$messagetext\n";
    } else {
        $mail->IsHTML(false);
        $mail->Body =  "\n$messagetext\n";
    }

    if ($attachment && $attachname) {
        if (ereg( "\\.\\." ,$attachment )) {    // Security check for ".." in dir path
            $adminname =  mb_convert_encoding(fullname($adminuser),'SIO-2022-JP',$dbcharset);
            $mail->AddAddress($adminuser->email, $adminname);
            $mail->AddStringAttachment('Error in attachment.  User attempted to attach a filename with a unsafe name.', 'error.txt', '8bit', 'text/plain');
        } else {
            require_once($CFG->libdir.'/filelib.php');
            $mimetype = mimeinfo('type', $attachname);
            $mail->AddAttachment($CFG->dataroot .'/'. $attachment, $attachname, 'base64', $mimetype);
        }
    }
    if ($mail->Send()) {
        set_send_count($user);
        return true;

    } else {
        mtrace('ERROR: '. $mail->ErrorInfo);
        add_to_log(SITEID, 'library', 'mailer', $FULLME, 'ERROR: '. $mail->ErrorInfo);
        return false;
    }

}

/**
 * Print visibility setting form element on module setup forms in mod/.../mod.html
 */
function mieattendance_print_visible_setting($form, $course=NULL) {
    if (empty($course)) {
        if (! $course = get_record('course', 'id', $form->course)) {
            error("This course doesn't exist");
        }
    }
    if ($form->coursemodule) {
        $visible = get_field('course_modules', 'visible', 'id', $form->coursemodule);
    } else {
        $visible = true;
    }

    if ($form->mode == 'add') { // in this case $form->section is the section number, not the id
        $hiddensection = !get_field('course_sections', 'visible', 'section', $form->section, 'course', $form->course);
    } else {
        $hiddensection = !get_field('course_sections', 'visible', 'id', $form->section);
    }
    if ($hiddensection) {
        $visible = false;
    }
    
    echo '<tr valign="top">';
    echo '<td align="right"><b>'.get_string('visibletostudents','',get_string('students')).':</b></td>';
    echo '<td align="left">';
    unset($choices);
    $choices[1] = get_string('show');
    $choices[0] = get_string('hide');
    choose_from_menu($choices, 'visible', $visible, '', '', 0, false, $hiddensection);
    echo '</td></tr>';
} 

function mieattendance_encording_internal() {
	$str = '';
	if ( function_exists('mb_internal_encoding') ) {
		$str = mb_internal_encoding();
	}
	return $str;	
}

function mieattendance_encording_convert($str,$encode) {
    if ( function_exists('mb_convert_encoding')) {
        $internalencoding = get_string('thischarset');
        if ( $internalencoding != $encode ) {
            $output = mb_convert_encoding($str,$encode, $internalencoding);
        }
    }
    return $output;
}

function mieattendance_encording_get_list() {
    // check function PHP5.
    if (function_exists('mb_list_encodings')) {
        $list_encoding = mb_list_encodings();
    } else {
        // I use a 'mb_list_encodings()' function in the future. PHP5 
        $list_encoding = array('EUC-JP', 'UTF-8', 'SJIS', 'ISO-2022-JP');
    }
    foreach ($list_encoding as $encode) {
        $encoding[$encode] = $encode; 
    }
    return $encoding;
}

function mieattendance_encording_choose_from_menu ($options, $name, $selected='', $enable='true') {
    $enable = ($enable == 'true') ? '' : 'disabled=disabled"';
    $output = "<select name=\"$name\" $enable>";

    if (!empty($options)) {
        foreach ($options as $value => $label) {
            $output .= "   <option value=\"$value\"";
            if ($value == $selected) {
                $output .= " selected=\"true\"";
            }
            if ($label === "") {
                $output .= ">$value</option>";
            } else {
                $output .= ">$label</option>";
            }
        }
    }
    $output .= '</select>';
    echo $output;
}
/**
 * Determine if there is data waiting to be processed from a form
 *
 * Used on most forms in Moodle to check for data
 * Returns the data as an object, if it's found.
 * This object can be used in foreach loops without
 * casting because it's cast to (array) automatically
 *
 * Checks that submitted POST data exists, and also
 * checks the referer against the given url (it uses
 * the current page if none was specified.
 *
 * @uses $CFG
 * @param string $url the url to compare to referer for secure forms
 * @return boolean
 */
function mieattendance_data_get_submitted() {
    global $CFG;

    if (empty($_GET)) {
        return false;
    } else {
        return (object)$_GET;
    }
}
function mieattendance_logout() {
    global $CFG;
    if (isset($USER) and isset($USER->id)) {
        add_to_log(SITEID, "user", "logout", "view.php?id=$USER->id&course=".SITEID, $USER->id, 0, $USER->id);

        if ($USER->auth == 'cas' && !empty($CFG->cas_enabled)) {
            require($CFG->dirroot.'/auth/cas/logout.php');
        }
    }


    if (ini_get_bool("register_globals") and check_php_version("4.3.0")) {
        // This method is just to try to avoid silly warnings from PHP 4.3.0
        session_unregister("USER");
        session_unregister("SESSION");
    }

    unset($_SESSION['USER']);
    unset($_SESSION['SESSION']);

    unset($SESSION);
    unset($USER);
}

/**
 * Print a self contained form with a single submit button.
 *
 * @param string $link ?
 * @param array $options ?
 * @param string $label ?
 * @param string $method ?
 * @todo Finish documenting this function
 */
function mieattendance_print_single_button($link, $options, $label='OK', $method='get') {
    echo '<form action="'. $link .'" method="'. $method .'">';
    if ($options) {
        foreach ($options as $name => $value) {
            echo '<input type="hidden" name="'. $name .'" value="'. $value .'">';
        }
    }
    echo '<input type="submit" value="'. $label .'"></form>';
}


?>
