<?php // $Id: index.php,v 1.74.2.6 2005/12/12 03:16:42 mjollnir_ Exp $

    $loginguest = optional_param('loginguest', false); // determines whether visitors are logged in as guest automatically

/// Check for timed out sessions
    if (!empty($SESSION->has_timed_out)) {
        $session_has_timed_out = true;
        $SESSION->has_timed_out = false;
    } else {
        $session_has_timed_out = false;
    }
    //HTTPS is potentially required in this page
    httpsrequired();

    $currlang = current_language();
    $langs    = get_list_of_languages();
    $loginsite = get_string("loginsite");
    $loginurl = (!empty($CFG->alternateloginurl)) ? $CFG->alternateloginurl : '';
    $frm = false;
    $user = false;

    if (!empty($SESSION->wantsurl) && file_exists($CFG->dirroot.'/login/weblinkauth.php')) {
        // Handles the case of another Moodle site linking into a page on this site
        include($CFG->dirroot.'/login/weblinkauth.php');
        if (function_exists(weblink_auth)) {
        	$user = weblink_auth($SESSION->wantsurl);
        }
        if ($user) {
        	$frm->username = $user->username;
        } else {
                $frm = mieattendance_data_get_submitted();
        }
    } else {
        // get parameters.
        $frm = mieattendance_data_get_submitted();
    }
/// Check if the user has actually submitted login data to us
    if ($frm) {                             // Login WITH cookies
        $frm->username = trim(moodle_strtolower($frm->username));

        if ($CFG->auth == 'none' && empty($CFG->extendedusernamechars)) {
            $string = eregi_replace("[^(-\.[:alnum:])]", "", $frm->username);
            if (strcmp($frm->username, $string)) {
                $errormsg = get_string('username').': '.get_string("alphanumerical");
                $user = null;
            }
        } 

        //======================================================
        $user = authenticate_user_login($frm->username, $frm->password);
        update_login_count();

        if ($user) {
            if (empty($user->confirmed)) {       // This account was never confirmed
                echo '&nbsp;<font color="red">'.get_string("emailconfirmsent", "", $user->email).'</font><br>';
                $options['func'] = 'login';
                $options['id'] = $session->mieattendanceid;
                $options['key'] = $session->celluserid;

                echo '&nbsp;';
                mieattendance_print_single_button("$CFG->wwwroot/mod/mieattendance/mobiledispatch.php", $options, get_string('again'));
                exit;
            }

            // Let's get them all set up.
            $USER = $user;
            add_to_log(SITEID, 'user', 'login', "view.php?id=$USER->id&course=".SITEID, $USER->id, 0, $USER->id);

            update_user_login_times();
            set_login_session_preferences();

            //Select password change url
            if (is_internal_auth($USER->auth) || $CFG->{'auth_'.$USER->auth.'_stdchangepassword'}){
                $passwordchangeurl=$CFG->wwwroot.'/login/change_password.php';
            } elseif($CFG->changepassword) {
                $passwordchangeurl=$CFG->changepassword;
            } 
            
            // check whether the user should be changing password
            if (get_user_preferences('auth_forcepasswordchange', false) || $frm->password == 'changeme'){
                if (isset($passwordchangeurl)) {
                    redirect($passwordchangeurl);
                } else {
                     echo '&nbsp;<font color="red">You cannot proceed without changing your password. 
                                     However there is no available page for changing it.
                           Please contact your Moodle Administrator.</font><br>';

                     $options['func'] = 'login';
                     $options['id'] = $session->mieattendanceid;
                     $options['key'] = $session->celluserid;

                     echo '&nbsp;';
                     mieattendance_print_single_button("$CFG->wwwroot/mod/mieattendance/mobiledispatch.php", $options, get_string('again'));
                     exit;
               }
            }

            // check if user password has expired
            // Currently supported only for ldap-authentication module
            if (isset($CFG->ldap_expiration) && $CFG->ldap_expiration == 1 ) {
                if (function_exists('auth_password_expire')){
                    $days2expire = auth_password_expire($USER->username);
                    if (intval($days2expire) > 0 && intval($days2expire) < intval($CFG->{$USER->auth.'_expiration_warning'})) {
                        print_header("$site->fullname: $loginsite", "$site->fullname", $loginsite, $focus, "", true, "<div align=\"right\">$langmenu</div>"); 
                        notice_yesno(get_string('auth_passwordwillexpire', 'auth', $days2expire), $passwordchangeurl, $urltogo); 
                        print_footer();
                        exit;
                    } elseif (intval($days2expire) < 0 ) {
                        print_header("$site->fullname: $loginsite", "$site->fullname", $loginsite, $focus, "", true, "<div align=\"right\">$langmenu</div>"); 
                        notice_yesno(get_string('auth_passwordisexpired', 'auth'), $passwordchangeurl, $urltogo);
                        print_footer();
                        exit;
                    }
                }
            }
            reset_login_count();

        } else {
            echo '&nbsp;<font color="red">'.get_string('passwordsdiffer').'</font><br>';

            $options['func'] = 'login';
            $options['id'] = $session->mieattendanceid;
            $options['key'] = $session->celluserid;

            echo '&nbsp;';
            mieattendance_print_single_button("$CFG->wwwroot/mod/mieattendance/mobiledispatch.php", $options, get_string('again'));
            exit;
        }
    }

?>
