<?php
    require_once("../../config.php");
    require_once("lib.php" );
    require_once("$CFG->dirroot/course/lib.php");

    if (! $module = get_record("modules", "id", $cm->module)) {
        error("This module doesn't exist");
    }
    if (! $cw = get_record("course_sections", "id", $cm->section)) {
        error("This course section doesn't exist");
    }

    $sesskey = $USER->sesskey;
    $mode = "update";
    $error = '';
    $options['id'] = $cm->id;
    $options['sesskey'] = $sesskey;

    //==============================================
    // check certification cord.
    //
    if ( !isset($editattend) && ($mieattendance->certificationcord  && isset($checkcode))) {
        if ($mieattendance->certificationcord == $checkcode) {
            $url = "$CFG->wwwroot/mod/$module->name/view.php".
                      "?id=$cm->id&tabid=$tabid&sesskey=$sesskey&editattend=true";
            redirect( $url );
            exit;
        } else {
            $error = '<p><font color="red">'.get_string('err_authentication','mieattendance').'</font></p>';
        }
    }

    $strmodulename = get_string('modulename', $module->name);
    $sectionname = get_string("name$course->format");
    $fullmodulename = strtolower($strmodulename);
    $savechange = get_string('savechanges');
    $strcancel = get_string('cancel');

    if ($cm->section) {
        $heading->what = $fullmodulename;
        $heading->in     = "$sectionname $cw->section";
        $pageheading = get_string("updatingain", "moodle", $heading);
    } else {
        $pageheading = get_string("updatinga", "moodle", $fullmodulename);
    }

    $streditinga = get_string('teacheredit', 'mieattendance');
    $strmodulenameplural = get_string("modulenameplural", $module->name);

    // Show only a teacher UPDATE a button.
    $updatebutton = isteacher($course->id) ? update_module_button($cm->id, $course->id, $strmodulename) : '';

    if ($course->category) {
        print_header("$course->shortname: $streditinga", "$course->fullname",
               "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> -> 
               <a href=\"$CFG->wwwroot/mod/$module->name/index.php?id=$course->id\">$strmodulenameplural</a> -> 
               $streditinga", '', '', false, $updatebutton);
    } else {
        print_header("$course->shortname: $streditinga", "$course->fullname", "$streditinga", '', '', false, $updatebutton);
    }

    // get the list of mieattendance records for all hours of the given day and 
    // put it in the array for use in the mieattendance table
    if (isteacher($course->id)) {
        mieattendance_tab_menu ($TAB_EDIT_MENU_T, $tabid, "view.php?id=$cm->id");
        if ($rolls = get_records('mieattendance_roll', 'dayid', $mieattendance->id)) {
            foreach ($rolls as $roll) {
                $sroll[$roll->userid]->status=$roll->status;
                $sroll[$roll->userid]->notes=$roll->notes;
            }
        }
        $students = mieattendance_get_course_students($course->id, 'u.lastname ASC',$groupid);
    } elseif ( isstudent($course->id) ) {
        mieattendance_tab_menu ($TAB_EDIT_MENU_S, $tabid, "view.php?id=$cm->id");
        if ( $roll = get_record('mieattendance_roll', 'dayid',$mieattendance->id, 'userid', $USER->id)) {
            $sroll[$roll->userid]->status=$roll->status;
            $sroll[$roll->userid]->notes=$roll->notes;
        }
        $students[0] = $USER;
    }

    mieattendance_print_group($course->id, $groupmode);
    print_spacer(10);
    print_simple_box_start ('center','*');
    //========================================================
    // Confirm the limit period when I can input it.
    $timenow = time();
    if ( $mieattendance->timeopen && $mieattendance->timeclose ) {
        $startday = userdate($mieattendance->timeopen, get_string('strftimedate'));
        $endday = userdate($mieattendance->timeclose, get_string('strftimedate'));
        $message = ( $timenow < $mieattendance->timeopen  ) ? get_string('timeopenbefore','mieattendance',$startday) : 
                          (( $timenow > $mieattendance->timeclose ) ? get_string('timecloseafter','mieattendance',$endday) : '');
        if ( !empty($message)) {
            echo '<center><br>'.$message.'<br><br>';
            print_single_button('view.php', $options, get_string('continue'));
            echo '<br></center>';
            /// Finish the page
            print_simple_box_end ();
            print_footer();
            exit;
        }
    }

    if ( !isset($editattend) && $mieattendance->certificationcord ) {
        //======================================================
        // input certification cord.
        //
        $strauthentication    = '&nbsp;&nbsp;&nbsp;'.get_string('authentication','mieattendance').'&nbsp;&nbsp;&nbsp;';
        $strcertificationcord = get_string('certificationcord','mieattendance');

        echo  "<center><form name=\"form\" method=\"post\" action=\"$CFG->wwwroot/mod/$module->name/view.php\">";
        echo $error;
        echo '<table width="380" border="1" valign="top" align="center" cellpadding="5" cellspacing="1" class="generaltable">';
        echo "<tr><td align=\"right\">$strcertificationcord :</td>";
        echo '<td align="left"><input type="password" size="15" name="checkcode" value=""></td></tr>';
        echo '</table><br>';

        // These hidden variables are always the same -->
        echo '<table><tr><td>';
        echo "<input type=\"hidden\" name=\"id\"           value=$cm->id>";
        echo "<input type=\"hidden\" name=\"sesskey\"  value=$sesskey>";
        echo "<input type=\"hidden\" name=\"tabid\"      value=$tabid>";
        echo "<input type=\"submit\" name=\"check\"      value=\"$strauthentication\">&nbsp;";
        echo '</form></td><td>';
        print_single_button('view.php', $options, $strcancel);
        echo '</td></td></table></center>';
    } else {
        //==============================================
        // edit mieattendance.
        //
        echo "<center><form name=\"form\" method=\"post\" action=\"$CFG->wwwroot/mod/$module->name/saveroll.php\">";
        print_heading($mieattendance->name, '', 3);

        // build the table for mieattendance roll
        echo '<table width="*" border="1" valign="top" align="center" cellpadding="5" cellspacing="1" class="generaltable">';
        echo '<tr><td>';
        $strname = get_string('name','mieattendance');
        $strfirstname = get_string('firstname');
        $table->head = array($strname,get_string('presentshort','mieattendance').'&nbsp;'.
                                     get_string('tardyshort','mieattendance').'&nbsp;'.get_string('absentshort','mieattendance'));
        $table->align = array('left', 'center');
        $table->wrap = array('nowrap', 'nowrap');
        $table->width = '100%';
        $table->size = array ('*','*');

        $states = array( ATTEND_PRESENT => get_string('presentshort','mieattendance'),
                                  ATTEND_TARDY => get_string('tardyshort','mieattendance'),
                                  ATTEND_ABSENT => get_string('absentshort','mieattendance'));
        if ($students) {
            foreach ($students as $student) {
                $selected = isset($sroll[$student->id]) ? $sroll[$student->id]->status : $CFG->mieattendance_default_student_status;
                $name = "student_".$student->id;
                $radio =  mieattendance_choose_from_radio($states, $name, $selected);
                $strstudentname = fullname($student);
                $table->data[]=array($strstudentname, $radio);
            }
            mieattendance_print_table($table);
        }

        echo '</td></tr></table>';
         // These hidden variables are always the same -->
        echo "<input type=\"hidden\" name=\"course\"              value=$course->id>";
        echo "<input type=\"hidden\" name=\"coursemodule\"   value=$cm->id>";
        echo "<input type=\"hidden\" name=\"section\"             value=$cm->section>";
        echo "<input type=\"hidden\" name=\"module\"            value=$module->id>";
        echo "<input type=\"hidden\" name=\"modulename\"    value=$module->name>";
        echo "<input type=\"hidden\" name=\"instance\"           value=$cm->instance>";
        echo "<input type=\"hidden\" name=\"mode\"               value=$mode>";
        echo "<input type=\"hidden\" name=\"sesskey\"            value=$sesskey>";
        echo '<br><table border="0"><tr><td>';
        echo "<input type=\"submit\" value=\"$savechange\"></form></td><td>";
        print_single_button('view.php', $options, $strcancel);
        echo '</td></tr></table></center>';
    }
    print_simple_box_end ();

   /// Finish the page
    print_footer();

?>
