<?php
    require_once('../../config.php');
    require_once('lib.php' );
    require_once($CFG->dirroot.'/course/lib.php');

    if (! $module = get_record('modules', 'id', $cm->module)) {
        error("This module doesn't exist");
    }

    if (!isteacher($course->id)) {
        error("You can't modify this record!");
    }

    $mode             = 'update';
    $sesskey          = $USER->sesskey;

    $sectionname = get_string("name$course->format");
    $fullmodulename = strtolower(get_string('modulename', $module->name));
    $strmailto = get_string('mailtostudents', 'mieattendance');
    $strmodulenameplural = get_string('modulenameplural', $module->name);
    $strsend = get_string('send','mieattendance');
    $strnoticemail = get_string('registrationemail');
    $strcancel = get_string('cancel');
    if ($course->category) {
        print_header("$course->shortname: $strmailto", "$course->fullname",
               "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> -> 
               <a href=\"$CFG->wwwroot/mod/$module->name/index.php?id=$course->id\">$strmodulenameplural</a> -> 
               $strmailto", '', '', false, update_module_button($cm->id, $course->id, $fullmodulename));
    } else {
        print_header("$course->shortname: $streditinga", "$course->fullname", "$streditinga", '', '', false, update_module_button($cm->id, $course->id, $fullmodulename));
    }

    if (isteacher($course->id)) {
        mieattendance_tab_menu($TAB_EDIT_MENU_T, $tabid, 'view.php?id='.$id);
        $rolls = get_records('mieattendance_roll', 'dayid', $mieattendance->id);
    } else if (isstudent($course->id)) {    // visible and a student
        mieattendance_tab_menu($TAB_EDIT_MENU_S, $tabid, 'view.php?id='.$id);
        $sql = "SELECT * FROM {$CFG->prefix}attendance_roll ar  WHERE ar.dayid = '$mieattendance->id' AND ar.userid, '$USER->id'";
        $rolls = get_records_sql( $sql );
    } else {
        notice(get_string('noviews', 'mieattendance'));
        print_footer($course); exit;
    }

    //========================================================
    // Confirm the limit period when I can input it.
    $timenow = time();
    if ( $mieattendance->timeopen && $mieattendance->timeclose ) {
        $endday = userdate($mieattendance->timeclose, get_string('strftimedate'));
        $message = ( $timenow > $mieattendance->timeclose ) ? get_string('timecloseafter','mieattendance',$endday) : '';
        if ( !empty($message)) {
            print_simple_box_start('center','*');
            echo '<center><br>'.$message.'<br><br>';
            $options['id'] = $cm->id;
            $options['sesskey'] = $sesskey;
            print_single_button($CFG->wwwroot.'/mod/'.$module->name.'/view.php?id='.$cm->id, $options, get_string('continue'));
            echo '<br></center>';
            /// Finish the page
            print_simple_box_end ();
            print_footer();
            exit;
        }
    }

    if ( !isset($sendto) && !isset($confir) ) {
        mieattendance_print_group($course->id, $groupmode);
        print_simple_box_start('center','*');
        //=======================================================
        $strattendname = get_string('fullname');
        $strgroup = get_string('group');
        $strsend = get_string('send','mieattendance');
        $strhours = get_string('confirmationtime','mieattendance');
        $strscheduleid  = get_string('classscheduleid','mieattendance');

        $table->head = array($strattendname,$strscheduleid,$strhours);
        $table->align = array('left', 'left', 'left');
        $table->wrap = array('nowrap', 'nowrap', 'nowrap');
        $table->width = '100%';
        $table->size = array ('*','*','*');
        $table->border = 1;

        $strconfirmationtime = userdate($mieattendance->timeopen, get_string('strftimetime')).
                                     ' - '.userdate($mieattendance->timeclose, get_string('strftimetime'));
        $code = !empty($mieattendance->certificationcord) ? ' ('.$mieattendance->certificationcord.')' : 
                                                                       ' ('.get_string('certificationcord','mieattendance').get_string('none').')';
        $table->data[]=array($mieattendance->name.$code, $mieattendance->scheduleid, $strconfirmationtime);
        mieattendance_print_table($table);

        //=======================================================
        echo "<center><form name=\"form\" method=\"post\" action=\"$CFG->wwwroot/mod/mieattendance/view.php\">";
        // These hidden variables are always the same -->
        echo "<input type=\"hidden\" name=\"course\"              value=$course->id>";
        echo "<input type=\"hidden\" name=\"id\"                     value=$cm->id>";
        echo "<input type=\"hidden\" name=\"instance\"           value=$cm->instance>";
        echo "<input type=\"hidden\" name=\"section\"             value=$cm->section>";
        echo "<input type=\"hidden\" name=\"module\"            value=$module->id>";
        echo "<input type=\"hidden\" name=\"modulename\"    value=$module->name>";
        echo "<input type=\"hidden\" name=\"mode\"               value=$mode>";
        echo "<input type=\"hidden\" name=\"tabid\"                value=$tabid>";
        echo "<input type=\"hidden\" name=\"sesskey\"            value=$sesskey>";
        echo '<br><table border="0"><tr><td>';
        echo "<input type=\"submit\" name=\"sendto\" value=\"$strnoticemail\"></form></td><td>";
        $option['id'] = $cm->id;
        $option['sesskey'] = $sesskey;
        print_single_button('view.php', $option, $strcancel);
        echo '</td></tr></table></center>';
        print_simple_box_end();

    } elseif ( isset($sendto) ) {

        mieattendance_print_group($course->id, $groupmode);
        print_simple_box_start('center','*');
        //======================================================
        // 1. get user information.
        if (! $students = mieattendance_get_course_students($course->id, 'u.id ASC', $groupid)) {
            notice(get_string('notuser','mieattendance'),"view.php?id=$cm->id&sesskey=$sesskey");
        }
	/*
        // check mail address.
        $cnt = 0;
        $tmp = '';
        foreach( $students as $student ) {
            $profilesub = get_record('user_profile_sub', 'userid', $student->id);
            if (!$profilesub || !$profilesub->k_mail ) {
                $name = fullname($student);
                if ( $cnt == 4 ) {
                    $tmp .= ' '.$name.'<br>';
                } else {
                    $tmp .= !$cnt  ? $name : ', '.$name;
                }
                $cnt = ( $cnt < 4 ) ? ($cnt + 1) : 0;
            }
        }
        if ( !empty( $tmp )) {
            $output = '<center>'.$tmp.'<br><br><b>'.get_string('notaddress','mieattendance').'</b><br>';
            notice( $output,"view.php?id=$cm->id&sesskey=$sesskey");
        }
        */

        //=======================================================
        $strname = get_string('name','mieattendance');
        $strgroup = get_string('group');
        $strsend = get_string('send','mieattendance');
        $strhours = get_string('confirmationtime','mieattendance');
        $strscheduleid  = get_string('classscheduleid','mieattendance');

        $table->head = array($strname);
        $table->align = array('left');
        $table->wrap = array('nowrap');
        $table->width = '80%';
        $table->size = array ('*');
        $table->border = 1;
        foreach ( $students as $student ) {
             $table->data[] = array(fullname($student));
        }
        mieattendance_print_table($table);
        
        //=======================================================
        echo "<center><form name=\"form\" method=\"post\" action=\"$CFG->wwwroot/mod/mieattendance/view.php\">";
        // These hidden variables are always the same -->
        echo "<input type=\"hidden\" name=\"course\"              value=$course->id>";
        echo "<input type=\"hidden\" name=\"id\"                    value=$cm->id>";
        echo "<input type=\"hidden\" name=\"instance\"           value=$cm->instance>";
        echo "<input type=\"hidden\" name=\"section\"             value=$cm->section>";
        echo "<input type=\"hidden\" name=\"module\"            value=$module->id>";
        echo "<input type=\"hidden\" name=\"modulename\"    value=$module->name>";
        echo "<input type=\"hidden\" name=\"mode\"               value=$mode>";
        echo "<input type=\"hidden\" name=\"tabid\"                value=$tabid>";
        echo "<input type=\"hidden\" name=\"sesskey\"            value=$sesskey>";
        echo '<br />';
        echo "<input type=\"submit\" name=\"confir\" value=\"$strsend\">&nbsp;";
        echo "<input type=\"submit\" name=\"cancel\" value=\"$strcancel\">";
        echo '</td></tr></center></form>';
        print_simple_box_end();

    } elseif ( isset($confir) ) {

        mieattendance_print_group($course->id, $groupmode);

        //======================================================
        // 1. get user information.
        $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);

        // 2. sendmail
        $oldsettime = ini_get('max_execution_time');
        ini_set('max_execution_time','3600');
        $cnt = $sendcnt = 0;

        echo '<center><br><br><b>'.get_string('waitmessages','mieattendance').'</b><br><br>';
        foreach($students as $student) {
            $to_name = fullname($student);
            $subject = $mieattendance->notes;
            $url = "$CFG->wwwroot/mod/mieattendance/mobiledispatch.php?id=$mieattendance->id&key=$student->id";
            $messagetext = get_string('href','mieattendance')."\n\n".$url;

            if (false === mieattendance_email_to_user($student, '', $subject, $messagetext) ) {
                echo "<font color=\"red\"><br>ERROR : </font> $to_name<br>";
            } else {
                if ( $cnt == 4 ) {
                    echo " $to_name <br>";
                } else {
                    $msg = !$cnt  ? "$to_name" : ", $to_name";
                    echo $msg;
                }
                $sendcnt++;
            }
            $cnt = ( $cnt < 4 ) ? ($cnt + 1) : 0;
        }
        ini_set('max_execution_time',$oldsettime);

        echo '<br><br><b>'.get_string('total').':&nbsp;'.$sendcnt.'</b><br><br>';

        echo "<a href=\"view.php?id=$cm->id&sesskey=$sesskey\">".get_string('emailsuccess','mieattendance').'</a>';
        echo '</center><br>';
    }

    /// Finish the page
    print_footer();

?>
