<?php
    /// Print the report of the page
    $selectgroup = ($groupmode && $groupid) ? " AND a.groupid = '$groupid' " : '';
    $selectscheduleid = $mieattendance->scheduleid ? " AND  a.scheduleid = '$mieattendance->scheduleid'" : '';

    $sql = "SELECT * FROM {$CFG->prefix}mieattendance a 
                                 WHERE a.course = $course->id $selectgroup $selectscheduleid 
                                 ORDER BY a.day ASC";

    if ($mieattendances = get_records_sql( $sql )) {
        /// create an array of all the mieattendance objects for the entire course
        $numatt = $numhours = 0;
        if ($mieattendances) {
            foreach ($mieattendances as $attmie) {
                // store the raw mieattendance object
                $cm = get_coursemodule_from_instance('mieattendance', $attmie->id, $course->id);
                $attmie->cmid = $cm->id;
                $atts[$numatt]->mieattendance = $attmie;
                // put it in the array for use in the mieattendance table
                if (isstudent($course->id) && !isteacher($course->id)) { 
                    $rolls[0] = get_record('mieattendance_roll', 'dayid', $attmie->id, 'userid', $USER->id);
                } else { // must be a teacher
                    $rolls = get_records('mieattendance_roll', 'dayid', $attmie->id);
                }
                if ($rolls) {
                    foreach ($rolls as $roll) {
                        $atts[$numatt]->sroll[$roll->userid]->status=$roll->status;
                        $atts[$numatt]->sroll[$roll->userid]->notes=$roll->notes;
                    }
                }
                $numatt++;
            }
        }
    } else {
        error("There are no mieattendance rolls in this course.");
    }

    //  IF REQUESTING A DATA FILE DOWNLOAD, GENERATE IT INSTEAD OF THE HTML PAGE, SEND IT, AND EXIT
    if ( isteacher($course->id)) include('downloadreport.php');

    // FIGURE OUT THE PAGING LAYOUT FOR THE DATA BASED ON STATUS, PAGE NUMBER REQUESTED, ETC
    // A LOOP FOR CREATING SINGLE-USER VERSION OF THE REPORT OR A ONE-PAGE REPORT
    if (isstudent($course->id) && !isteacher($course->id)) {
        $onepage=true;
        $multipage=false; 
    } else if (!(isset($onepage))){
        $onepage=false;
        $multipage=true;
    } else if ($onepage) {
        $multipage=false;
    } else {  // if onepage is set to false
        $multilpage=true;
    }

    // adjust the width for the report for students 
    if (!empty($onetable) || ($CFG->mieattendance_hours_in_full_report == 0)) {
        $hoursinreport = 100+$numhours;
    } else if (isstudent($course->id) && !isteacher($course->id)) {
        $hoursinreport = $CFG->mieattendance_hours_in_full_report + 15;
    } else { 
        $hoursinreport = $CFG->mieattendance_hours_in_full_report;
    }
    while (($multipage || $onepage) && empty($endonepage)) {
        // this makes for a one iteration loop for multipage
        if ($multipage) {$onepage = false; $multipage = false; $endonepage=false;}
        if ($numhours >= $hoursinreport) {
            if ( !isset($pagereport) ) {
                $pagereport=true; $page=1;
           }
           // find the last hour to have on this page of the report
           // go to the next (or first) page
           $curpage=1;
           $endatt=0;
           for ( $curpage=1; true; $curpage++) {
                $pagehours= $atts[$endatt]->mieattendance->hours;
                $startatt=$endatt;
                while($pagehours<=$hoursinreport) {
                   if ($endatt>=$numatt) { break; }
                   $endatt++;
                   $pagehours=$pagehours+$atts[$endatt]->mieattendance->hours;
                }
                // if this is the page we're on, save the info
                if ($curpage == $page) {$endatt_target = $endatt; $startatt_target = $startatt; }
            }
            if ($curpage == $page) {$endatt_target = $endatt; $startatt_target = $startatt; } 
            else { $endatt=$endatt_target; $startatt=$startatt_target; }
            $maxpages = $curpage;
        } else {$pagereport=false;}

        $minatt=($pagereport ? $startatt : 0);
        $maxatt=($pagereport ? $endatt : $numatt);

        if (!$pagereport || ($page == $maxpages)) {$endonepage = true;}  // end a one page display

        //  ALL PRELIMINARY STUFF DONE - MAKE THE MEAT OF THE PAGE
        //
        mieattendance_print_header();
        if (isteacher($course->id)) {
            $tabmenu = $mieattendance->autoattend ? $TAB_EDIT_MENU_AUTO_T : $TAB_EDIT_MENU_T;
            mieattendance_tab_menu($tabmenu, $tabid, "view.php?id=$id");
        } else if (isstudent($course->id)) {    // visible and a student
            $tabmenu = $mieattendance->autoattend ? $TAB_EDIT_MENU_AUTO_S : $TAB_EDIT_MENU_S;
            mieattendance_tab_menu($tabmenu, $tabid, "view.php?id=$id");
        } else {
            notice(get_string("noviews", "mieattendance"));
            print_footer($course); exit;
        }
        mieattendance_print_group($course->id, $groupmode);
        if ( $mieattendance->autoattend ) {
            echo '<center><b>'.get_string('entrymethod','mieattendance').':</b>&nbsp;'.get_string('autoattend','mieattendance');
            if ($mieattendance->timeclose < time()) {
                $endday = userdate($mieattendance->timeclose, get_string('strftimedatetime'));
                echo '<br><font color="red">'.get_string('timecloseafter', 'mieattendance', $endday).'</font>'; 
            }
            echo '</center>';
        }
        print_spacer(25);

        if (!$onepage) {
            mieattendance_print_pagenav(); 
        }

        // TABLE Header.--------------------------------------------------------
        $tableheads[] = get_string('name','mieattendance'); $tablealigns[] = 'left'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';
        $tableheads[] = get_string('identifier','mieattendance'); $tablealigns[] = 'center'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';

        for ($i=$minatt ;$i<$maxatt ;$i++) {
            $notes = ($atts[$i]->mieattendance->notes != "") ? ":<br>".$atts[$i]->mieattendance->notes : '';
            $auto = ($atts[$i]->mieattendance->autoattend == 1) ? "(".get_string("auto","mieattendance").")" : '';
            $cmid = $atts[$i]->mieattendance->cmid;
            $tableheads[] = "<a href=\"view.php?id=$cmid\">".userdate($atts[$i]->mieattendance->day,"%m/%0d")."</a>$auto$notes";
            $tablealigns[] = 'left'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';
        }
        // if we're at the end of the report
        if (($maxatt==$numatt) || !$pagereport) {
            

            $tableheads[] = get_string('total').'<br>'.helpbutton('total','', 'mieattendance','true','false','',true);
            $tablealigns[] = 'center'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';
        }

        // TABLE data ----------------------------------------------------------
        if (isstudent($course->id) && !isteacher($course->id)) { 
            $students[0] = $USER;
        } else { // must be a teacher
            $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);
        }
        $A = get_string('absentshort','mieattendance');
        $T = get_string('tardyshort','mieattendance');
        $P = get_string('presentshort','mieattendance');
        $N = get_string('nonentryshort','mieattendance');

        if ($students) {
            foreach ($students as $student) {
                $data[] = fullname($student);
                $data[] = $student->idnumber ? $student->idnumber : "&nbsp";
                // set the mieattendance defaults for each student
                $abs = $tar = 0;
                for( $i=$minatt; $i<$maxatt; $i++) {
                    $status =  isset ($atts[$i]->sroll[$student->id]) ?
                                          $atts[$i]->sroll[$student->id]->status : $CFG->mieattendance_default_student_status;
                    switch ( $status ) {
                        case ATTEND_PRESENT: $data[] = $P; break;
                        case ATTEND_TARDY:    $data[] = $T; $tar++; break;
                        case ATTEND_ABSENT:   $data[] = $A; $abs++; break;
                        case ATTEND_NONFIX:   $data[] = $N; break;
                    }
                }
                if ($maxatt==$numatt || !$pagereport) {
                    $data[] = mieattendance_tally_overall_absences_fraction($abs,$tar); 
                }
                $tabledatas[] = $data;
                unset($data);
            }
        }
        $table->head  = $tableheads;
        $table->align  = $tablealigns;
        $table->valign = $tablevaligns;
        $table->wrap  = $tablewraps;
        $table->width = '*';
        $table->size    = $tablesizes;
        $table->data   = empty($tabledatas) ? '' : $tabledatas;
        mieattendance_print_table($table);

        if ($onepage) {
            $page++;
            echo '<br><br>';
        }
    }

    if (!$onepage) { mieattendance_print_pagenav(); }

    if ( $CFG->mieattendance_tardies_per_absence ) {
        echo "<center>".get_string('tardiesperabs','mieattendance',$CFG->mieattendance_tardies_per_absence);
    }

    if ( isteacher($course->id))  {
        echo '<form name="form" method="post" action="view.php">';
        echo '<center><table border=0 align=CENTER>';
        echo '<tr><td colspan="2" align="center">';
        $selected = mieattendance_encording_internal();
        $options = mieattendance_encording_get_list();
        $strencode = get_string('selectencode','mieattendance');
        echo "<b>$strencode &nbsp;: &nbsp;</b>";
        mieattendance_encording_choose_from_menu($options, 'encode', $selected, 'true');
        helpbutton('encode', get_string('selectencode','mieattendance'), 'mieattendance');

        echo '</td></tr>';
        echo '<tr><td>';
        $strxls = get_string('downloadexcelfull', 'mieattendance');
        echo "<input type=\"hidden\" name=\"id\"                 value=$id>";
        echo "<input type=\"hidden\" name=\"download\"      value=\"xls\">";
        echo "<input type=\"hidden\" name=\"dlsub\"          value=\"all\">";
        echo "<input type=\"hidden\" name=\"tabid\"          value=$tabid>";
        echo "<input type=\"submit\" name=\"excel\" value=\"$strxls\">";
        echo '</td><td>';
        $strtxt = get_string('downloadtextfull', 'mieattendance');
        echo "<input type=\"hidden\" name=\"id\"                 value=$id>";
        echo "<input type=\"hidden\" name=\"download\"      value=\"txt\">";
        echo "<input type=\"hidden\" name=\"dlsub\"          value=\"all\">";
        echo "<input type=\"hidden\" name=\"tabid\"          value=$tabid>";
        echo "<input type=\"submit\" name=\"text\" value=\"$strtxt\">";
        echo '</td></tr></table></center></form>';
    }
    /// Finish the page
    print_footer();

//================================================

function mieattendance_print_header() {
    global $course, $cm, $CFG;

    /// Print the page header
    if (! $module = get_record("modules", "id", $cm->module)) {
        error("This module doesn't exist");
    }

    $strmodulename = get_string('modulename','mieattendance');
    $strreports = get_string('reports','mieattendance');
    $strmodulenameplural = get_string('modulenameplural', $module->name);

    // Show only a teacher UPDATE a button.
    $updatebutton = isteacher($course->id) ? update_module_button($cm->id, $course->id, $strmodulename) : '';

    if ($course->category) {
        print_header("$course->shortname: $strreports", "$course->fullname",
               "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> -> 
               <a href=\"$CFG->wwwroot/mod/$module->name/index.php?id=$course->id\">$strmodulenameplural</a> -> 
               $strreports", '', '', false , $updatebutton);
    } else {
        print_header("$course->shortname: $strreports", "$course->fullname", 
		                            "$strreports", '', '', false, $updatebutton);
    }
}

function mieattendance_print_pagenav() {
    global $pagereport, $minatt, $maxatt, $course, $page, $numatt, $maxpages;
    if ($pagereport) {
        $of = get_string('of','mieattendance');
        $pg = get_string('page');

        echo "<center><table align=\"center\" width=\"80\" class=\"generalbox\"".
             "border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>".
             "<td bgcolor=\"#ffffff\" class=\"generalboxcontent\">";
        // this is the main table
        echo "<table width=\"100%\" border=\"0\" valign=\"top\" align=\"center\" ".
             "cellpadding=\"5\" cellspacing=\"1\" class=\"generaltable\">";
        echo "<tr>";
        if ($minatt!=0) {
            echo "<th valign=\"top\" align=\"right\" nowrap class=\"generaltableheader\">".
               "<a href=\"viewall.php?id=".$course->id ."&amp;pagereport=1&amp;page=1\">&lt;&lt;</a>&nbsp;\n".
               "<a href=\"viewall.php?id=".$course->id ."&amp;pagereport=1&amp;page=".($page-1)."\">&lt;</a></th>\n";
        } else {
            echo "<th valign=\"top\" align=\"right\" nowrap class=\"generaltableheader\">&lt;&lt;&nbsp;&lt;</th>\n";
        }
        echo "<th valign=\"top\" align=\"right\" nowrap class=\"generaltableheader\">".
               "$pg $page $of $maxpages</th>\n";
        if ($maxatt!=$numatt) {
            echo "<th valign=\"top\" align=\"right\" nowrap class=\"generaltableheader\">".
                "<a href=\"viewall.php?id=".$course->id ."&amp;pagereport=1&amp;page=". ($page+1)."\">&gt;</a>&nbsp;".
                "<a href=\"viewall.php?id=".$course->id ."&amp;pagereport=1&amp;page=$maxpages\">&gt;&gt;</a></th>";
        } else {
            echo "<th valign=\"top\" align=\"right\" nowrap class=\"generaltableheader\">&gt;&nbsp;&gt;&gt;</th>\n";
        }
        echo "</tr></table></td></tr></table></center>\n";
    }
}

?>

