<?php
    /// Print the page header

    if (! $module = get_record('modules', 'id', $cm->module)) {
        error("This module doesn't exist");
    }

    $strmodulename = get_string('modulename','mieattendance');
    $strsituation = $strmodulename.get_string('situation','mieattendance');
    $strmodulenameplural = get_string('modulenameplural', $module->name);

    // Show only a teacher UPDATE a button.
    $updatebutton = isteacher($course->id) ? update_module_button($cm->id, $course->id, $strmodulename) : '';

    if ($course->category) {
        print_header("$course->shortname: $strsituation", "$course->fullname",
               "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> -> 
               <a href=\"$CFG->wwwroot/mod/$module->name/index.php?id=$course->id\">$strmodulenameplural</a> -> 
               $strsituation", '', '', false, $updatebutton);
    } else {
        print_header("$course->shortname: $strsituation", "$course->fullname", "$strsituation", '', '', false, $updatebutton);
    }

    if (isteacher($course->id)) {
        $tabmenu = $mieattendance->autoattend ? $TAB_EDIT_MENU_AUTO_T : $TAB_EDIT_MENU_T;
        mieattendance_tab_menu($tabmenu, $tabid, "view.php?id=$id");
        if ($rolls = get_records('mieattendance_roll', 'dayid', $mieattendance->id)) {
            foreach ($rolls as $roll) {
                $sroll[$roll->userid]->status=$roll->status;
                $sroll[$roll->userid]->notes=$roll->notes;
            }
        }
        $students = mieattendance_get_course_students($course->id, 'u.lastname ASC', $groupid);
    } else if (isstudent($course->id)) {    // visible and a student
        $tabmenu = $mieattendance->autoattend ? $TAB_EDIT_MENU_AUTO_S : $TAB_EDIT_MENU_S;
        mieattendance_tab_menu($tabmenu, $tabid, "view.php?id=$id");
        if ( $roll = get_record('mieattendance_roll', 'dayid',$mieattendance->id, 'userid', $USER->id)) {
            $sroll[$roll->userid]->status=$roll->status;
            $sroll[$roll->userid]->notes=$roll->notes;
        }
        $students[0] = $USER;
    } else {
        notice(get_string("noviews", "mieattendance"));
        print_footer($course); exit;
    }

    mieattendance_print_group($course->id, $groupmode);

    if ( $mieattendance->autoattend ) {
        echo '<center><b>'.get_string('entrymethod','mieattendance').':</b>&nbsp;'.get_string('autoattend','mieattendance');
        if ($mieattendance->timeclose < time()) {
            $endday = userdate($mieattendance->timeclose, get_string('strftimedatetime'));
            echo '<br><font color="red">'.get_string('timecloseafter', 'mieattendance', $endday).'</font>'; 
        }
        echo '</center>';
    }
    print_spacer(25);
    print_simple_box_start ('center','*');

    // print the date headings at the top of the table
    // print the second level headings with name and possibly hour numbers
    $tableheads[] = get_string('name','mieattendance'); $tablealigns[] = 'left'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';
    $tableheads[] = get_string('identifier','mieattendance'); $tablealigns[] = 'center'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';
    // generate the headers for the mieattendance
    $tableheads[] = userdate($mieattendance->day,get_string("strftimedateshort")).'<br>'.$mieattendance->notes;
    $tablealigns[] = 'center'; $tablevaligns[] ='middle'; $tablewraps[] = 'nowrap'; $tablesizes[] = '*';

    // get the list of students along with student ID field
    // get back array of stdclass objects in sorted order, with members:
    // id, username,firstname,lastname,maildisplay,mailformat,email,city,country,
    //     lastaccess,lastlogin,picture (picture is null, 0, or 1), idnumber
    $i=0;
    $A = get_string('absentshort','mieattendance');
    $T = get_string('tardyshort','mieattendance');
    $P = get_string('presentshort','mieattendance');

    if ($students) {
        foreach ($students as $student) {
            $studentid=(($student->idnumber != "") ? $student->idnumber : "&nbsp");
            $data[] = fullname($student);
            $data[] = $studentid;
            // set the mieattendance defaults for each student
            $status = isset ($sroll[$student->id]) ? $sroll[$student->id]->status : $CFG->mieattendance_default_student_status;
            switch ( $status ) {
                case ATTEND_PRESENT: $data[] = $P; break;
                case ATTEND_TARDY:    $data[] = $T; break;
                case ATTEND_ABSENT:  $data[] = $A; break;
            }
            $tabledatas[] = $data;
            unset($data);
        }
    }
     // this is the main table
    $table->head  = $tableheads;
    $table->align  = $tablealigns;
    $table->valign = $tablevaligns;
    $table->wrap  = $tablewraps;
    $table->width = '80%';
    $table->size    = $tablesizes;
    $table->data   = empty($tabledatas) ? '' : $tabledatas;
    mieattendance_print_table($table);

    $options['id'] = $course->id;
    $options['sesskey'] = $USER->sesskey;
    echo '<center>';
    print_single_button($CFG->wwwroot.'/course/view.php', $options, get_string('back','mieattendance'));
    echo '</center>';

    /// ending for the table
    print_simple_box_end ();

   /// Finish the page
    print_footer();

?>
