<?php //$Id: backuplib.php,v 1.9 2005/07/04 18:55:58 stronk7 Exp $
    //This php script contains all the stuff to backup/restore
    //miechoice mods

    //This is the "graphical" structure of the miechoice mod:
    //
    //                      miechoice
    //                    (CL,pk->id)----------|
    //                        |                |
    //                        |                |
    //                        |                |
    //                  miechoice_options         |
    //             (UL,pk->id, fk->miechoiceid)   |  
    //                        |                |
    //                        |                |
    //                        |                |
    //                   miechoice_answers        |
    //        (UL,pk->id, fk->miechoiceid, fk->optionid)     
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    function miechoice_backup_mods($bf,$preferences) {
        
        global $CFG;

        $status = true;

        //Iterate over miechoice table
        $miechoices = get_records ("miechoice","course",$preferences->backup_course,"id");
        if ($miechoices) {
            foreach ($miechoices as $miechoice) {
                //Start mod
                fwrite ($bf,start_tag("MOD",3,true));
                //Print miechoice data
                fwrite ($bf,full_tag("ID",4,false,$miechoice->id));
                fwrite ($bf,full_tag("MODTYPE",4,false,"miechoice"));
                fwrite ($bf,full_tag("GROUPID",4,false,$miechoice->groupid));
                fwrite ($bf,full_tag("NAME",4,false,$miechoice->name));
                fwrite ($bf,full_tag("TEXT",4,false,$miechoice->text));
                fwrite ($bf,full_tag("FORMAT",4,false,$miechoice->format));
                fwrite ($bf,full_tag("PUBLISH",4,false,$miechoice->publish));
                fwrite ($bf,full_tag("RLSRESULT",4,false,$miechoice->rlsresult));
                fwrite ($bf,full_tag("DISPLAY",4,false,$miechoice->display));
                fwrite ($bf,full_tag("ALLOWUPDATE",4,false,$miechoice->allowupdate));
                fwrite ($bf,full_tag("SHOWUNANSWERED",4,false,$miechoice->showunanswered));
                fwrite ($bf,full_tag("LIMITANSWERS",4,false,$miechoice->limitanswers));
                fwrite ($bf,full_tag("TIMEOPEN",4,false,$miechoice->timeopen));
                fwrite ($bf,full_tag("TIMECLOSE",4,false,$miechoice->timeclose));
                fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$miechoice->timemodified));

                //Now backup miechoice_options
                $status = backup_miechoice_options($bf,$preferences,$miechoice->id);

                //if we've selected to backup users info, then execute backup_miechoice_answers
                if ($preferences->mods["miechoice"]->userinfo && $status) {
                    $status = backup_miechoice_answers($bf,$preferences,$miechoice->id);
                }
                //End mod
                $status =fwrite ($bf,end_tag("MOD",3,true));
            }
        }
        return $status;
    }

    //Backup miechoice_answers contents (executed from miechoice_backup_mods)
    function backup_miechoice_answers ($bf,$preferences,$miechoice) {

        global $CFG;

        $status = true;

        $miechoice_answers = get_records("miechoice_answers","miechoiceid",$miechoice,"id");
        //If there is answers
        if ($miechoice_answers) {
            //Write start tag
            $status =fwrite ($bf,start_tag("ANSWERS",4,true));
            //Iterate over each answer
            foreach ($miechoice_answers as $cho_ans) {
                //Start answer
                $status =fwrite ($bf,start_tag("ANSWER",5,true));
                //Print answer contents
                fwrite ($bf,full_tag("ID",6,false,$cho_ans->id));
                fwrite ($bf,full_tag("USERID",6,false,$cho_ans->userid));
                fwrite ($bf,full_tag("OPTIONID",6,false,$cho_ans->optionid));
                fwrite ($bf,full_tag("TIMEMODIFIED",6,false,$cho_ans->timemodified));
                //End answer
                $status =fwrite ($bf,end_tag("ANSWER",5,true));
            }
            //Write end tag
            $status =fwrite ($bf,end_tag("ANSWERS",4,true));
        }
        return $status;
    }


    //backup miechoice_options contents (executed from miechoice_backup_mods)
    function backup_miechoice_options ($bf,$preferences,$miechoice) {

        global $CFG;

        $status = true;
        
        $miechoice_options = get_records("miechoice_options","miechoiceid",$miechoice,"id");
        //If there is options
        if ($miechoice_options) {            
            //Write start tag
            $status =fwrite ($bf,start_tag("OPTIONS",4,true));
            //Iterate over each answer
            foreach ($miechoice_options as $cho_opt) {
                //Start option
                $status =fwrite ($bf,start_tag("OPTION",5,true));
                //Print option contents
                fwrite ($bf,full_tag("ID",6,false,$cho_opt->id));
                fwrite ($bf,full_tag("TEXT",6,false,$cho_opt->text));
                fwrite ($bf,full_tag("MAXANSWERS",6,false,$cho_opt->maxanswers));
                fwrite ($bf,full_tag("TIMEMODIFIED",6,false,$cho_opt->timemodified));
                //End answer
                $status =fwrite ($bf,end_tag("OPTION",5,true));
            }
            //Write end tag
            $status =fwrite ($bf,end_tag("OPTIONS",4,true));
        }
        return $status;
    }
   
   ////Return an array of info (name,value)
   function miechoice_check_backup_mods($course,$user_data=false,$backup_unique_code) {
        //First the course data
        $info[0][0] = get_string("modulenameplural","miechoice");
        if ($ids = miechoice_ids ($course)) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        //Now, if requested, the user_data
        if ($user_data) {
            $info[1][0] = get_string("responses","miechoice");
            if ($ids = miechoice_answer_ids_by_course ($course)) {
                $info[1][1] = count($ids);
            } else {
                $info[1][1] = 0;
            }
        }
        return $info;
    }

    //Return a content encoded to support interactivities linking. Every module
    //should have its own. They are called automatically from the backup procedure.
    function miechoice_encode_content_links ($content,$preferences) {

        global $CFG;

        $base = preg_quote($CFG->wwwroot,"/");

        //Link to the list of miechoices
        $buscar="/(".$base."\/mod\/miechoice\/index.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@MIECHOICEINDEX*$2@$',$content);

        //Link to miechoice view by moduleid
        $buscar="/(".$base."\/mod\/miechoice\/view.php\?id\=)([0-9]+)/";
        $result= preg_replace($buscar,'$@MIECHOICEVIEWBYID*$2@$',$result);

        return $result;
    }

    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of miechoices id
    function miechoice_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT a.id, a.course
                                 FROM {$CFG->prefix}miechoice a
                                 WHERE a.course = '$course'");
    }
   
    //Returns an array of miechoice_answers id
    function miechoice_answer_ids_by_course ($course) {

        global $CFG;

        return get_records_sql ("SELECT s.id , s.miechoiceid
                                 FROM {$CFG->prefix}miechoice_answers s,
                                      {$CFG->prefix}miechoice a
                                 WHERE a.course = '$course' AND
                                       s.miechoiceid = a.id");
    }
?>
