<?php // $Id: mysql.php,v 1.22 2005/04/22 13:19:47 moodler Exp $

function miechoice_upgrade($oldversion) {
    
    global $CFG;

// This function does anything necessary to upgrade
// older versions to match current functionality

    if ($oldversion < 2002090800) {
        execute_sql(" ALTER TABLE `miechoice` CHANGE `answer1` `answer1` VARCHAR( 255 )");
        execute_sql(" ALTER TABLE `miechoice` CHANGE `answer2` `answer2` VARCHAR( 255 )");
    }
    if ($oldversion < 2002102400) {
        execute_sql(" ALTER TABLE `miechoice` ADD `answer3` varchar(255) NOT NULL AFTER `answer2`");
        execute_sql(" ALTER TABLE `miechoice` ADD `answer4` varchar(255) NOT NULL AFTER `answer3`");
        execute_sql(" ALTER TABLE `miechoice` ADD `answer5` varchar(255) NOT NULL AFTER `answer4`");
        execute_sql(" ALTER TABLE `miechoice` ADD `answer6` varchar(255) NOT NULL AFTER `answer5`");
    }
    if ($oldversion < 2002122300) {
        execute_sql("ALTER TABLE `miechoice_answers` CHANGE `user` `userid` INT(10) UNSIGNED DEFAULT '0' NOT NULL ");
    }
    if ($oldversion < 2003010100) {
        execute_sql(" ALTER TABLE `miechoice` ADD `format` TINYINT(2) UNSIGNED DEFAULT '0' NOT NULL AFTER `text` ");
        execute_sql(" ALTER TABLE `miechoice` ADD `publish` TINYINT(2) UNSIGNED DEFAULT '0' NOT NULL AFTER `answer6` ");
    }

    if ($oldversion < 2004010100) {
        table_column("miechoice", "", "showunanswered", "integer", "4", "unsigned", "0", "", "publish");
    }
    if ($oldversion < 2004021700) {
        modify_database("", "INSERT INTO prefix_log_display VALUES ('miechoice', 'choose', 'miechoice', 'name');");
        modify_database("", "INSERT INTO prefix_log_display VALUES ('miechoice', 'choose again', 'miechoice', 'name');");
    }
    if ($oldversion < 2004070100) {
        table_column("miechoice", "", "timeclose", "integer", "10", "unsigned", "0", "", "showunanswered");
        table_column("miechoice", "", "timeopen", "integer", "10", "unsigned", "0", "", "showunanswered");
    }
    if ($oldversion < 2004070101) {
        table_column("miechoice", "", "release", "integer", "2", "unsigned", "0", "", "publish");
        table_column("miechoice", "", "allowupdate", "integer", "2", "unsigned", "0", "", "release");
    }
    if ($oldversion < 2004070102) {
        modify_database("", "UPDATE prefix_miechoice SET allowupdate = '1' WHERE publish = 0;");
        modify_database("", "UPDATE prefix_miechoice SET release = '1' WHERE publish > 0;");
        modify_database("", "UPDATE prefix_miechoice SET publish = publish - 1 WHERE publish > 0;");
    }

    if ($oldversion < 2004111200){  // drop first to avoid conflicts when upgrading from 1.4+
        execute_sql("ALTER TABLE {$CFG->prefix}miechoice DROP INDEX course;",false);
        execute_sql("ALTER TABLE {$CFG->prefix}miechoice_answers DROP INDEX miechoice;",false);
        execute_sql("ALTER TABLE {$CFG->prefix}miechoice_answers DROP INDEX userid;",false);       
        
        modify_database('','ALTER TABLE prefix_miechoice ADD INDEX course (course);');
        modify_database('','ALTER TABLE prefix_miechoice_answers ADD INDEX miechoice (miechoice);');
        modify_database('','ALTER TABLE prefix_miechoice_answers ADD INDEX userid (userid);');
    }
    
    if ($oldversion < 2005033001){  
        if (execute_sql("CREATE TABLE {$CFG->prefix}miechoice_options (
                             `id` int(10) unsigned NOT NULL auto_increment, 
                             `miechoiceid` int(10) unsigned NOT NULL default '0', 
                             `text` TEXT, 
                             `timemodified` int(10) NOT NULL default '0', 
                             PRIMARY KEY  (id), 
                             UNIQUE KEY id (id), 
                             KEY miechoiceid (miechoiceid)
                         ) TYPE=MyISAM;")) {
    
            table_column('miechoice_answers', 'miechoice', 'miechoiceid', 'integer', '10', 'unsigned', 0, 'not null');
            table_column('miechoice_answers', 'answer', 'optionid', 'integer', '10', 'unsigned', 0, 'not null');
    
            table_column('miechoice', '', 'display', 'integer', '4', 'unsigned', 0, 'not null', 'release');
    
            
            /// move old answers from miechoice to miechoice_options
    
            if ($miechoices = get_records('miechoice')) {
                foreach ($miechoices as $miechoice) {
                    for ($i=1; $i<=6; $i++) {      // We used to have six columns
                        $option = new stdClass;
                        $option->text         = addslashes($miechoice->{'answer'.$i});
                        if ($option->text) {   /// Don't bother with blank options
                            $option->miechoiceid     = $miechoice->id;
                            $option->timemodified = $miechoice->timemodified;
                            if ($option->id = insert_record('miechoice_options', $option)) { 
                                /// Update all the user answers to fit the new value
                                execute_sql("UPDATE {$CFG->prefix}miechoice_answers 
                                                SET optionid='$option->id' 
                                              WHERE miechoiceid='$miechoice->id' 
                                                AND optionid='$i'");                                                            
                            }
                        }
                    }
                }
            }
            
            //drop old fields
    
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer1`;');
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer2`;');
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer3`;');
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer4`;');
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer5`;');
            modify_database('','ALTER TABLE prefix_miechoice DROP `answer6`;');

        } else {
            notify('SERIOUS PROBLEM OCCURRED WHILE UPGRADING A TABLE - you may have to manually upgrade your tables ... see mod/miechoice/db/mysql.php');
            return false;
        }
    }
    
    if ($oldversion < 2005041100) { // replace wiki-like with markdown
        include_once( "$CFG->dirroot/lib/wiki_to_markdown.php" );
        $wtm = new WikiToMarkdown();
        $wtm->update( 'miechoice','text','format' );
    }
    if ($oldversion < 2005041500) { //new limit feature
        table_column('miechoice', '', 'limitanswers', 'TINYINT', '2', 'unsigned', 0, 'not null', 'showunanswered');
        table_column('miechoice_options', '', 'maxanswers', 'INTEGER', '10', 'unsigned', 0, 'null', 'text');
    }      

    return true;
}


?>
