rem
rem Table structure for table miechoice
rem

drop TABLE prefix_miechoice;
CREATE TABLE prefix_miechoice (
  id number(10) primary key,
  course number(10) default '0' not null,
  name varchar2(255) default '' not null,
  text varchar2(1024) NOT NULL,
  format number(2) default '0' not null,
  answer1 varchar2(255) default 'Yes' not null,
  answer2 varchar2(255) default 'No' not null,
  answer3 varchar2(255) default NULL,
  answer4 varchar2(255) default NULL,
  answer5 varchar2(255) default NULL,
  answer6 varchar2(255) default NULL,
  publish number(2) default '0' not null,
  timemodified number(10) default '0' not null
);

COMMENT on table prefix_miechoice is 'Available miechoices are stored here.';

drop sequence p_miechoice_seq;
create sequence p_miechoice_seq;

create or replace trigger p_miechoice_trig
  before insert on prefix_miechoice
  referencing new as new_row
  for each row
  begin
    select p_miechoice_seq.nextval into :new_row.id from dual;
  end;
.
/

insert into prefix_miechoice(course,name,text,format,answer1,answer2,answer3,answer4,answer5,answer6,publish,timemodified) values(1,'name1','text1',1,'1','1','1','1','1','1',1,1);
insert into prefix_miechoice(course,name,text,format,answer1,answer2,answer3,answer4,answer5,answer6,publish,timemodified) values(2,'name2','text2',2,'2','2','2','2','2','2',2,2);
insert into prefix_miechoice(course,name,text,format,answer1,answer2,answer3,answer4,answer5,answer6,publish,timemodified) values(3,'name3','text3',3,'3','3','3','3','3','3',3,3);
insert into prefix_miechoice(course,name,text,format,answer1,answer2,answer3,answer4,answer5,answer6,publish,timemodified) values(4,'name4','text4',4,'4','4','4','4','4','4',4,4);

select * from prefix_miechoice order by 1,2;

rem --------------------------------------------------------

rem
rem Table structure for table miechoice_answers
rem

drop TABLE prefix_miechoice_answers;
CREATE TABLE prefix_miechoice_answers (
  id number(10) primary key,
  miechoice number(10) default '0' not null,
  userid number(10) default '0' not null,
  answer number(4) default '0' not null,
  timemodified number(10) default '0' not null
);

comment on table prefix_miechoice_answers is 'Answers for each miechoice';

drop sequence p_miechoice_answers_seq;
create sequence p_miechoice_answers_seq;

create or replace trigger p_miechoice_answers_trig
  before insert on prefix_miechoice_answers
  referencing new as new_row
  for each row
  begin
    select p_miechoice_answers_seq.nextval into :new_row.id from dual;
  end;
.
/

insert into prefix_miechoice_answers (miechoice,userid,answer,timemodified) values(1,1,1,1);
insert into prefix_miechoice_answers (miechoice,userid,answer,timemodified) values(2,2,2,2);
insert into prefix_miechoice_answers (miechoice,userid,answer,timemodified) values(3,3,3,3);
insert into prefix_miechoice_answers (miechoice,userid,answer,timemodified) values(4,4,4,4);

select * from prefix_miechoice_answers order by 1,2;

rem
rem Dumping data for table log_display
rem

delete from prefix_log_display where module = 'miechoice';
INSERT INTO prefix_log_display VALUES ('miechoice', 'view', 'miechoice', 'name');
INSERT INTO prefix_log_display VALUES ('miechoice', 'update', 'miechoice', 'name');
INSERT INTO prefix_log_display VALUES ('miechoice', 'add', 'miechoice', 'name');
INSERT INTO prefix_log_display VALUES ('miechoice', 'report', 'miechoice', 'name');

    


