<?php // $Id: postgres7.php,v 1.22 2005/08/15 23:17:57 patrickslee Exp $

function miechoice_upgrade($oldversion) {

    global $CFG;

// This function does anything necessary to upgrade
// older versions to match current functionality

    if ($oldversion < 2003010100) {
        execute_sql(" ALTER TABLE `miechoice` ADD `format` INTEGER DEFAULT '0' NOT NULL AFTER `text` ");
        execute_sql(" ALTER TABLE `miechoice` ADD `publish` INTEGER DEFAULT '0' NOT NULL AFTER `answer6` ");
    }
    if ($oldversion < 2004010100) {
        table_column("miechoice", "", "showunanswered", "integer", "4", "unsigned", "0", "", "publish");
    }
    if ($oldversion < 2004021700) {
        modify_database("", "INSERT INTO prefix_log_display VALUES ('miechoice', 'choose', 'miechoice', 'name');");
        modify_database("", "INSERT INTO prefix_log_display VALUES ('miechoice', 'choose again', 'miechoice', 'name');");
    }
    if ($oldversion < 2004070100) {
        table_column("miechoice", "", "timeclose", "integer", "10", "unsigned", "0", "", "showunanswered");
        table_column("miechoice", "", "timeopen", "integer", "10", "unsigned", "0", "", "showunanswered");
    }
    if ($oldversion < 2004070101) {
        table_column("miechoice", "", "release", "integer", "2", "unsigned", "0", "", "publish");
        table_column("miechoice", "", "allowupdate", "integer", "2", "unsigned", "0", "", "release");
    }
    if ($oldversion < 2004070102) {
        modify_database("", "UPDATE prefix_miechoice SET allowupdate = '1' WHERE publish = 0;");
        modify_database("", "UPDATE prefix_miechoice SET release = '1' WHERE publish > 0;");
        modify_database("", "UPDATE prefix_miechoice SET publish = publish - 1 WHERE publish > 0;");
    }

    if ($oldversion < 2004111200) { // drop first to avoid conflicts when upgrading from 1.4+
        execute_sql("DROP INDEX {$CFG->prefix}miechoice_course_idx;",false);
        execute_sql("DROP INDEX {$CFG->prefix}miechoice_answers_miechoice_idx;",false);
        execute_sql("DROP INDEX {$CFG->prefix}miechoice_answers_userid_idx;",false);

        modify_database('','CREATE INDEX prefix_miechoice_course_idx ON prefix_miechoice (course);');
        modify_database('','CREATE INDEX prefix_miechoice_answers_miechoice_idx ON prefix_miechoice_answers (miechoice);');
        modify_database('','CREATE INDEX prefix_miechoice_answers_userid_idx ON prefix_miechoice_answers (userid);');
    }
    if ($oldversion < 2005033000){
        if (execute_sql("CREATE TABLE {$CFG->prefix}miechoice_options (id SERIAL PRIMARY KEY, miechoiceid integer NOT NULL default '0', text TEXT, timemodified integer NOT NULL default '0');") ) {
            execute_sql("CREATE INDEX {$CFG->prefix}miechoice_options_miechoice_idx ON {$CFG->prefix}miechoice_options (miechoiceid);");

            table_column('miechoice_answers', 'miechoice', 'miechoiceid', 'integer', '10', 'unsigned', 0, 'not null');
            table_column('miechoice_answers', 'answer', 'optionid', 'integer', '10', 'unsigned', 0, 'not null');
            table_column('miechoice', '', 'display', 'integer', '4', 'unsigned', 0, 'not null', 'release');

            // move old answers from miechoice to miechoice_options
            if ($miechoices = get_records('miechoice')) {
                foreach ($miechoices as $miechoice) {
                    for ($i=1; $i<=6; $i++) {      // We used to have six columns
                        $option = new stdClass;
                        $option->text         = addslashes($miechoice->{'answer'.$i});
                        if ($option->text) {   /// Don't bother with blank options
                            $option->miechoiceid     = $miechoice->id;
                            $option->timemodified = $miechoice->timemodified;
                            if ($option->id = insert_record('miechoice_options', $option)) {
                                /// Update all the user answers to fit the new value 
                                execute_sql("UPDATE {$CFG->prefix}miechoice_answers
                                                SET optionid={$option->id}
                                              WHERE miechoiceid={$miechoice->id}
                                                AND optionid={$i}");
                            }
                        }
                    }
                }
            }

      // drop old fields
         modify_database('','ALTER TABLE prefix_miechoice DROP answer1;');
         modify_database('','ALTER TABLE prefix_miechoice DROP answer2;');
         modify_database('','ALTER TABLE prefix_miechoice DROP answer3;');
         modify_database('','ALTER TABLE prefix_miechoice DROP answer4;');
         modify_database('','ALTER TABLE prefix_miechoice DROP answer5;');
         modify_database('','ALTER TABLE prefix_miechoice DROP answer6;');

       }
    }

    if ($oldversion < 2005041100) { // replace wiki-like with markdown
        include_once( "$CFG->dirroot/lib/wiki_to_markdown.php" );
        $wtm = new WikiToMarkdown();
        $wtm->update( 'miechoice','text','format' );
    }
    if ($oldversion < 2005041500) { //new limit feature
        table_column('miechoice', '', 'limitanswers', 'INTEGER', '2', 'unsigned', 0, 'not null', 'showunanswered');
        table_column('miechoice_options', '', 'maxanswers', 'INTEGER', '10', 'unsigned', 0, 'null', 'text');
    }

    if ($oldversion < 2005041501) { // Mass cleanup of bad upgrade scripts
        modify_database('','CREATE INDEX prefix_miechoice_answers_miechoice_idx ON prefix_miechoice_answers (miechoiceid)');
        modify_database('','ALTER TABLE prefix_miechoice ALTER display SET NOT NULL');
        modify_database('','ALTER TABLE prefix_miechoice ALTER limitanswers SET NOT NULL');
        modify_database('','ALTER TABLE prefix_miechoice_answers ALTER miechoiceid SET NOT NULL');
        modify_database('','ALTER TABLE prefix_miechoice_answers ALTER optionid SET NOT NULL');
    }

    return true;
}

?>
