<?php

    if (!isteacher($course->id)) {
        error("Only teachers can look at this page");
    }

    if (!$miechoice = miechoice_get_miechoice($cm->instance)) {
        error("Course module is incorrect");
    }

    /// Check to see if groups are being used in this choice
    if ($groupmode = groupmode($course, $cm)) {   // Groups are being used
        $currentgroup = get_current_group($course->id);
    } else {
        $currentgroup = false;
    }

    if ($currentgroup) {
        $users = get_group_users($currentgroup, "u.username ASC", '', 'u.username, u.id, u.picture, u.firstname, u.lastname');
    } else {
        $users = get_course_users($course->id, "u.username ASC", '', 'u.username, u.id, u.picture, u.firstname, u.lastname') + get_admins();
    }
    if (!$users) {
        print_heading(get_string("nousersyet"));        
    }

    if ($allresponses = get_records("miechoice_answers", "miechoiceid", $miechoice->id)) {
        foreach ($allresponses as $aa) {
            $answers[$aa->userid] = $aa;
        }
    } else {
        $answers = array () ;
    }

    $timenow = time();

    foreach ($miechoice->option as $optionid => $text) {
        $useranswer[$optionid] = array();
    }

    //print spreadsheet if one is asked for:
    if ( isset($dlexcel) ) {
        require_once("$CFG->libdir/excel/Worksheet.php");
        require_once("$CFG->libdir/excel/Workbook.php");

        // HTTP headers
        $filename = "$course->shortname".'_'."$miechoice->name".'.xls';
//      $fname = miechoice_encording_convert($filename,$encode);

    // okumura: (see file.php)
    $ua = $_SERVER['HTTP_USER_AGENT'];
    if (strstr($ua, "MSIE") && !strstr($ua, 'Opera')) {
       $fname = mb_convert_encoding($filename, "SJIS", get_string('thischarset'));
    } elseif (strstr($ua, "Safari")) {
       $fname = preg_replace('/[^\.a-zA-Z\d\_-]/', '_', $filename);
    } else {
       $fname = mb_convert_encoding($filename, "UTF-8", get_string('thischarset'));
    }

        header('Content-type: application/vnd.ms-excel');
        header('Content-Disposition: attachment; filename='."$fname");
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0,pre-check=0');
        header('Pragma: public');

        // Creating a workbook
        $workbook = new Workbook('-');

        // Creating the first worksheet
//      $responses = miechoice_encording_convert(get_string('responses','miechoice'),$encode);
        $responses = mb_convert_encoding(get_string('responses','miechoice'),"SJIS",get_string('thischarset'));
        $worksheet =& $workbook->add_worksheet("$responses");
        $worksheet->set_column( 0, 1, 10);
        $worksheet->set_column( 2, 3, 15);
        $worksheet->set_column( 4, 4, 8);

        $format_head =& $workbook->add_format();
        $format =& $workbook->add_format();
        $format_head->set_bold(1);
        $format_head->set_border(1);
        $format->set_border(1);

        $worksheet->write_string(0,0,miechoice_encording_convert(get_string('username'),$encode), $format_head);
        $worksheet->write_string(0,1,miechoice_encording_convert(get_string('firstname'),$encode), $format_head);
        $worksheet->write_string(0,2,miechoice_encording_convert(get_string('lastname'),$encode), $format_head);
        $worksheet->write_string(0,3,miechoice_encording_convert(get_string('miechoice','miechoice'),$encode), $format_head);

        /// generate the data for the body of the spreadsheet
        $i=0;  
        $row=1;
        if ($users) {
            foreach ($users as $user) {
                //make sure admins and hidden teachers are not shown in not answered yet column, and not answered only shown if set in config page.
                if (!($answers[$user->id]->optionid==0 && isadmin($user->id)) && 
                    (!($answers[$user->id]->optionid==0 && isteacher($course->id, $user->id) && !(isteacheredit($course->id, $user->id)) ) ) &&  
                    !($answers[$user->id]->optionid==0 && $miechoice->showunanswered==0)) { 

		    $studentid=$user->username;
                    $worksheet->write_string($row,0,miechoice_encording_convert($studentid,$encode), $format);
                    $worksheet->write_string($row,1,miechoice_encording_convert($user->firstname,$encode), $format);
                    $worksheet->write_string($row,2,miechoice_encording_convert($user->lastname,$encode), $format);
                    $useroption = miechoice_get_option_text($miechoice, $answers[$user->id]->optionid);
                    if (isset($useroption)) {
                         $worksheet->write_string($row,3,miechoice_encording_convert(format_string($useroption,true),$encode), $format);
                    }
                    $row++;
                 }
            }
            $pos=4;
        }
        $workbook->close();
    } 

    // print text file
    if ( isset( $dltext) ) {
        $miechoicename = miechoice_encording_convert($miechoice->name,$encode);

        $filename = "$course->shortname"."_$miechoicename".'.txt';
        header("Content-Type: application/download\n"); 
        header("Content-Disposition: attachment; filename=\"".$filename."\"");

        /// Print names of all the fields
        $output .= get_string('username')."\t".get_string('firstname') . "\t". get_string('lastname') . "\t";
        $output .= get_string('miechoice','miechoice'). "\n";

        /// generate the data for the body of the spreadsheet
        $i=0;
        $row=1;
        if ($users) foreach ($users as $user) {
            if (!($answers[$user->id]->optionid==0 && isadmin($user->id)) &&
                (!($answers[$user->id]->optionid==0 && isteacher($course->id, $user->id) && !(isteacheredit($course->id, $user->id)) ) ) &&  
                !($miechoice->showunanswered==0 && $answers[$user->id]->optionid==0)  ) { //make sure admins and hidden teachers are not shown in not answered yet column, and not answered only shown if set in config page.
                $studentid=$user->username;
                $output .= $studentid;
                $output .= "\t".$user->firstname;
                $output .= "\t".$user->lastname;
                $output .= format_string(miechoice_get_option_text($miechoice, $answers[$user->id]->optionid),true). "\n";
            }
            $row++;
        }
        $output = miechoice_encording_convert($output,$encode);
        echo $output;
    }
    exit;
?>
