<?php // $Id: lib.php,v 1.30 2005/09/01 04:14:29 mjollnir_ Exp $

$COLUMN_HEIGHT = 300;

define('MIECHOICE_PUBLISH_ANONYMOUS', '0');
define('MIECHOICE_PUBLISH_NAMES',     '1');

define('MIECHOICE_RELEASE_NOT',          '0');
define('MIECHOICE_RELEASE_AFTER_ANSWER', '1');
define('MIECHOICE_RELEASE_AFTER_CLOSE',  '2');
define('MIECHOICE_RELEASE_ALWAYS',       '3');

define('MIECHOICE_DISPLAY_HORIZONTAL',  '0');
define('MIECHOICE_DISPLAY_VERTICAL',    '1');

$MIECHOICE_PUBLISH = array (MIECHOICE_PUBLISH_ANONYMOUS  => get_string('publishanonymous', 'miechoice'),
                         MIECHOICE_PUBLISH_NAMES      => get_string('publishnames', 'miechoice'));

$MIECHOICE_RELEASE = array (MIECHOICE_RELEASE_NOT          => get_string('publishnot', 'miechoice'),
                         MIECHOICE_RELEASE_AFTER_ANSWER => get_string('publishafteranswer', 'miechoice'),
                         MIECHOICE_RELEASE_AFTER_CLOSE  => get_string('publishafterclose', 'miechoice'),
                         MIECHOICE_RELEASE_ALWAYS       => get_string('publishalways', 'miechoice'));

$MIECHOICE_DISPLAY = array (MIECHOICE_DISPLAY_HORIZONTAL   => get_string('displayhorizontal', 'miechoice'),
                         MIECHOICE_DISPLAY_VERTICAL     => get_string('displayvertical','miechoice'));

// TAB.
define('MIECHOICE_TAB_ID_MIECHOICE',1);
define('MIECHOICE_TAB_ID_SENDMAIL',2);
define('MIECHOICE_TAB_ID_REPORT',3);

$MIECHOICE_TAB_MENU = array ( MIECHOICE_TAB_ID_MIECHOICE => get_string('modulename', 'miechoice'),
                                             MIECHOICE_TAB_ID_SENDMAIL => get_string('mailtostudents', 'miechoice'),
                                             MIECHOICE_TAB_ID_REPORT => get_string('reports','miechoice'));

$MIECHOICE_TAB_STUDENT_MENU = array ( MIECHOICE_TAB_ID_MIECHOICE => get_string('modulename', 'miechoice'));

/// Standard functions /////////////////////////////////////////////////////////
?>
<?php
function miechoice_user_outline($course, $user, $mod, $miechoice) {
    if ($answer = get_record('miechoice_answers', 'miechoiceid', $miechoice->id, 'userid', $user->id)) {
        $result->info = "'".format_string(miechoice_get_option_text($miechoice, $answer->optionid))."'";
        $result->time = $answer->timemodified;
        return $result;
    }
    return NULL;
}


function miechoice_user_complete($course, $user, $mod, $miechoice) {
    if ($answer = get_record('miechoice_answers', 'miechoiceid', $miechoice->id, 'userid', $user->id)) {
        $result->info = "'".format_string(miechoice_get_option_text($miechoice, $answer->optionid))."'";
        $result->time = $answer->timemodified;
        echo get_string('answered', 'miechoice').": $result->info. ".get_string('updated', '', userdate($result->time));
    } else {
        print_string('notanswered', 'miechoice');
    }
}


function miechoice_add_instance($miechoice) {
// Given an object containing all the necessary data, 
// (defined by the form in mod.html) this function 
// will create a new instance and return the id number 
// of the new instance.
    $miechoice->timemodified = time();

    if (!empty($miechoice->timerestrict) and $miechoice->timerestrict) {
        $miechoice->timeopen = make_timestamp($miechoice->openyear, $miechoice->openmonth, $miechoice->openday,
                                     $miechoice->openhour, $miechoice->openminute, 0);
        $miechoice->timeclose = make_timestamp($miechoice->closeyear, $miechoice->closemonth, $miechoice->closeday,
                                      $miechoice->closehour, $miechoice->closeminute, 0);
    } else {
        $miechoice->timeopen = 0;
        $miechoice->timeclose = 0;
    }

    //insert answers
    if ($id = insert_record('miechoice', $miechoice)) {
        foreach ($miechoice as $name => $value) {        
            if (strstr($name, 'newoption')) {   /// New option
                $value = trim($value);
                if (isset($value) && $value <> '') {
                    $limit = empty($miechoice->{'newlimit'.substr($name, 9)} ) ? 0 : $miechoice->{'newlimit'.substr($name, 9)};
                    $option = NULL;
                    $option->text = $value;
                    $option->miechoiceid = $id;
                    $option->maxanswers = $limit; 
                    $option->timemodified = time();
                    insert_record('miechoice_options', $option);
                }
            }
        }
    }
    return $id;
}


function miechoice_update_instance($miechoice) {
// Given an object containing all the necessary data, 
// (defined by the form in mod.html) this function 
// will update an existing instance with new data.

    $miechoice->id = $miechoice->instance;
    $miechoice->timemodified = time();
    if (!empty($miechoice->timerestrict) and $miechoice->timerestrict) {
        $miechoice->timeopen = make_timestamp($miechoice->openyear, $miechoice->openmonth, $miechoice->openday,
                                     $miechoice->openhour, $miechoice->openminute, 0);
        $miechoice->timeclose = make_timestamp($miechoice->closeyear, $miechoice->closemonth, $miechoice->closeday,
                                      $miechoice->closehour, $miechoice->closeminute, 0);
    } else {
        $miechoice->timeopen = 0;
        $miechoice->timeclose = 0;
    }

    //update answers
    foreach ($miechoice as $name => $value) {
        $value = trim($value);
        if (strstr($name, 'oldoption')) {  // Old option
            if (isset($value) && $value <> '') {
                $option = NULL;
                $option->id = substr($name, 9); // Get the ID of the answer that needs to be updated.
                $option->text = $value;
                $option->miechoiceid = $miechoice->id;
                $oldlimit = !empty($miechoice->{'oldlimit'.substr($name, 9)}) ? $miechoice->{'oldlimit'.substr($name, 9)} : 0;
                $option->maxanswers = $oldlimit;
                $option->timemodified = time();
                update_record('miechoice_options', $option);
            } else { //empty old option - needs to be deleted.
                delete_records('miechoice_options', 'id', substr($name, 9));
            }
        } else if (strstr($name, 'newoption')) {   /// New option
            if (isset($value)&& $value <> '') {
                $option = NULL;
                $option->text = $value;
                $option->miechoiceid = $miechoice->id;
                $newlimit = !empty($miechoice->{'newlimit'.substr($name, 9)}) ? $miechoice->{'newlimit'.substr($name, 9)} : 0;
                $option->maxanswers = $newlimit;
                $option->timemodified = time();
                insert_record('miechoice_options', $option);
            }
        }
    }
    return update_record('miechoice', $miechoice);
}

function miechoice_delete_instance($id) {
// Given an ID of an instance of this module, 
// this function will permanently delete the instance 
// and any data that depends on it.  

    if (! $miechoice = get_record('miechoice', 'id', "$id")) {
        return false;
    }

    $result = true;

    if (! delete_records('miechoice_answers', 'miechoiceid', "$miechoice->id")) {
        $result = false;
    }

    if (! delete_records('miechoice_options', 'miechoiceid', "$miechoice->id")) {
        $result = false;
    }

    if (! delete_records('miechoice', 'id', "$miechoice->id")) {
        $result = false;
    }
    

    return $result;
}

function miechoice_get_participants($miechoiceid) {
//Returns the users with data in one miechoice
//(users with records in miechoice_responses, students)

    global $CFG;

    //Get students
    $students = get_records_sql("SELECT DISTINCT u.id, u.id
                                 FROM {$CFG->prefix}user u,
                                      {$CFG->prefix}miechoice_answers a
                                 WHERE a.miechoiceid = '$miechoiceid' and
                                       u.id = a.userid");

    //Return students array (it contains an array of unique users)
    return ($students);
}


function miechoice_get_option_text($miechoice, $id) {
// Returns text string which is the answer that matches the id
    if ($result = get_record('miechoice_options', 'id', $id)) {
        return $result->text;
    } else {
        return get_string('notanswered', 'miechoice');
    }            
}

function miechoice_get_miechoice($miechoiceid) {
// Gets a full miechoice record      
    if ($miechoice = get_record('miechoice', 'id', $miechoiceid)) {
        if ($options = get_records('miechoice_options', 'miechoiceid', $miechoiceid, 'id')) {
            foreach ($options as $option) {                         
                $miechoice->option[$option->id] = $option->text; 
                $miechoice->maxanswers[$option->id] = $option->maxanswers;
            }        
            return $miechoice;
        }
    }
    return false;
}

function miechoice_get_view_actions() {
    return array('view','view all','report');
}

function miechoice_get_post_actions() {
    return array('choose','choose again');
}

function miechoice_print_choice_group($form, $course) {
    echo '<tr valign="top">';
    echo '<td align="right"><b>'.get_string('groupsetting','miechoice').':</b></td>';
    echo '<td  colspan="3" align="left">';
    $optgroups[0] = get_string('notset','miechoice');
    if ( $groups = get_records('groups','courseid',$course->id,'id ASC')) {
        foreach($groups as $group) { $optgroups[$group->id] = $group->name; }
    }
//    $disable = (! isset($form->groupmode) || ($form->groupmode == 'NOGROUPS')) ? true : false;
    choose_from_menu($optgroups, 'groupid', $form->groupid, '0','','0',''); 
    helpbutton('choicegroup', get_string('groupsetting','miechoice'), 'miechoice'); 
    echo '</td></tr>';
}

/**
 * Print visibility setting form element on module setup forms in mod/.../mod.html
 */
function miechoice_print_visible_setting($form, $course=NULL) {
    if (empty($course)) {
        if (! $course = get_record('course', 'id', $form->course)) {
            error("This course doesn't exist");
        }
    }
    if ($form->coursemodule) {
        $visible = get_field('course_modules', 'visible', 'id', $form->coursemodule);
    } else {
        $visible = true;
    }

    if ($form->mode == 'add') { // in this case $form->section is the section number, not the id
        $hiddensection = !get_field('course_sections', 'visible', 'section', $form->section, 'course', $form->course);
    } else {
        $hiddensection = !get_field('course_sections', 'visible', 'id', $form->section);
    }
    if ($hiddensection) {
        $visible = false;
    }
    
    echo '<tr valign="top">';
    echo '<td align="right"><b>'.get_string('visibletostudents','',get_string('students')).':</b></td>';
    echo '<td align="left">';
    unset($choices);
    $choices[1] = get_string('show');
    $choices[0] = get_string('hide');
    choose_from_menu($choices, 'visible', $visible, '', '', 0, false, $hiddensection);
    echo '</td></tr>';
} 

function miechoice_tab_menu($tabsinfo, $selected='', $link='', $onclick='') {
    // prints the question types for when editing and adding a page
    $tabs = array();
    $tabrows = array();

    foreach ($tabsinfo as $tabid => $tabname) {
        $tabrows[] = new tabobject($tabid, "$link&amp;tabid=$tabid\" onClick=\"$onclick\"", $tabname);
    }
    $tabs[] = $tabrows;
    print_tabs($tabs, $selected);
    echo "<input type=\"hidden\" name=\"tabid\" value=\"$selected\" >";
}

/**
 * Send an email to a specified user
 *
 * @uses $CFG
 * @uses $_SERVER
 * @uses SITEID
 * @param user $user  A {@link $USER} object
 * @param user $from A {@link $USER} object
 * @param string $subject plain text subject line of the email
 * @param string $messagetext plain text version of the message
 * @param string $messagehtml complete html version of the message (optional)
 * @param string $attachment a file on the filesystem, relative to $CFG->dataroot
 * @param string $attachname the name of the file (extension indicates MIME)
 * @param boolean $usetrueaddress determines whether $from email address should
 *          be sent out. Will be overruled by user profile setting for maildisplay
 * @return boolean|string Returns "true" if mail was sent OK, "emailstop" if email
 *          was blocked by user and "false" if there was another sort of error.
 */
function miechoice_email_to_user($user, $from, $subject, $messagetext, $messagehtml='', $attachment='', $attachname='', $usetrueaddress=true, $repyto='', $replytoname='') {
    global $CFG, $FULLME;

    global $course;                // This is a bit of an ugly hack to be gotten rid of later
    if (!empty($course->lang)) {   // Course language is defined
        $CFG->courselang = $course->lang;
    }
    if (!empty($course->theme)) {   // Course language is defined
        $CFG->coursetheme = $course->theme;
    }

    include_once("$CFG->dirroot/lib/phpmailer/class.phpmailer.php");

    if (empty($user)) {
        return false;
    }

    if (!empty($user->emailstop)) {
        return 'emailstop';
    }

    if (over_bounce_threshold($user)) {
        error_log("User $user->id (".fullname($user).") is over bounce threshold! Not sending.");
        return false;
    }

    $mail = new phpmailer;

    $mail->IsMail();                                                         // use PHP mail()
    $mail->Version = "Moodle $CFG->version";                 // mailer version
    $mail->PHPMailer();                                                  // plugin directory (eg smtp plugin)

    if (current_language() != 'en') {
//        $mail->CharSet = get_string('thischarset');
        $mail->CharSet = 'ISO-2022-JP';
    }
    $dbcharset = get_string('thischarset');

/*==================================================
    if ($CFG->smtphosts == 'qmail') {
        $mail->IsQmail();                              // use Qmail system
    } else if (empty($CFG->smtphosts)) {
        $mail->IsMail();                               // use PHP mail() = sendmail
    } else {
        $mail->IsSMTP();                               // use SMTP directly
        if ($CFG->debug > 7) {
            echo '<pre>';
            $mail->SMTPDebug = true;
        }
        $mail->Host = $CFG->smtphosts;               // specify main and backup servers

        if ($CFG->smtpuser) {                          // Use SMTP authentication
            $mail->SMTPAuth = true;
            $mail->Username = $CFG->smtpuser;
            $mail->Password = $CFG->smtppass;
        }
    }
==================================================*/

    $adminuser = get_admin();

    // make up an email address for handling bounces
    if (!empty($CFG->handlebounces)) {
        $modargs = 'B'.base64_encode(pack('V',$user->id)).substr(md5($user->email),0,16);
        $mail->Sender = generate_email_processing_address(0,$modargs);
    } else {
        $mail->Sender = $adminuser->email;
    }
    if (is_string($from)) { // So we can pass whatever we want if there is need
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding($from, 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else if ($usetrueaddress and $from->maildisplay) {
        $mail->From = $from->email;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    } else {
        $mail->From = $CFG->noreplyaddress;
        $mail->FromName = mb_encode_mimeheader(mb_convert_encoding(fullname($from), 'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
        if (empty($replyto)) {
            $mail->AddReplyTo($CFG->noreplyaddress,get_string('noreplyname'));
        }
    }
    if (!empty($replyto)) {
        $mail->AddReplyTo($replyto,$replytoname);
    }
    $subject = mb_convert_encoding($subject, 'ISO-2022-JP',$dbcharset);
    $mail->Subject = substr(stripslashes($subject), 0, 900);

    if (! $kmailuser = get_record('user_profile_sub','userid',$user->id)) {
        $username = fullname($user);
        error("ERROR : kmail user $username");
    }
    $username = mb_encode_mimeheader(mb_convert_encoding(fullname($user),'ISO-2022-JP',$dbcharset),'ISO-2022-JP');
    $mail->AddAddress($kmailuser->k_mail,$username);

    $mail->WordWrap = 79;                               // set word wrap

    if (!empty($from->customheaders)) {                 // Add custom headers
        if (is_array($from->customheaders)) {
            foreach ($from->customheaders as $customheader) {
                $mail->AddCustomHeader($customheader);
            }
        } else {
            $mail->AddCustomHeader($from->customheaders);
        }
    }

    if (!empty($from->priority)) {
        $mail->Priority = $from->priority;
    }

    $messagetext = mb_convert_encoding($messagetext,'JIS',$dbcharset);
    if ($messagehtml && $user->mailformat == 1) { // Don't ever send HTML to users who don't want it
        $mail->IsHTML(true);
        $mail->Encoding = 'quoted-printable';           // Encoding to use
        $mail->Body    =  $messagehtml;
        $mail->AltBody =  "\n$messagetext\n";
    } else {
        $mail->IsHTML(false);
        $mail->Body =  "\n$messagetext\n";
    }

    if ($attachment && $attachname) {
        if (ereg( "\\.\\." ,$attachment )) {    // Security check for ".." in dir path
//          $adminname =  mb_convert_encoding(fullname($adminuser),'SIO-2022-JP',$dbcharset);  // silly typo!
            $adminname =  mb_convert_encoding(fullname($adminuser),'ISO-2022-JP',$dbcharset);
            $mail->AddAddress($adminuser->email, $adminname);
            $mail->AddStringAttachment('Error in attachment.  User attempted to attach a filename with a unsafe name.', 'error.txt', '8bit', 'text/plain');
        } else {
            require_once($CFG->libdir.'/filelib.php');
            $mimetype = mimeinfo('type', $attachname);
            $mail->AddAttachment($CFG->dataroot .'/'. $attachment, $attachname, 'base64', $mimetype);
        }
    }
    if ($mail->Send()) {
        set_send_count($user);
        return true;

    } else {
        mtrace('ERROR: '. $mail->ErrorInfo);
        add_to_log(SITEID, 'library', 'mailer', $FULLME, 'ERROR: '. $mail->ErrorInfo);
        return false;
    }

}

function miechoice_print_group($courseid, $groupmode) {

    if ( $group = get_current_group($courseid, true)) {
        $strgroupname = $group->name;
    } else {
        $strgroupname = get_string('everybody');
    }
    $strgroupmodes = array('groupsnone','groupsseparate','groupsvisible');
//    print_simple_box_start('center','*');
    echo '<center>'.get_string("$strgroupmodes[$groupmode]").'&nbsp;:&nbsp;'."$strgroupname</center><br>";
//    print_simple_box_end();
}

function miechoice_encording_convert($str,$encode,$src='') {
  /*
    if ( function_exists('mb_convert_encoding') ) {
        $srcencoding = ($src == '')  ?  get_string('thischarset') : $src;
        if ( $srcencoding != $encode ) {
            $output = mb_convert_encoding($str,$encode,$srcencoding);
        }
    }
    return $output;
  */
  return $str;
}

function miechoice_encording_get_list() {
    // check function PHP5.
    if (function_exists('mb_list_encodings')) {
        $list_encoding = mb_list_encodings();
    } else {
        // I use a 'mb_list_encodings()' function in the future. PHP5 
        $list_encoding = array('EUC-JP', 'UTF-8', 'SJIS', ' iso-2022-jp');
    }
    foreach ($list_encoding as $encode) {
        $encoding[$encode] = $encode; 
    }
    return $encoding;
}

function miechoice_encording_choose_from_menu ($options, $name, $selected='', $enable='true') {

    $enable = ($enable == 'true') ? '' : 'disabled="disabled"';
    $output = "<select name=\"$name\" $enable>";

    if (!empty($options)) {
        foreach ($options as $value => $label) {
            $output .= "   <option value=\"$value\"";
            if ($value == $selected) {
                $output .= ' selected="true"';
            }
            if ($label === '') {
                $output .= ">$value</option>\n";
            } else {
                $output .= ">$label</option>\n";
            }
        }
    }
    $output .= '</select>';
    echo $output;
}

/**
 * Determine if there is data waiting to be processed from a form
 *
 * Used on most forms in Moodle to check for data
 * Returns the data as an object, if it's found.
 * This object can be used in foreach loops without
 * casting because it's cast to (array) automatically
 *
 * Checks that submitted POST data exists, and also
 * checks the referer against the given url (it uses
 * the current page if none was specified.
 *
 * @uses $CFG
 * @param string $url the url to compare to referer for secure forms
 * @return boolean
 */
function miechoice_data_get_submitted() {
    global $CFG;

    if ( empty($_GET)) {
        return false;
    } else {
        return (object)$_GET;
    }
}

function miechoice_choose_from_radio ($options, $name, $checked='', $vertical='0', $mobile='0') {
    if (!$name) { $name = 'unnamed'; }

    if (!empty($options)) {
        switch ($vertical) {
        case MIECHOICE_DISPLAY_HORIZONTAL:
            if ( $mobile ) {
                $output = '';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>';
                    $output .= $text.'&nbsp;&nbsp;';
                }
            } else {
                $output = '<table cellpadding="0" align="center"><tr>';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '<td align="center">';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>'.$text;
                    $output .= '</td>';
                }
                $output .= '</tr></table>';
            }
            break;
        case MIECHOICE_DISPLAY_VERTICAL:
            if ( $mobile ) {
                $output = '';
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '&nbsp;<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>';
                    $output .= '&nbsp;'.$text.'<br>';
                }
            } else {
                $output = '<table align="center">';
                $displayoptions->para = false;
                foreach ($options as $optionid => $text) {
                    $selected = ($optionid == $checked) ? 'checked' : '';
                    $output .= '<tr><td><div align="left">';
                    $output .= '<input type="radio" name="'.$name.'" value="'.$optionid.'" '.$selected.'>'.$text;
                    $output .= '</div></td></tr>';
                }
                $output .= '</table>';
            }
            break;
        }
    }

    return $output;
}

function miechoice_get_course_answer($miechoiceid, $optionid, $groupid='', $sort='a.id DES') {
    global $CFG;
    // make sure it works on the site course
    if ( $groupid ) {
        $from = ", {$CFG->prefix}groups_members gm";
        $select = "AND a.userid = gm.userid AND gm.groupid = '$groupid'";
    } else {
        $from  = $select = "";
    }
    $selectsql = "{$CFG->prefix}miechoice_answers a $from WHERE  a.miechoiceid = '$miechoiceid' AND a.optionid = '$optionid' $select ORDER BY $sort";

    return count_records_sql("SELECT COUNT(*) FROM $selectsql");
}

/**
 * Print a self contained form with a single submit button.
 *
 * @param string $link ?
 * @param array $options ?
 * @param string $label ?
 * @param string $method ?
 * @todo Finish documenting this function
 */
function miechoice_print_single_button($link, $options, $label='OK', $method='get') {
    echo '<form action="'. $link .'" method="'. $method .'">';
    if ($options) {
        foreach ($options as $name => $value) {
            echo '<input type="hidden" name="'. $name .'" value="'. $value .'">';
        }
    }
    echo '<input type="submit" value="'. $label .'"></form>';
}
function miechoice_logout() {
    global $USER, $CFG;
    if (isset($USER) && isset($USER->id)) {
        add_to_log(SITEID, "user", "logout", "view.php?id=$USER->id&course=".SITEID, $USER->id, 0, $USER->id);

        if ($USER->auth == 'cas' && !empty($CFG->cas_enabled)) {
            require($CFG->dirroot.'/auth/cas/logout.php');
        }
    }

    if (ini_get_bool("register_globals") and check_php_version("4.3.0")) {
        // This method is just to try to avoid silly warnings from PHP 4.3.0
        session_unregister("USER");
        session_unregister("SESSION");
    }

    unset($_SESSION['USER']);
    unset($_SESSION['SESSION']);

    unset($SESSION);
    unset($USER);
}

?>
