<?php

    if ($miechoice->text) {
        print_simple_box(format_text($miechoice->text, $miechoice->format), 'center', '70%', '', 5, 'generalbox', 'intro');
    }

    //if user has already made a selection, and they are not allowed to update it, show their selected answer.
    if (isset($USER->id) && ($current = get_record('miechoice_answers', 'miechoiceid', $miechoice->id, 'userid', $USER->id)) && !$miechoice->allowupdate) {
        print_simple_box(get_string("yourselection", "miechoice", userdate($miechoice->timeopen)).": ".format_string(miechoice_get_option_text($miechoice, $current->optionid)), "center");
    }

    // Print the form
    if ($miechoice->timeopen > time() ) {
        print_simple_box(get_string('notopenyet', 'miechoice', userdate($miechoice->timeopen)), 'center');
        print_footer($course);
        exit;
    }
    if (! $current || $miechoice->allowupdate ) {
        $miechoiceanswer = get_record('miechoice_answers','miechoiceid',$miechoice->id,'userid',$USER->id);
        $checked = !empty($miechoiceanswer) ? $miechoiceanswer->optionid : 0;
             
       // They haven't made their miechoice yet or updates allowed and miechoice is open
        echo '<form name="form" method="post" action="view.php"><center>';
        $optionid = !empty($current) ? $current->optionid : ' ';
        echo miechoice_choose_from_radio ($miechoice->option, 'answer', $checked, $miechoice->display);
        echo '<br>';
        
        echo '<input type="hidden" name="id" value="'.$cm->id.'">';
        if (!isguest()) {
            if( ($miechoice->timeclose == 0)  || ($miechoice->timeclose > time()) ) {
                echo '<input type="hidden" name="groupid" value="'.$miechoice->groupid.'">';
                echo '<input type="submit" name="savechange" value="'.get_string('savemymiechoice','miechoice').'">';
                echo '</form>';
            } else {
                $options['id'] = $cm->course;
                echo '</form><font  color="red">'.get_string('err_limitperiod','miechoice').'</font><br>';
                print_single_button("$CFG->wwwroot/course/view.php", $options,get_string('cancel'));
            }
        } else {
            print_string('havetologin', 'miechoice');
        }
        echo '</center>';
    }

    // print the results at the bottom of the screen
    if (  $miechoice->rlsresult == MIECHOICE_RELEASE_ALWAYS or
        ( $miechoice->rlsresult == MIECHOICE_RELEASE_AFTER_ANSWER and $current ) or
        ( $miechoice->rlsresult == MIECHOICE_RELEASE_AFTER_CLOSE and $miechoice->timeclose <= time() ) )  {
        print_spacer(15);
        echo '<hr size="1" noshade="noshade">';
        print_spacer(15);
        print_simple_box_start ('center','*');
        print_heading(get_string("responses", "miechoice"));

        if ($currentgroup) {
            $users = get_group_users($currentgroup, "u.firstname ASC", '', 'u.id, u.picture, u.firstname, u.lastname');
        } else {
            $users = get_course_users($course->id, "u.firstname ASC", '', 'u.id, u.picture, u.firstname, u.lastname') + get_admins();
        }
        if (!$users) {
            print_heading(get_string("nousersyet"));
        }

        if ($allresponses = get_records("miechoice_answers", "miechoiceid", $miechoice->id)) {
            foreach ($allresponses as $aa) {
                $answers[$aa->userid] = $aa;
            }
        } else {
            $answers = array () ;
        }

        $timenow = time();

        foreach ($miechoice->option as $optionid => $text) {
            $useranswer[$optionid] = array();
        }
        foreach ($users as $user) {
//            if (! isstudent( $course->id, $user->id)) {   continue;  }
            if (!empty($user->id) and !empty($answers[$user->id])) {
                $answer = $answers[$user->id];
                $useranswer[(int)$answer->optionid][] = $user;
            } else {
                $useranswer[0][] = $user;
            }
        }
        foreach ($miechoice->option as $optionid => $text) {
            if (!$miechoice->option[$optionid]) {
                unset($useranswer[$optionid]);     // Throw away any data that doesn't apply
            }
        }

        ksort($useranswer);
        switch ($miechoice->publish) {
          case MIECHOICE_PUBLISH_NAMES:

            $isteacher = isteacher($course->id);

            $tablewidth = (int) (100.0 / count($useranswer));

            echo "<table cellpadding=\"5\" cellspacing=\"10\" align=\"center\" class=\"results names\">";
            echo "<tr>";
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<th class=\"col$count header\" width=\"$tablewidth%\">";
                } else if ($miechoice->showunanswered) {
                    echo "<th class=\"col$count header\" width=\"$tablewidth%\">";
                } else {
                    continue;
                }
                echo format_string(miechoice_get_option_text($miechoice, $optionid));
                echo "</th>";
                $count++;
            }
            echo "</tr><tr>";

            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<td class=\"col$count data\" width=\"$tablewidth%\" valign=\"top\" nowrap=\"nowrap\">";
                } else if ($miechoice->showunanswered) {
                    echo "<td class=\"col$count data\" width=\"$tablewidth%\" valign=\"top\" nowrap=\"nowrap\">";
                } else {
                    continue;
                }

                echo "<table width=\"100%\">";
                foreach ($userlist as $user) {
                    if (!($optionid==0 && isadmin($user->id)) && !($optionid==0 && isteacher($course->id, $user->id) && !(isteacheredit($course->id, $user->id)) )  ) { //make sure admins and hidden teachers are not shown in not answered yet column.
                        echo "<tr><td width=\"10\" nowrap=\"nowrap\" class=\"picture\">";
                        print_user_picture($user->id, $course->id, $user->picture);
                        echo "</td><td width=\"100%\" nowrap=\"nowrap\" class=\"fullname\">";
                        echo fullname($user, $isteacher);
                        echo "</td></tr>";
                    }
                }
                $count++;
                echo "</table>";

                echo "</td>";
            }
            echo "</tr><tr>";
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                echo "<td align=\"center\" class=\"count\">";
                if ($miechoice->limitanswers && !$optionid==0) {
                    echo get_string("taken", "miechoice").":";
                    echo miechoice_get_course_answer($miechoice->id, $optionid, $currentgroup,'a.id ASC');
                    echo "<br>";
                    echo get_string("limit", "miechoice").":";
                    $miechoice_option = get_record("miechoice_options", "id", $optionid);
                    echo $miechoice_option->maxanswers;
                }
                echo "</td>";
                $count++;
            }
            
            echo "</tr></table>";
            break;


          case MIECHOICE_PUBLISH_ANONYMOUS:
            $tablewidth = (int) (100.0 / count($useranswer));

            echo "<table cellpadding=\"5\" cellspacing=\"10\" align=\"center\" class=\"results anonymous\">";
            echo "<tr>";
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<th width=\"$tablewidth%\" class=\"col$count header\">";
                } else if ($miechoice->showunanswered) {
                    echo "<th width=\"$tablewidth%\" class=\"col$count header\">";
                } else {
                    continue;
                }
                echo format_string(miechoice_get_option_text($miechoice, $optionid));
                echo "</th>";
                $count++;
            }
            echo "</tr><tr>";

            $maxcolumn = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                $column[$optionid] = 0;
                foreach ($userlist as $user) {
                    if (!($optionid==0 && isadmin($user->id)) && !($optionid==0 && isteacher($course->id, $user->id) && !(isteacheredit($course->id, $user->id)) )  ) { //make sure admins and hidden teachers are not shown in not answered yet column.
                         $column[$optionid]++;
                    }
                }
                if ($column[$optionid] > $maxcolumn) {
                    $maxcolumn = $column[$optionid];
                }
            }

            echo "</tr><tr>";
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                $height = 0;
                if ($maxcolumn) {
                    $height = $COLUMN_HEIGHT * ((float)$column[$optionid] / (float)$maxcolumn);
                }
                echo "<td valign=\"bottom\" align=\"center\" class=\"col$count data\">";
                echo "<img src=\"column.png\" height=\"$height\" width=\"49\" alt=\"\" />";
                echo "</td>";
                $count++;
            }
            echo "</tr>";

            echo "<tr>";
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                echo "<td align=\"center\" class=\"col$count count\">";
                if ($miechoice->limitanswers && !$optionid==0) {
                    echo get_string("taken", "miechoice").":";
                    echo $column[$optionid];
                    echo "<br>";
                    echo get_string("limit", "miechoice").":";
                    $miechoice_option = get_record("miechoice_options", "id", $optionid);
                    echo $miechoice_option->maxanswers;
                } else {
                    echo $column[$optionid];
                }
                echo "</td>";
                $count++;
            }
            echo "</tr></table>";

            break;
        }
        print_simple_box_end ();
    }
?>
