<?php  // $Id: report.php,v 1.33 2005/08/14 21:59:09 danmarsden Exp $

    $format   = optional_param('format', MIECHOICE_PUBLISH_NAMES, PARAM_INT);

    require_login($course->id, false, $cm);

    if (!isteacher($course->id)) {
        error('Only teachers can look at this page');
    }

    $strmiechoice = get_string('modulename', 'miechoice');
    $strmiechoices = get_string('modulenameplural', 'miechoice');
    $strresponses = get_string('responses', 'miechoice');

    add_to_log($course->id, 'miechoice', 'report', "report.php?id=$cm->id", "$miechoice->id",$cm->id);

    if ($currentgroup) {
        $users = get_group_users($currentgroup, 'u.username ASC', '', 'u.id, u.picture, u.firstname, u.lastname');
    } else {
        $users = get_course_users($course->id, 'u.username ASC', '', 'u.id, u.picture, u.firstname, u.lastname') + get_admins();
    }

    if (!$users) {
        print_heading(get_string('nousersyet'));
    }

    if ($allresponses = get_records('miechoice_answers', 'miechoiceid', $miechoice->id)) {
        foreach ($allresponses as $aa) {
            $answers[$aa->userid] = $aa;
        }
    } else {
        $answers = array () ;
    }

    $timenow = time();

    foreach ($miechoice->option as $optionid => $text) {
        $useranswer[$optionid] = array();
    }
    if ( !empty($users)) {
           foreach ($users as $user) {
        if (!empty($user->id) and !empty($answers[$user->id])) {
            $answer = $answers[$user->id];
            $useranswer[(int)$answer->optionid][] = $user;
        } else {
            $useranswer[0][] = $user;
        }
        }
       }
    foreach ($miechoice->option as $optionid => $text) {
        if (!$miechoice->option[$optionid]) {
            unset($useranswer[$optionid]);     // Throw away any data that doesn't apply
        }
    }
    ksort($useranswer);

    print_simple_box_start ('center','*');

    switch ($format) {
        case MIECHOICE_PUBLISH_NAMES:

            $tablewidth = (int) (100.0 / count($useranswer));

            echo '<table cellpadding="5" cellspacing="10" align="center" class="results names">';
            echo '<tr>';
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<th class=\"col$count header\" width=\"$tablewidth%\">";
                } else if ($miechoice->showunanswered) {
                    echo "<th class=\"col$count header\" width=\"$tablewidth%\">";
                } else {
                    continue;
                }
                echo format_string(miechoice_get_option_text($miechoice, $optionid));
                echo '</th>';
                $count++;
            }
            echo '</tr><tr>';

            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<td class=\"col$count data\" width=\"$tablewidth%\" valign=\"top\" nowrap=\"nowrap\">";
                } else if ($miechoice->showunanswered) {
                    echo "<td class=\"col$count data\" width=\"$tablewidth%\" valign=\"top\" nowrap=\"nowrap\">";
                } else {
                    continue;
                }

                echo '<table width="100%" cellpadding="0" cellspacing="0">';
                foreach ($userlist as $user) {
                    if (!($optionid==0 && isadmin($user->id)) && !($optionid==0 && isteacher($course->id, $user->id) && !(isteacheredit($course->id, $user->id)) )  ) { //make sure admins and hidden teachers are not shown in not answered yet column.
                        echo '<tr><td width="10" nowrap="nowrap" class="picture">';
                        print_user_picture($user->id, $course->id, $user->picture);
                        echo '</td><td width="100%" nowrap="nowrap" class="fullname">';
                        echo '<p>'.fullname($user, true).'</p>';
                        echo '</td></tr>';
                    }
                }
                echo '</table></td>';
                $count++;
            }
            echo '</tr></table>';
            break;

        case MIECHOICE_PUBLISH_ANONYMOUS:
            $tablewidth = (int) (100.0 / count($useranswer));

            echo '<table cellpadding="5" cellspacing="10" align="center" class="results anonymous">';
            echo '<tr>';
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if ($optionid) {
                    echo "<th width=\"$tablewidth%\" class=\"col$count header\">";
                } else if ($miechoice->showunanswered) {
                    echo "<th width=\"$tablewidth%\" class=\"col$count header\">";
                } else {
                    continue;
                }
                echo miechoice_get_option_text($miechoice, $optionid);
                echo '</th>';
                $count++;
            }
            echo '</tr>';

            $maxcolumn = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                $column[$optionid] = count($userlist);
                if ($column[$optionid] > $maxcolumn) {
                    $maxcolumn = $column[$optionid];
                }
            }

            echo '<tr>';
            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                $height = 0;
                if ($maxcolumn) {
                    $height = $COLUMN_HEIGHT * ((float)$column[$optionid] / (float)$maxcolumn);
                }
                echo "<td valign=\"bottom\" align=\"center\" class=\"col$count data\">";
                echo "<img src=\"column.png\" height=\"$height\" width=\"49\" alt=\"\" />";
                echo '</td>';
                $count++;
            }
            echo '</tr><tr>';

            $count = 0;
            foreach ($useranswer as $optionid => $userlist) {
                if (!$optionid and !$miechoice->showunanswered) {
                    continue;
                }
                echo "<td align=\"center\" class=\"col$count count\">".$column[$optionid]."</td>";
                $count++;
            }
            echo '</tr></table>';

            break;
    }
    
    echo '<br>';
    echo '<form name="form" method="post" action="view.php">';
    echo '<table border="0" align="center"><tr>';
    echo '<td colspan="2" align="center">';
    $strencode = get_string('selectencode','miechoice');
    echo "<b>$strencode &nbsp;: &nbsp;</b>";
    $selected = get_string('thischarset');
    $options = miechoice_encording_get_list();
    miechoice_encording_choose_from_menu($options, 'encode', $selected, 'true');
    helpbutton('encode', get_string('selectencode','miechoice'), 'miechoice');
    echo '</td><tr><td>';
    $strxls = get_string('downloadexcel');
    echo "<input type=\"hidden\" name=\"id\"        value=$id>";
    echo "<input type=\"hidden\" name=\"tabid\"   value=$tabid>";
    echo "<input type=\"submit\" name=\"dlexcel\" value=\"$strxls\">";
    echo '</td><td>';
    $strtxt = get_string('downloadtext');
    echo "<input type=\"hidden\" name=\"id\"       value=$id>";
    echo "<input type=\"hidden\" name=\"tabid\"   value=$tabid>";
    echo "<input type=\"submit\" name=\"dltext\"  value=\"$strtxt\">";
    echo '</td></tr></table></form>';

    print_simple_box_end ();

?>
