<?php  // $Id: view.php,v 1.74 2005/09/20 09:22:06 thepurpleblob Exp $

    require_once('../../config.php');
    require_once('lib.php');

    $id = required_param('id',PARAM_INT);    // Course Module ID

    if (! $cm = get_record('course_modules', 'id', $id)) {
        error('Course Module ID was incorrect');
    }

    if (! $course = get_record('course', 'id', $cm->course)) {
        error('Course is misconfigured');
    }

    require_course_login($course, false, $cm);

    if (!$miechoice = miechoice_get_miechoice($cm->instance)) {
        error('Course module is incorrect');
    }

    if ($miechoice->option) {
        foreach ($miechoice->option as $optionid => $text) {
            $answerchecked[$optionid] = '';
        }
    }

    /// Check to see if groups are being used in this miechoice
    if ($groupmode = groupmode($course, $cm)) {   // Groups are being used
        $currentgroup = set_current_group($course->id, $miechoice->groupid);
    } else {
        $currentgroup = set_current_group($course->id, false);
    }

    $current = get_record('miechoice_answers', 'miechoiceid', $miechoice->id, 'userid', $USER->id);

    /// Submit any new data if there is any
    if ( isset($savechange) && $form = data_submitted()) {
        $timenow = time();
        if (empty($form->answer)) {
            redirect("view.php?id=$cm->id", get_string('mustchooseone', 'miechoice'));
        } else {
            $countanswers = miechoice_get_course_answer($miechoice->id, $form->answer, $form->groupid,'a.id ASC');
            $maxans = $miechoice->maxanswers[$form->answer];
            if (!($miechoice->limitanswers && ($countanswers >= $maxans) )) {
                if ($current) {
                    $newanswer = $current;
                    $newanswer->optionid = $form->answer;
                    $newanswer->timemodified = $timenow;
                    if (! update_record('miechoice_answers', $newanswer)) {
                        error('Could not update your miechoice because of a database error');
                    }
                    add_to_log($course->id, 'miechoice', 'choose again', "view.php?id=$cm->id", $miechoice->id, $cm->id);
                } else {
                    $newanswer = NULL;
                    $newanswer->miechoiceid = $miechoice->id;
                    $newanswer->userid = $USER->id;
                    $newanswer->optionid = $form->answer;
                    $newanswer->timemodified = $timenow;
                    if (! insert_record('miechoice_answers', $newanswer)) {
                        error('Could not save your miechoice');
                    }
                    add_to_log($course->id, 'miechoice', 'choose', "view.php?id=$cm->id", $miechoice->id, $cm->id);
                }
            } else {
                error(get_string('err_maxanswer','miechoice' ,$maxans),"./view.php?id=$cm->id");
            }
        }
        $option = get_record('miechoice_options','id',$form->answer);
        $struserchoice = get_string('yourselection','miechoice').':&nbsp;'.$option->text;
        redirect("./view.php?id=$cm->id",$struserchoice);
        exit;
    }

    if (! isset($tabid) or isset($cancel)) $tabid = MIECHOICE_TAB_ID_MIECHOICE;

    // download report.
    if ( isteacher( $course->id)  &&  ($tabid == MIECHOICE_TAB_ID_REPORT) && (isset($dlexcel) || isset($dltext))) {
        include('download.php');
    }

    add_to_log($course->id, 'miechoice', 'view', "view.php?id=$cm->id", $miechoice->id, $cm->id);

    /// Display the miechoice and possibly results
    $strmiechoice = get_string('modulename', 'miechoice');
    $strmodulename = get_string('modulename','miechoice');
    $strmodulenameplural = get_string('modulenameplural', 'miechoice');

    switch ($tabid) {
    case MIECHOICE_TAB_ID_SENDMAIL:
        $strheadtab = get_string('mailtostudents', 'miechoice');
        break;
    case MIECHOICE_TAB_ID_REPORT:
        $strheadtab = get_string('reports', 'miechoice');
        break;
    case MIECHOICE_TAB_ID_MIECHOICE:
    default:
        $strheadtab = $strmiechoice;
        break;
    }

    // Show only a teacher UPDATE a button.
    $updatebutton = isteacher($course->id) ? update_module_button($cm->id, $course->id, $strmodulename) : '';

     print_header("$course->shortname: $strheadtab", "$course->fullname",
               "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> -> 
               <a href=\"$CFG->wwwroot/mod/miechoice/index.php?id=$course->id\">$strmodulenameplural</a> -> 
               $strheadtab", '', '', false , $updatebutton);

    if ( isteacher($course->id)) {
        miechoice_tab_menu($MIECHOICE_TAB_MENU, $tabid, "view.php?id=$id");
    } else if ( isstudent($course->id) ) {
        miechoice_tab_menu($MIECHOICE_TAB_STUDENT_MENU, $tabid, "view.php?id=$id");
    }

    miechoice_print_group($course->id, $groupmode);

    print_spacer(10);

    switch ($tabid) {
    case MIECHOICE_TAB_ID_SENDMAIL:
        include('tabsendmail.php');
        break;
    case MIECHOICE_TAB_ID_REPORT:
        include('tabreport.php');
        break;
    case MIECHOICE_TAB_ID_MIECHOICE:
    default:
        include('tabedit.php');
        break;
    }

    print_footer();

?>
