<?php  // $Id: lib.php,v 1.16 2007/01/19 03:36:58 mchurch Exp $

require_once('locallib.php');

/// Library of functions and constants for module questionnaire
/// (replace questionnaire with the name of your module and delete this line)

define ('QUESTIONNAIREUNLIMITED', 0);
define ('QUESTIONNAIREONCE', 1);
define ('QUESTIONNAIREDAILY', 2);
define ('QUESTIONNAIREWEEKLY', 3);
define ('QUESTIONNAIREMONTHLY', 4);
$QUESTIONNAIRE_TYPES = array (QUESTIONNAIREUNLIMITED => get_string('qtypeunlimited', 'questionnaire'),
                              QUESTIONNAIREONCE => get_string('qtypeonce', 'questionnaire'),
                              QUESTIONNAIREDAILY => get_string('qtypedaily', 'questionnaire'),
                              QUESTIONNAIREWEEKLY => get_string('qtypeweekly', 'questionnaire'),
                              QUESTIONNAIREMONTHLY => get_string('qtypemonthly', 'questionnaire'));
$QUESTIONNAIRE_RESPONDENTS = array ('fullname' => get_string('respondenttypefullname', 'questionnaire'),
                                    'anonymous' => get_string('respondenttypeanonymous', 'questionnaire'));
$QUESTIONNAIRE_ELIGIBLES = array ('all' => get_string('respondenteligibleall', 'questionnaire'),
                                  'students' => get_string('respondenteligiblestudents', 'questionnaire'),
                                  'teachers' => get_string('respondenteligibleteachers', 'questionnaire'));
$QUESTIONNAIRE_REALMS = array ('private' => get_string('private', 'questionnaire'),
                               'public' => get_string('public', 'questionnaire'),
                               'template' => get_string('template', 'questionnaire'));

$QUESTIONNAIRE_TEACHERVIEWRESPONSE = 0;
$QUESTIONNAIRE_STUDENTVIEWRESPONSE = 1;
$QUESTIONNAIRE_RESPONSEVIEWERS =
    array ( $QUESTIONNAIRE_TEACHERVIEWRESPONSE => get_string('responseviewteachers', 'questionnaire'),
            $QUESTIONNAIRE_STUDENTVIEWRESPONSE => get_string('responseviewstudents', 'questionnaire'));

$QUESTIONNAIRE_EDITING = 0;
$QUESTIONNAIRE_ACTIVE1 = 1;
$QUESTIONNAIRE_ENDED = 3;
$QUESTIONNAIRE_ARCHIVED = 4;
$QUESTIONNAIRE_TESTING = 8;
$QUESTIONNAIRE_ACTIVE2 = 9;


function questionnaire_add_instance($questionnaire) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will create a new instance and return the id number 
/// of the new instance.


    // Check the realm and set it to the survey if its set.
    if (!empty($questionnaire->sid) && !empty($questionnaire->realm)) {
        set_field('questionnaire_survey', 'realm', $questionnaire->realm, 'id', $questionnaire->sid);
    }

    $questionnaire->timemodified = time();

    # May have to add extra stuff in here #
    $questionnaire->useopendate = (isset($questionnaire->useopendate)) ? 1 : 0;
    $questionnaire->useclosedate = (isset($questionnaire->useclosedate)) ? 1 : 0;

    if ($questionnaire->useopendate) {
        $questionnaire->opendate =
            make_timestamp($questionnaire->openyear, $questionnaire->openmonth, $questionnaire->openday,
                           $questionnaire->openhour, $questionnaire->openminute, 0);
    }
    else {
        $questionnaire->opendate = 0;
    }

    if ($questionnaire->useclosedate) {
        $questionnaire->closedate =
            make_timestamp($questionnaire->closeyear, $questionnaire->closemonth, $questionnaire->closeday,
                           $questionnaire->closehour, $questionnaire->closeminute, 0);
    }
    else {
        $questionnaire->closedate = 0;
    }

    if ($questionnaire->resume == 'Y') {
        $questionnaire->resume = 1;
    } else {
        $questionnaire->resume = 0;
    }
    $questionnaire->navigate = 1;

    return insert_record("questionnaire", $questionnaire);
}


function questionnaire_update_instance($questionnaire) {
/// Given an object containing all the necessary data, 
/// (defined by the form in mod.html) this function 
/// will update an existing instance with new data.

    // Check the realm and set it to the survey if its set.
    if (!empty($questionnaire->sid) && !empty($questionnaire->realm)) {
        set_field('questionnaire_survey', 'realm', $questionnaire->realm, 'id', $questionnaire->sid);
    }

    $questionnaire->timemodified = time();
    $questionnaire->id = $questionnaire->instance;

    # May have to add extra stuff in here #
    $questionnaire->useopendate = (isset($questionnaire->useopendate)) ? 1 : 0;
    $questionnaire->useclosedate = (isset($questionnaire->useclosedate)) ? 1 : 0;

    if ($questionnaire->useopendate) {
        $questionnaire->opendate =
            make_timestamp($questionnaire->openyear, $questionnaire->openmonth, $questionnaire->openday,
                           $questionnaire->openhour, $questionnaire->openminute, 0);
    }
    else {
        $questionnaire->opendate = 0;
    }

    if ($questionnaire->useclosedate) {
        $questionnaire->closedate =
            make_timestamp($questionnaire->closeyear, $questionnaire->closemonth, $questionnaire->closeday,
                           $questionnaire->closehour, $questionnaire->closeminute, 0);
    }
    else {
        $questionnaire->closedate = 0;
    }

    if ($questionnaire->resume == 'Y') {
        $questionnaire->resume = 1;
    } else {
        $questionnaire->resume = 0;
    }
    $questionnaire->navigate = 1;

    return update_record("questionnaire", $questionnaire);
}


function questionnaire_delete_instance($id) {
/// Given an ID of an instance of this module, 
/// this function will permanently delete the instance 
/// and any data that depends on it.  

    if (! $questionnaire = get_record('questionnaire', 'id', $id)) {
        return false;
    }

    $result = true;

    if (! delete_records('questionnaire', 'id', $questionnaire->id)) {
        $result = false;
    }

    if ($survey = get_record('questionnaire_survey', 'id', $questionnaire->sid)) {
    /// If this survey is owned by this course, delete all of the survey records and responses.
        if ($survey->owner == $questionnaire->course) {
            $result = $result && questionnaire_delete_survey($questionnaire->sid, $questionnaire->id);
        }
    }

    return $result;
}

function questionnaire_user_outline($course, $user, $mod, $questionnaire) {
/// Return a small object with summary information about what a 
/// user has done with a given particular instance of this module
/// Used for user activity reports.
/// $return->time = the time they did it
/// $return->info = a short text description

    return $return;
}

function questionnaire_user_complete($course, $user, $mod, $questionnaire) {
/// Print a detailed representation of what a  user has done with 
/// a given particular instance of this module, for user activity reports.

    return true;
}

function questionnaire_print_recent_activity($course, $isteacher, $timestart) {
/// Given a course and a time, this module should find recent activity 
/// that has occurred in questionnaire activities and print it out. 
/// Return true if there was output, or false is there was none.

    global $CFG;

    return false;  //  True if anything was printed, otherwise false 
}

function questionnaire_cron () {
/// Function to be run periodically according to the moodle cron
/// This function searches for things that need to be done, such 
/// as sending out mail, toggling flags etc ... 

    global $CFG;

    return questionnaire_cleanup();
}

function questionnaire_grades($questionnaireid) {
/// Must return an array of grades for a given instance of this module, 
/// indexed by user.  It also returns a maximum allowed grade.

    return NULL;
}

function questionnaire_get_participants($questionnaireid) {
//Must return an array of user records (all data) who are participants
//for a given instance of questionnaire. Must include every user involved
//in the instance, independient of his role (student, teacher, admin...)
//See other modules as example.
    global $CFG;

    //Get students
    $users = get_records_sql('SELECT DISTINCT u.* '.
                             'FROM '.$CFG->prefix.'user u, '.
                             '     '.$CFG->prefix.'questionnaire_attempts qa '.
                             'WHERE qa.qid = \''.$questionnaireid.'\' AND '.
                             '      u.id = qa.userid');
    return ($users);
}

//////////////////////////////////////////////////////////////////////////////////////
/// Any other questionnaire functions go here.  Each of them must have a name that 
/// starts with questionnaire_

/// This function *really* shouldn't be needed, but since sometimes we can end up with
/// orphaned surveys, this will clean them up.
function questionnaire_cleanup() {
    global $CFG;

    /// Find surveys that don't have questionnaires associated with them.
    $sql = 'SELECT qs.* FROM '.$CFG->prefix.'questionnaire_survey qs '.
           'LEFT JOIN '.$CFG->prefix.'questionnaire q ON q.sid = qs.id '.
           'WHERE q.sid IS NULL';

    if ($surveys = get_records_sql($sql)) {
        foreach ($surveys as $survey) {
            questionnaire_delete_survey($survey->id, 0);
        }
    }
    return true;
}

function questionnaire_record_submission(&$questionnaire, $userid, $rid=0) {
    $attempt['qid'] = $questionnaire->id;
    $attempt['userid'] = $userid;
    $attempt['rid'] = $rid;
    $attempt['timemodified'] = time();
    return insert_record("questionnaire_attempts", (object)$attempt, false);
}

function questionnaire_delete_survey($sid, $qid) {
    global $QUESTIONNAIRE_ARCHIVED;
/// Until backup is implemented, just mark the survey as archived.

    $status = true;

    /// Delete all responses for the survey:
    if ($responses = get_records('questionnaire_response', 'survey_id', $sid, 'id')) {
        foreach ($responses as $response) {
            $status = $status && questionnaire_delete_response($response->id);
        }
    }

    /// There really shouldn't be any more, but just to make sure...
    delete_records('questionnaire_response', 'survey_id', $sid);
    delete_records('questionnaire_attempts', 'qid', $qid);

    /// Delete all question data for the survey:
    if ($questions = get_records('questionnaire_question', 'survey_id', $sid, 'id')) {
        foreach ($questions as $question) {
            delete_records('questionnaire_question_choice', 'question_id', $question->id);
        }
        $status = $status && delete_records('questionnaire_question', 'survey_id', $sid);
    }

    $status = $status && delete_records('questionnaire_survey', 'id', $sid);

    return $status;
}

function questionnaire_delete_response($rid) {

    $status = true;

    /// Delete all of the survey response data:
    delete_records('questionnaire_response_bool', 'response_id', $rid);
    delete_records('questionnaire_response_date', 'response_id', $rid);
    delete_records('questionnaire_response_multiple', 'response_id', $rid);
    delete_records('questionnaire_response_other', 'response_id', $rid);
    delete_records('questionnaire_response_rank', 'response_id', $rid);
    delete_records('questionnaire_response_single', 'response_id', $rid);
    delete_records('questionnaire_response_text', 'response_id', $rid);

    $status = $status && delete_records('questionnaire_response', 'id', $rid);
    $status = $status && delete_records('questionnaire_attempts', 'rid', $rid);

    return $status;
}

function questionnaire_get_active_surveys_menu() {
    global $QUESTIONNAIRE_ACTIVE1;
    global $QUESTIONNAIRE_ACTIVE2;

    $select = "status in ($QUESTIONNAIRE_ACTIVE1,$QUESTIONNAIRE_ACTIVE2)";
    return get_records_select_menu('questionnaire_survey', $select);
}

function questionnaire_get_surveys_menu($status=NULL) {

    $field = ($status) ? 'status' : $status;
    return get_records_menu('questionnaire_survey', $field, $status);
}

/// Functions to call directly into phpESP.
/// Make sure a "require_once('phpESP/admin/phpESP.ini.php')" line is included.
/// Don't need to include this for all library functions, so don't.
function questionnaire_get_survey_list($courseid=0, $type='') {
    global $QUESTIONNAIRE_EDITING, $QUESTIONNAIRE_ACTIVE1, $QUESTIONNAIRE_ENDED,
           $QUESTIONNAIRE_ARCHIVED, $QUESTIONNAIRE_TESTING, $QUESTIONNAIRE_ACTIVE2;

    if ($courseid == 0) {
        if (isadmin()) {
            $select = '';
            $fields = 'id,name,owner,realm,public,status';
        } else {
            return false;
        }
    } else if (!empty($type)) {
        if ($type == 'public') {
            $select = 'status != '.$QUESTIONNAIRE_ARCHIVED.' AND realm = \''.$type.'\' ';
    /// Any survey owned by the user or typed as 'template' can be copied.
        } else if ($type == 'template') {
            $select = 'status != '.$QUESTIONNAIRE_ARCHIVED.' AND '
                      .'(realm = \''.$type.'\' OR owner = \''.$courseid.'\') ';
        }
        $fields = 'id,name,owner,realm,status';
    } else {
        $select = 'status != '.$QUESTIONNAIRE_ARCHIVED.' AND owner = \''.$courseid.'\' ';
        $fields = 'id,name,owner,realm,status';
    }
    return get_records_select('questionnaire_survey', $select, 'realm,name', $fields);
}

function questionnaire_survey_has_questions($sid) {
    return record_exists('questionnaire_question', 'survey_id', $sid, 'deleted', 'N');
}

function questionnaire_survey_exists($sid) {
    return record_exists('questionnaire_survey', 'id', $sid);
}

function questionnaire_print_survey_select($instance, $courseid=0, $sid=0, $fname='sid', $usenone=false, $type='') {
    global $CFG;

    if ($surveys = questionnaire_get_survey_list($courseid, $type)) {
        $table->head[] = get_string('select');
        $table->head[] = get_string('name');
        $table->head[] = get_string('type', 'questionnaire');
        $table->align = array('center', 'left', 'center');
        $table->size = array('*', '100%', '*');
        $table->wrap = array('', '', 'nowrap');

        if ($usenone) {
            $select = '<input type="radio" name="sid" value="0"'.(($sid == 0)?' checked':'').'>';
            $stat = '';
            $table->data[] = array($select, 'none', $stat);
        }

        $strpreview = get_string('preview');
        $strunknown = get_string('unknown', 'questionnaire');
        $strpublic = get_string('public', 'questionnaire');
        $strprivate = get_string('private', 'questionnaire');
        $strtemplate = get_string('template', 'questionnaire');
        $strinuse = get_string('inuse', 'questionnaire');
        $strnotused = get_string('notused', 'questionnaire');
        $strviewresp = get_string('viewresponses', 'questionnaire');

        foreach ($surveys as $survey) {
            if (empty($survey->realm)) {
                $stat = '<font size="-1">'.$strunknown;
            } else if ($survey->realm == 'public') {
                $stat = '<font size="-1">'.$strpublic;
            } else if ($survey->realm == 'private') {
                $stat = '<font size="-1">'.$strprivate;
            } else if ($survey->realm == 'template') {
                $stat = '<font size="-1">'.$strtemplate;
            } else {
                $stat = '<font size="-1">'.$strunknown;
            }

            $select = '<input type="radio" name="'.$fname.'" value="'.$type.'-'.$survey->id.'"'.
                      (($survey->id == $sid)?' checked':'').'>';

            $view = link_to_popup_window('/mod/questionnaire/manage_survey.php?course='.$courseid.
                                         '&amp;qact=preview&amp;instance='.$instance.'&amp;sid='.$survey->id,
                                         $strpreview, '<font size="-1">'.$survey->name.'</font>', 
                                         '', '', $strpreview, '', true);
            $table->data[] = array($select, $view, $stat);
        }
        print_table($table);
        return true;
    } else {
        return false;
    }
}
?>
