<?php  // $Id: manage_survey.php,v 1.17 2007/01/19 03:36:58 mchurch Exp $

/// This page prints a particular instance of questionnaire

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/questionnaire/lib.php');

    global $errstr;

    $errstr = '';

    $courseid = optional_param('course', NULL, PARAM_INT);        // course ID - if new
    $instance = optional_param('instance', NULL, PARAM_INT);    // questionnaire ID - if update
    $section = optional_param('section', NULL, PARAM_INT);
    $qact = optional_param('qact', 'unknown');
    $sid = optional_param('sid', 0, PARAM_INT);              // Survey id.

    if (!empty($courseid)) {
        if (! $c_obj = get_record('course', 'id', $courseid)) {
            error("Course is misconfigured");
        }
    } 
    if (!empty($instance)) {
        if (! $questionnaire = get_record("questionnaire", "id", $instance)) {
            error("Questionnaire is incorrect");
        }
        if (!isset($c_obj)) {
            if (! $c_obj = get_record("course", "id", $questionnaire->course)) {
                error("Course is misconfigured");
            }
        }
    }
    if (isset($questionnaire) && isset($c_obj)) {
        if (! $cm = get_coursemodule_from_instance("questionnaire", $questionnaire->id, $c_obj->id)) {
            error("Course Module ID was incorrect");
        }
    }

    require_login($c_obj->id);

    if (!isteacheredit($c_obj->id)) {
        error('These functions are restricted to editing teachers only!');
    }
    
    $formdata = data_submitted('nomatch');
    if (!isset($formdata->sid)) {
        if (empty($sid) && !empty($SESSION->questionnaire_survey_id)) {
            $formdata->sid = $sid = $SESSION->questionnaire_survey_id;
        } else {
        	$formdata->sid = 0;
        }
    }
    if (!isset($formdata->summary)) {
        $formdata->summary = '';
    }

    /// If creating a new one, this'll be empty.
    if (empty($questionnaire)) {
        $questionnaire->id = 0;
        $questionnaire->sid = clean_param($formdata->sid, PARAM_INT);
    }

    if (!isset($c_obj)) {
        $c_obj = false;
    }
    if (!isset($cm)) {
        $cm = false;
    }

    $questionnaire = new questionnaire(0, $questionnaire, $c_obj, $cm);
    $tab = 'general';

    if (isset($SESSION->questionnaire_tab)) {
        $formdata->tab = $SESSION->questionnaire_tab;
        unset($SESSION->questionnaire_tab);
    }

    $byresponse = false;
    if (isset($formdata)) {
        $cancancel = false;
        if (!isset($formdata->tab)) {
            $formdata->tab = $tab;
        }
    /// QACTION comes from questionnaire/mod.html
        if (isset($formdata->qaction)) {
        /// If this was submitted from the module form, save the data in the SESSION variable.
        /// This is used by '/course/mod.php'.

            /// Need to create the open and close dates...
            if (!empty($formdata->useopendate)) {
                $formdata->opendate =
                    make_timestamp($formdata->openyear, $formdata->openmonth, $formdata->openday,
                                   $formdata->openhour, $formdata->openminute, 0);
            } else {
                $formdata->opendate = 0;
            }
            if (!empty($formdata->useclosedate)) {
                $formdata->closedate =
                    make_timestamp($formdata->closeyear, $formdata->closemonth, $formdata->closeday,
                                   $formdata->closehour, $formdata->closeminute, 0);
            } else {
                $formdata->closedate = 0;
            }

            $SESSION->modform = $formdata;
            /// If this is a new survey, check how its created.
            if (isset($formdata->create)) {
                $create = explode('-', $formdata->create);
                if ($create['0'] == 'public') {
                    $formdata->sid = $sid = (int)$create[1];
                    $qact = 'close';
                } else if ($create['0'] == 'template') {
                    $formdata->sid = $sid = (int)$create[1];
                    $qact = 'copy';
                } else {
                    unset($SESSION->questionnaire_survey_id);
                    $qact = 'new';
                }
            } else {
                $SESSION->questionnaire_survey_id = $formdata->sid;
                $qact = 'edit';
            }
    /// ACTION comes from this form.
        } else {
            if (isset($formdata->action)) {

            /// First make sure that all requirements have been met...
                if (($formdata->tab == 'general') &&
                    (empty($formdata->name) || empty($formdata->title))) {
                    $error_message = 'Must specify a valid name and title.';
                    $tab = 'general';
                    if (empty($formdata->sid)) {
                        $qact = 'new';
                    } else {
                        $qact = 'edit';
                    }
                } else {
    
                switch ($formdata->action) {
            
                case 'Cancel & Return':
                    if (empty($instance)) {
                        $args = 'id='.$courseid.'&section='.$section.'&sesskey='.$USER->sesskey.'&add=questionnaire';
                    } else {
                        $args = 'update='.$cm->id.'&sesskey='.$USER->sesskey;
                    }
                    redirect($CFG->wwwroot.'/course/mod.php?'.$args);
                    break;
            
                case 'Save & Return':
                    $tab = 'general';
                    $qact = 'close';
                    break;
            
                case 'General':
                    $tab = 'general';
                    $qact = 'edit';
                    break;
            
                case 'Edit Questions':
                    $tab = 'questions';
                    $qact = 'equest';
                    break;
            
                case 'Reorder Questions':
                    $tab = 'order';
                    $qact = 'oquest';
                    break;
                }
                }
            /// 'q' comes from the question editor as a submit, and can be from the reorder form.
            } else if (isset($formdata->q)) {
                if ($formdata->tab == 'order' && empty($formdata->q)) {
                    $tab = 'order';
                    $qact = 'oquest';
                } else {
                    $tab = 'questions';
                    $qact = 'equest';
                }
            /// 'extra_choices' comes from the question editor as a submit.
            } else if (isset($formdata->extra_choices)) {
                $tab = 'questions';
                $qact = 'equest';
            } else if (isset($formdata->addbreak)) {
                $tab = 'order';
                $qact = 'oquest';
            } else if (isset($formdata->confirm)) {
                if ($formdata->confirm == 'Yes') {
                    set_field('questionnaire_survey', 'status', STATUS_DELETED, 'id', $sid);
                }
                if (empty($instance)) {
                    $args = 'id='.$courseid.'&section='.$section.'&sesskey='.$USER->sesskey.'&add=questionnaire';
                } else {
                    $args = 'update='.$cm->id.'&sesskey='.$USER->sesskey;
                }
                redirect($CFG->wwwroot.'/course/mod.php?'.$args);
            } else {
                $cancancel = true;
            }

            if (($sid = $questionnaire->survey_update($formdata->tab, $formdata)) === false) {
                $sid = 0;
                $updated = false;
            } else {
                $updated = true;
            }

        }
    /// Commands like 'new' may load the sid in the session.
        if (empty($sid) && !empty($SESSION->questionnaire_survey_id)) {
            $sid = $SESSION->questionnaire_survey_id;
        }

    } else {
        $cancancel = true;
    }

    switch ($qact) {

    case 'close':
        $args = 'from=survey&sesskey='.$USER->sesskey.'&sid='.$formdata->sid;
        if (empty($instance)) {
            $args .= '&id='.$courseid.'&section='.$section.'&add=questionnaire';
        } else {
            $args .= '&update='.$cm->id;
        }
        redirect($CFG->wwwroot.'/course/mod.php?'.$args);
        break;

    case 'preview':
    /// Print the page header
        /// Templates may not have questionnaires yet...
        if (!isset($questionnaire->name)) {
            $name = get_field('questionnaire_survey', 'name', 'id', $sid);
            $questionnaire->sid = $sid;
            $questionnaire->add_questions($sid);
        } else {
            $name = $questionnaire->name;
        }
        print_header($c_obj->shortname.': Questionnaire Preview',
                     $c_obj->fullname.' Previewing Questionnaire '.$name, '', '', '', false);
    /// Print the main part of the page
        $SESSION->questionnaire_survey_id = $sid;
        include 'preview.inc';

        echo '<hr />'."\n";
        close_window_button();
    /// Finish the page
        if ($questionnaire->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;

    case 'delete':
        if (empty($questionnaire->survey)) {
            error('Survey does not exist. (0)');
        } else if ((int)$questionnaire->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Print the page header
        print_header_simple('Editing questionnaire', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$c_obj->id.'">'.'Questionnaires'.
                 '</a> -> '.'Editing survey');
    
    /// Print the main part of the page
        echo '<form name="phpesp" method="post" action="manage_survey.php">'."\n";
        echo '<input type="hidden" name="course" value="'.$courseid.'" />'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
        echo '<input type="hidden" name="section" value="'.$section.'" />'."\n";
        echo '<div class="headermain" align="center">Are you sure you want to delete survey: '.$surveyrec->name.'?<br /><br />';
        echo '<input type="submit" value="Yes" name="confirm" /> ';
        echo '<input type="submit" value="No" name="confirm" /> </div>';
        echo '</form>';

        print_footer($c_obj);
        break;

    case 'copy':
        /// survey_copy needs the owner field set:
        if (empty($questionnaire->survey)) {
            $questionnaire->add_survey($sid);
            $questionnaire->add_questions($sid);
        }
        $sid = $questionnaire->sid = $questionnaire->survey_copy($c_obj->id);
        /// Reload the new survey:
        $questionnaire->add_survey($questionnaire->sid);
        $questionnaire->add_questions($questionnaire->sid);
        
    /// Fall down into 'edit'.

    case 'edit':
        if (!($surveyrec = get_record_select('questionnaire_survey', 'id = '.$sid, 'id,name,owner'))) {
            error('Survey does not exist. (1)');
        } else if ((int)$surveyrec->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    case 'new':
    /// Print the page header
        print_header_simple('Editing questionnaire', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$c_obj->id.'">'.'Questionnaires'.
                 '</a> -> '.'Editing survey');

        if (!empty($errstr)) {
            p($errstr);
        }

    /// Print the main part of the page
        echo '<form name="phpesp" method="post" action="manage_survey.php">'."\n";
        echo '<input type="hidden" name="course" value="'.$courseid.'" />'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
        echo '<input type="hidden" name="section" value="'.$section.'" />'."\n";
        echo '<input type="hidden" name="tab" value="general" />'."\n";

        $updated = true;

        include 'general.inc';

        echo '<hr />'."\n";
        echo '<div align="center">';
        echo '<input type="submit" value="General" name="action" disabled="disabled" /> ';
        echo '<input type="submit" value="Edit Questions" name="action" /> ';
        if (questionnaire_survey_has_questions($sid)) {
            $disabled = '';
        } else {
            $disabled = 'disabled="disabled"';
        }
        echo '<input type="submit" value="Reorder Questions" name="action" '.$disabled.' /> ';
        button_to_popup_window('/mod/questionnaire/manage_survey.php?qact=preview&amp;course='.$courseid.
                               '&amp;instance='.$instance.'&amp;sid='.$sid.'&amp;section='.$section, 'Preview', 'Preview',0,0);
        if ($cancancel) {
            echo '<input type="submit" value="Cancel &amp; Return" name="action" /> ';
        }
        echo '<input type="submit" value="Save &amp; Return" name="action" /> ';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        if ($questionnaire->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;
        
    case 'equest':
        if (empty($questionnaire->survey)) {
            error('Please Use Internet Explorer to Edit Questionnaire.');
        } else if ((int)$questionnaire->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Print the page header
        print_header_simple('Editing questionnaire', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$c_obj->id.'">'.'Questionnaires'.
                 '</a> -> '.'Editing survey');
    
        if (!empty($errstr)) {
            p($errstr);
        }

    /// Print the main part of the page
        echo '<form name="phpesp" method="post" action="manage_survey.php">'."\n";
        echo '<input type="hidden" name="course" value="'.$courseid.'" />'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
        echo '<input type="hidden" name="section" value="'.$section.'" />'."\n";
        echo '<input type="hidden" name="tab" value="questions" />'."\n";

        $SESSION->questionnaire_survey_id = $sid;
        $SESSION->questionnaire_new_survey = false;
        include 'questions.inc';

        echo '<hr />'."\n";
        echo '<div align="center">';
        echo '<input type="submit" value="General" name="action" /> ';
        echo '<input type="submit" value="Edit Questions" name="action" disabled="disabled"/> ';
        if (questionnaire_survey_has_questions($sid)) {
            $disabled = '';
        } else {
            $disabled = 'disabled="disabled"';
        }
        echo '<input type="submit" value="Reorder Questions" name="action" '.$disabled.' /> ';
        button_to_popup_window('/mod/questionnaire/manage_survey.php?qact=preview&amp;instance='.$instance.
                               '&amp;course='.$courseid.'&amp;sid='.$sid.'&amp;section='.$section, 'Preview', 'Preview',0,0);
        echo '<input type="submit" value="Save &amp; Return" name="action" /> ';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        if ($questionnaire->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;
        
    case 'oquest':
        if (empty($questionnaire->survey)) {
            error('Survey does not exist. (3)');
        } else if ((int)$questionnaire->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Save  the tab in a session variablem to handle the reorder commands.
        $SESSION->questionnaire_tab = 'order';

    /// Print the page header
        print_header_simple('Editing questionnaire', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$c_obj->id.'">'.'Questionnaires'.
                 '</a> -> '.'Editing survey');
    
        if (!empty($errstr)) {
            p($errstr);
        }

    /// Print the main part of the page
        echo '<form method="post" name="phpesp" id="phpesp" action="manage_survey.php">'."\n";
        echo '<input type="hidden" name="course" value="'.$courseid.'" />'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
        echo '<input type="hidden" name="section" value="'.$section.'" />'."\n";
        echo '<input type="hidden" name="tab" value="order" />'."\n";

        $SESSION->questionnaire_survey_id = $sid;
        $SESSION->questionnaire_new_survey = false;
        include 'order.inc';

        echo '<hr />'."\n";
        echo '<div align="center">';
        echo '<input type="submit" value="General" name="action" /> ';
        if (questionnaire_survey_has_questions($sid)) {
            $disabled = '';
        } else {
            $disabled = 'disabled="disabled"';
        }
        echo '<input type="submit" value="Edit Questions" name="action" '.$disabled.' /> ';
        echo '<input type="submit" value="Reorder Questions" name="action" disabled="disabled" /> ';
        button_to_popup_window('/mod/questionnaire/manage_survey.php?qact=preview&amp;instance='.$instance.'&amp;course='.$courseid.
                               '&amp;sid='.$sid.'&amp;section='.$section, 'Preview', 'Preview',0,0);
        echo '<input type="submit" value="Save &amp; Return" name="action" /> ';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        if ($questionnaire->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;
        
        case 'unknown':
        default:
        $message = 'Unknown questionnaire action specified...<br />'."\n";
        if (empty($formdata)) {
            $message .= '<br />No data posted!';
        } else {
            $message .= '<br />Reached page with posted data:<br />'."\n";
            $message .= '<pre>'.print_r($formdata, true).'</pre><br />'."\n";
        }
        error($message);
        break;
    }
?>