<?php  // $Id: myreport.php,v 1.2 2007/01/18 16:24:16 mchurch Exp $

/// This page shows results of a questionnaire to a student.

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/questionnaire/lib.php');
    require_once($CFG->dirroot.'/mod/questionnaire/resultslib.php');

    $strall = get_string('all', 'questionnaire');
    $strsummary = get_string('summary', 'questionnaire');

    $instance = required_param('instance', PARAM_INT);   // questionnaire ID
    $userid = optional_param('user', $USER->id, PARAM_INT);
    $action = optional_param('action', $strsummary, PARAM_ALPHA);
    $rid = optional_param('rid', false, PARAM_INT);

    if (! $questionnaire = get_record("questionnaire", "id", $instance)) {
        error("Questionnaire is incorrect");
    }
    if (! $course = get_record("course", "id", $questionnaire->course)) {
        error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance("questionnaire", $questionnaire->id, $course->id)) {
        error("Course Module ID was incorrect");
    }

    require_login($course->id);
    if (($questionnaire->resp_view != $QUESTIONNAIRE_STUDENTVIEWRESPONSE) && !isteacher($course->id)) {
        error('These functions are restricted to teachers only!');
    }

    $strmodname = get_string('modulename', 'questionnaire');
    $strmodnameplural = get_string('modulenameplural', 'questionnaire');
    $strmyresults = get_string('myresults', 'questionnaire');

    $questionnaire = new questionnaire(0, $questionnaire, $course, $cm);
    $formdata = data_submitted();

    switch ($action) {
  
    case $strsummary:
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        }
        $select = 'survey_id = '.$questionnaire->sid.' AND username = '.$userid;
        $resps = get_records_select('questionnaire_response', $select);
        $rids = array_keys($resps);
        $titletext = get_string('myresponsetitle', 'questionnaire', count($resps));

    /// Print the page header
        print_header_simple($strmyresults, '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.$strmodnameplural.
                 '</a> -> '.$strmyresults);
    
        echo '<form name="myresults" method="post" action="myreport.php">'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="user" value="'.$userid.'" />'."\n";
    
        print_heading($titletext.':');
        $questionnaire->survey_results(1, 1, '', '', $rids, '', $USER->id);
    
        echo '<hr />'."\n";
        echo '<div align="center">';
        echo get_string('responseview', 'questionnaire').':';
        $i = 1;
        foreach ($resps as $resp) {
            echo ' <a href="myreport.php?instance='.$instance.'&user='.$userid.'&action=vresp&rid='.$resp->id.'"'.
                    'title="'.userdate($resp->submitted).'">'.$i.'</a>';
            $i++;
        }
        echo ' <input type="submit" value="'.$strall.'" name="action" /> ';
        echo ' <input type="submit" value="'.get_string('return', 'questionnaire').'" name="action" /> ';
    
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;

    case $strall:
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        }
        $rids = $rid;
        $select = 'survey_id = '.$questionnaire->sid.' AND username = '.$userid;
        $resps = get_records_select('questionnaire_response', $select);
        $titletext = get_string('myresponses', 'questionnaire');

    /// Print the page header
        print_header_simple($strmyresults, '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.$strmodnameplural.
                 '</a> -> '.$strmyresults);
    
        echo '<form name="myresults" method="post" action="myreport.php">'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="user" value="'.$userid.'" />'."\n";
    
        print_heading($titletext.':');

        $questionnaire->view_all_responses($resps);

        echo '<hr />'."\n";
        echo '<div align="center">';
        echo get_string('responseview', 'questionnaire').':';
        $i = 1;
        foreach ($resps as $resp) {
            echo ' <a href="myreport.php?instance='.$instance.'&user='.$userid.'&action=vresp&rid='.$resp->id.'" ' .
                 'title="'.userdate($resp->submitted).'">'.$i.'</a>';
            $i++;
        }
        echo ' <input type="submit" value="'.$strsummary.'" name="action" /> ';
        echo ' <input type="submit" value="'.get_string('return', 'questionnaire').'" name="action" /> ';
    
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;

    case 'vresp':
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        }
        $rids = $rid;
        $select = 'survey_id = '.$questionnaire->sid.' AND username = '.$userid.' AND complete=\'Y\'';
        $resps = get_records_select('questionnaire_response', $select);
        $titletext = get_string('myresponsedated', 'questionnaire', userdate($resps[$rid]->submitted));

    /// Print the page header
        print_header_simple($strmyresults, '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.$strmodnameplural.
                 '</a> -> '.$strmyresults);
    
        echo '<form name="myresults" method="post" action="myreport.php">'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="user" value="'.$userid.'" />'."\n";
    
        print_heading($titletext.':');

        $questionnaire->view_response($rid);

        echo '<hr />'."\n";
        echo '<div align="center">';
        echo get_string('responseview', 'questionnaire').':';
        $i = 1;
        foreach ($resps as $resp) {
            echo ' <a href="myreport.php?instance='.$instance.'&user='.$userid.'&action=vresp&rid='.$resp->id.'" ' .
                 'title="'.userdate($resp->submitted).'">'.$i.'</a>';
            $i++;
        }
        echo ' <input type="submit" value="'.$strsummary.'" name="action" /> ';
        echo ' <input type="submit" value="'.$strall.'" name="action" /> ';
        echo ' <input type="submit" value="'.get_string('return', 'questionnaire').'" name="action" /> ';
    
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;

    case get_string('return', 'questionnaire'):
    default:
        redirect('view.php?id='.$cm->id);
    }
?>