<?php  // $Id: report.php,v 1.8 2006/04/29 15:16:11 mchurch Exp $

/// This page prints a particular instance of questionnaire

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/questionnaire/lib.php');
    require_once($CFG->dirroot.'/mod/questionnaire/resultslib.php');

    $instance = optional_param('instance', false, PARAM_INT);   // questionnaire ID
    $qact = optional_param('qact', 'vresp');
    $sid = optional_param('sid', NULL, PARAM_INT);              // Survey id.
    $rid = optional_param('rid', false, PARAM_INT);
    $type = optional_param('type', '', PARAM_ALPHA);
    $byresponse = optional_param('byresponse', false, PARAM_INT);

    if ($instance === false) {
        if (!empty($SESSION->instance)) {
            $instance = $SESSION->instance;
        } else {
            error('A required parameter was missing.');
        }
    }
    $SESSION->instance = $instance;

    if (! $questionnaire = get_record("questionnaire", "id", $instance)) {
        error("Questionnaire is incorrect");
    }
    if (! $course = get_record("course", "id", $questionnaire->course)) {
        error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance("questionnaire", $questionnaire->id, $course->id)) {
        error("Course Module ID was incorrect");
    }

    require_login($course->id);

    if (!isteacheredit($course->id)) {
        error('These functions are restricted to editing teachers only!');
    }

    $questionnaire = new questionnaire(0, $questionnaire, $course, $cm);
    $formdata = data_submitted();

    if (isset($formdata)) {
         if (isset($formdata->action)) {
            switch ($formdata->action) {
        
            case 'Cancel & Return':
                redirect($CFG->wwwroot.'/mod/questionnaire/view.php?id='.$cm->id);
                break;

            case 'View all Responses':
                $qact = 'vresp';
                $byresponse = false;
                $rid = false;
                break;        

            case 'View by Response':
                $qact = 'vresp';
                $byresponse = true;
                $rid = false;
                break;

            case 'Cross Tabulate':
                $qact = 'cross';
                break;

            case 'Delete This Response':
                $qact = 'dresp';
                break;

            case 'Download CSV':
                $qact = 'dcsv';
                break;

            default:
                redirect($CFG->wwwroot.'/mod/questionnaire/view.php?id='.$cm->id);
            }
         }
    }
    
    switch ($qact) {
  
    case 'dresp':
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        } else if ($questionnaire->survey->owner != $course->id) {
            error('You must be a survey owner to perform this operation.');
        } else if (!$rid || !is_numeric($rid)) {
            error('Invalid response specified.');
        } else if (!($resp = get_record('questionnaire_response', 'id', $rid))) {
            error('Invalid response record specified.');
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- Unknown -';
            }
        } else {
            $ruser = $resp->username;
        }

    /// Print the page header
        print_header_simple('Deleting Response', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.'Questionnaires'.
                 '</a> -> '.'Survey Reports');

        notice_yesno('Are you sure you want to delete the response by '.$ruser.'?',
                     $CFG->wwwroot.'/mod/questionnaire/report.php?where=results&sid='.$sid.'&rid='.$rid.'&qact=dvresp',
                     $CFG->wwwroot.'/mod/questionnaire/report.php?where=results&sid='.$sid.'&rid='.$rid);

    /// Finish the page
        print_footer($course);
        break;
        
    case 'dvresp':
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        } else if ($questionnaire->survey->owner != $course->id) {
            error('You must be a survey owner to perform this operation.');
        } else if (!$rid || !is_numeric($rid)) {
            error('Invalid response specified.');
        } else if (!($resp = get_record('questionnaire_response', 'id', $rid))) {
            error('Invalid response record specified.');
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- Unknown -';
            }
        } else {
            $ruser = $resp->username;
        }

    /// Print the page header
        print_header_simple('Deleting Response', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.'Questionnaires'.
                 '</a> -> '.'Survey Reports');
        if (questionnaire_delete_response($rid)) {
            notice('Deleted response '.$rid.' by '.$ruser.'.',
                   $CFG->wwwroot.'/mod/questionnaire/report.php?where=results&sid='.$sid.'&byresponse=1');
        } else {
            error ('Could not delete response '.$rid.' by '.$ruser.'?',
                   $CFG->wwwroot.'/mod/questionnaire/report.php?where=results&sid='.$sid.'&byresponse=1');
        }
        break;
        
    case 'dcsv':
        include 'download.inc';
        exit();
        break;        

    case 'cross':
        $type = 'cross';
        /// Fall down into the vresp section.

    case 'vresp':
    default:
        if (empty($questionnaire->survey)) {
            error('Survey does not exist.');
        } else if ($questionnaire->survey->owner != $course->id) {
            error('You must be a survey owner to perform this operation.');
        }

        $ruser = false;

        if ($byresponse || $rid) { 
            if ($rid === false) {
                $resps = get_records('questionnaire_response', 'survey_id', $sid, 'id', '*', 0, 1);
                $resp = current($resps);
                $rid = $resp->id;
            } else {
                $resp = get_record('questionnaire_response', 'id', $rid);
            }
            if (is_numeric($resp->username)) {
                if ($user = get_record('user', 'id', $resp->username)) {
                    $ruser = fullname($user);
                } else {
                    $ruser = '- Unknown -';
                }
            } else {
                $ruser = $resp->username;
            }
        }

    /// Print the page header
        print_header_simple('Questionnaire Report', '',
                 '<a href="'.$CFG->wwwroot.'/mod/questionnaire/index.php?id='.$course->id.'">'.'Questionnaires'.
                 '</a> -> '.'Survey Reports');

    /// Print the main part of the page
        if ($rid !== false) {
            echo '<table align="right" cellspacing="0" cellpadding="0" border="0"><tr><td>';
            echo '<form name="print" method="post" action="print.php" target="_new">'."\n";
            echo '<input type="hidden" name="qid" value="'.$questionnaire->id.'" />'."\n";
            echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
            echo '<input type="hidden" name="rid" value="'.$rid.'" />'."\n";
            echo '<input type="hidden" name="sec" value="1" />'."\n";
            echo '<input type="hidden" name="userid" value="'.$resp->username.'" />';
            echo '<span style="font-size:75%;">印刷用の窓を開く</span> ';
            echo '<input type="submit" value="Print" name="print" /> ';
            echo '</form>';
            echo '</td></tr></table>';
        }

        echo '<form name="phpesp" method="post" action="report.php">'."\n";
        echo '<input type="hidden" name="instance" value="'.$instance.'" />'."\n";
        echo '<input type="hidden" name="sid" value="'.$sid.'" />'."\n";
        echo '<input type="hidden" name="tab" value="general" />'."\n";

        if ($ruser !== false) echo '<b>Respondent: '.$ruser.'</b><br />'."\n";

        $SESSION->questionnaire_survey_id = $sid;
        include 'results.inc';

        echo '<hr />'."\n";
        echo '<div align="center">';
        if ($rid) {
            echo '<input type="hidden" name="rid" value="'.$rid.'" />'."\n";
            echo '<input type="submit" value="Delete This Response" name="action" /> ';
            echo '<input type="submit" value="View all Responses" name="action" /> ';
        } else {
            echo '<input type="submit" value="View by Response" name="action" /> ';
            if ($qact != 'cross') {
                echo '<input type="submit" value="Cross Tabulate" name="action" /> ';
            }
        }
        echo '<input type="submit" value="Download CSV" name="action" /> ';
        echo '<input type="submit" value="Cancel &amp; Return" name="action" /> ';

        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;
    }
?>