<?php //$Id: backuplib.php,v 1.2 2006/02/02 00:35:46 gustav_delius Exp $
    //This php script contains all the stuff to backup/restore
    //scheduler mods

    //This is the "graphical" structure of the scheduler mod:
    //
    //                     scheduler                                      
    //                    (CL,pk->id)
    //                        |
    //                        |
    //                        |
    //                   scheduler_slots 
    //               (UL,pk->id, fk->scheduler)     
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files
    //
    //-----------------------------------------------------------

    function scheduler_backup_mods($bf,$preferences) {

        global $CFG;

        $status = true;

        //Iterate over scheduler table
        $schedulers = get_records ("scheduler","course",$preferences->backup_course,"id");
        if ($schedulers) {
            foreach ($schedulers as $scheduler) {
                //Start mod
                fwrite ($bf,start_tag("MOD",3,true));
                //Print scheduler data
                fwrite ($bf,full_tag("ID",4,false,$scheduler->id));
                fwrite ($bf,full_tag("MODTYPE",4,false,"scheduler"));
                fwrite ($bf,full_tag("NAME",4,false,$scheduler->name));
                fwrite ($bf,full_tag("DESCRIPTION",4,false,$scheduler->description));
                fwrite ($bf,full_tag("TEACHER",4,false,$scheduler->teacher));
                fwrite ($bf,full_tag("SCHEDULERMODE",4,false,$scheduler->schedulermode));
                fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$scheduler->timemodified));

                //if we've selected to backup users info, then execute backup_scheduler_slots
                if ($preferences->mods["scheduler"]->userinfo) {
                    $status = backup_scheduler_slots($bf,$preferences,$scheduler->id);
                }
                //End mod
                $status =fwrite ($bf,end_tag("MOD",3,true));
            }
        }
        return $status;
    }

    //Backup scheduler_slots contents (executed from scheduler_backup_mods)
    function backup_scheduler_slots ($bf,$preferences,$scheduler) {

        global $CFG;

        $status = true;

        $scheduler_slots = get_records("scheduler_slots","scheduler",$scheduler,"id");
        //If there is slots
        if ($scheduler_slots) {
            //Write start tag
            $status =fwrite ($bf,start_tag("SLOTS",4,true));
            //Iterate over each slot
            foreach ($scheduler_slots as $scheduler_slot) {
                //Start slot
                $status =fwrite ($bf,start_tag("SLOT",5,true));
                //Print scheduler_slots contents
                fwrite ($bf,full_tag("ID",6,false,$scheduler_slot->id));
                fwrite ($bf,full_tag("STARTTIME",6,false,$scheduler_slot->starttime));
                fwrite ($bf,full_tag("DURATION",6,false,$scheduler_slot->duration));
                fwrite ($bf,full_tag("STUDENT",6,false,$scheduler_slot->student));
                fwrite ($bf,full_tag("TEACHER",6,false,$scheduler_slot->teacher));
                fwrite ($bf,full_tag("APPOINTMENTLOCATION",6,false,$scheduler_slot->appointmentlocation));
                fwrite ($bf,full_tag("REUSE",6,false,$scheduler_slot->reuse));
                fwrite ($bf,full_tag("ATTENDED",6,false,$scheduler_slot->attended));
                fwrite ($bf,full_tag("TIMEMODIFIED",6,false,$scheduler_slot->timemodified));
                fwrite ($bf,full_tag("NOTES",6,false,$scheduler_slot->notes));
                fwrite ($bf,full_tag("EXCLUSIVE",6,false,$scheduler_slot->exclusive));
                fwrite ($bf,full_tag("APPOINTMENTNOTE",6,false,$scheduler_slot->appointmentnote));
                fwrite ($bf,full_tag("EMAILDATE",6,false,$scheduler_slot->emaildate));
                fwrite ($bf,full_tag("HIDEUNTIL",6,false,$scheduler_slot->hideuntil));
                //End slot
                $status =fwrite ($bf,end_tag("SLOT",5,true));
            }
            //Write end tag
            $status =fwrite ($bf,end_tag("SLOTS",4,true));
        }
        return $status;
    }
 
   ////Return an array of info (name,value)
   function scheduler_check_backup_mods($course,$user_data=false,$backup_unique_code) {
        //First the course data
        $info[0][0] = get_string("modulenameplural","scheduler");
        if ($ids = scheduler_ids ($course)) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        //Now, if requested, the user_data
        if ($user_data) {
            $info[1][0] = get_string("slots","scheduler");
            if ($ids = scheduler_slot_ids_by_course ($course)) {
                $info[1][1] = count($ids);
            } else {
                $info[1][1] = 0;
            }
        }
        return $info;
    }






    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of schedulers id
    function scheduler_ids ($course) {

        global $CFG;

        return get_records_sql ("SELECT s.id, s.course
                                 FROM {$CFG->prefix}scheduler s
                                 WHERE s.course = '$course'");
    }
   
    //Returns an array of scheduler slots id
    function scheduler_slot_ids_by_course ($course) {

        global $CFG;

        return get_records_sql ("SELECT sl.id , sl.scheduler
                                 FROM {$CFG->prefix}scheduler_slots sl,
                                      {$CFG->prefix}scheduler s
                                 WHERE s.course = '$course' AND
                                       sl.scheduler = s.id");
    }
?>
