<?PHP // $Id: index.php,v 1.4 2006/04/05 07:51:14 gustav_delius Exp $

/// This page lists all the instances of scheduler in a particular course

    require_once("../../config.php");
    require_once("lib.php");

    $id = required_param('id', PARAM_INT);   // course

    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);

    add_to_log($course->id, "scheduler", "view all", "index.php?id=$course->id", "");


/// Get all required strings

    $strschedulers = get_string("modulenameplural", "scheduler");
    $strscheduler  = get_string("modulename", "scheduler");


/// Print the header

    if ($course->category) {
        $navigation = "<A HREF=\"../../course/view.php?id=$course->id\">$course->shortname</A> ->";
    }

    print_header("$course->shortname: $strschedulers", "$course->fullname", "$navigation $strschedulers", "", "", true, "", navmenu($course));

/// Get all the appropriate data

    if (! $schedulers = get_all_instances_in_course("scheduler", $course)) {
        notice(get_string("noschedulers","scheduler"), "../../course/view.php?id=$course->id");
        die;
    }

/// Print the list of instances 

    $timenow = time();
    $strname  = get_string("name");
    $strweek  = get_string("week");
    $strtopic  = get_string("topic");

    if ($course->format == "weeks") {
        $table->head  = array ($strweek, $strname);
        $table->align = array ("CENTER", "LEFT");
    } else if ($course->format == "topics") {
        $table->head  = array ($strtopic, $strname);
        $table->align = array ("CENTER", "LEFT", "LEFT", "LEFT");
    } else {
        $table->head  = array ($strname);
        $table->align = array ("LEFT", "LEFT", "LEFT");
    }

    foreach ($schedulers as $scheduler) {
        if (!$scheduler->visible) {
            //Show dimmed if the mod is hidden
            $link = "<A class=\"dimmed\" HREF=\"view.php?id=$scheduler->coursemodule\">$scheduler->name</A>";
        } else {
            //Show normal if the mod is visible
            $link = "<A HREF=\"view.php?id=$scheduler->coursemodule\">$scheduler->name</A>";
        }
        if ($scheduler->visible or isteacher($course->id)) {
            if ($course->format == "weeks" or $course->format == "topics") {
                $table->data[] = array ($scheduler->section, $link);
            } else {
                $table->data[] = array ($link);
            }
        }
    }

    echo "<br />";

    print_table($table);

/// Finish the page

    print_footer($course);

?>
