<?PHP  // $Id: view.php,v 1.19 2006/04/05 08:19:17 gustav_delius Exp $

//Bug fixes for Add Slots feature added by Joshua Mathianas
//This will enable Scheduler to work with pre 1.7 versions of moodle
//I will post the file that will work with 1.7 when I finish it.
//Updated on December 12, 2006

/// This page prints a particular instance of scheduler and handles
/// all interactions 

    require_once("../../config.php");
    require_once("lib.php");

    $id = optional_param('id');    // Course Module ID, or
    $a = optional_param('a');     // scheduler ID
    $action = optional_param('action', 'view'); 
    $starttime = optional_param('starttime', floor(time()/86400)*86400+33*3600);
    $endtime= optional_param('endtime', $starttime);
    $duration = optional_param('duration', 10);
    $duration=intval($duration);
    $allowmultiplestudents = optional_param('allowmultiplestudents');
    $exclusiveappointment = optional_param('exclusiveappointment');
    $hideuntildate = optional_param('hideuntildate');
    $year = optional_param('year');
    $month = optional_param('month');
    $day = optional_param('day');
    $starthour = optional_param('starthour');
    $startminute = optional_param('startminute');
    $endhour = optional_param('endhour');
    $endminute = optional_param('endminute');
    //Joshua Mathianas added bug fix
    $yearend = optional_param('yearend');
    $monthend = optional_param('monthend');
    $dayend = optional_param('dayend');
    $slotid = optional_param('slotid');
    $seen = optional_param('seen');
    $studentid = optional_param('studentid');
    $confirmdelete = optional_param('confirmdelete');
    $bookstudent = optional_param('bookstudent');
    $noteMove = optional_param('noteMove');
    $notes = optional_param('notes');
    $appointmentlocation = optional_param('appointmentlocation');
    $page = optional_param('page', 'myappointments');
    $start = optional_param('start', '');
    $currenttime = time();
    //Joshua Mathianas more bug fixes
    $monday = optional_param('monday');
    $tuesday = optional_param('tuesday');
    $wednesday = optional_param('wednesday');
    $thursday = optional_param('thursday');
    $friday = optional_param('friday');
    $saturday = optional_param('saturday');
    $sunday = optional_param('sunday');
    $exclusive = optional_param('exclusive');
    $teacher = optional_param('teacher');
    $hasslots = optional_param('hasslots');
    $teacherid = optional_param('teacherid');
    $displayfrom = optional_param('displayfrom');
    $emailfrom = optional_param('emailfrom');

    if ($id) {
        if (! $cm = get_record("course_modules", "id", $id)) {
            error("Course Module ID was incorrect");
        }
    
        if (! $course = get_record("course", "id", $cm->course)) {
            error("Course is misconfigured");
        }
    
        if (! $scheduler = get_record("scheduler", "id", $cm->instance)) {
            error("Course module is incorrect");
        }

    } else {
        if (! $scheduler = get_record("scheduler", "id", $a)) {
            error("Course module is incorrect");
        }
        if (! $course = get_record("course", "id", $scheduler->course)) {
            error("Course is misconfigured");
        }
        if (! $cm = get_coursemodule_from_instance("scheduler", $scheduler->id, $course->id)) {
            error("Course Module ID was incorrect");
        }
    }

    require_login($course->id);
    
    add_to_log($course->id, 'scheduler', $action, "view.php?id=$cm->id", $scheduler->id, $cm->id);

/// Print the page header

    $strschedulers = get_string("modulenameplural", "scheduler");
    $strscheduler  = get_string("modulename", "scheduler");
    $strtime = get_string("time");
    $strdate = get_string("date", 'scheduler');
    $strstart = get_string('start', 'scheduler');
    $strend = get_string('end', 'scheduler');
    $strname = get_string('name');
    $strseen = get_string('seen', 'scheduler');
    $straction = get_string('action', 'scheduler');
    $strduration = get_string('duration', 'scheduler');
    $stremail = get_string('email');

    print_header_simple($scheduler->name, '',
                 "<A HREF=index.php?id=$course->id>$strschedulers</A> -> $scheduler->name", 
                  "", "", true, update_module_button($cm->id, $course->id, $strscheduler), 
                  navmenu($course, $cm));

    if (isteacher($course->id,$USER->id)) {
        //print top tabs
        $tabrows = array();
        $row  = array();
        if($action == "viewstatistics"){
            $currenttab = get_string("statistics", 'scheduler');
        } else if($action == "viewstudent"){
            $currenttab = get_string("studentdetails", 'scheduler');
            $row[] = new tabobject($currenttab, '', $currenttab);
        } else {
            $currenttab = get_string($page, 'scheduler');
        }

        $tabname = get_string("myappointments", 'scheduler');
        $row[] = new tabobject($tabname, "view.php?id=$cm->id&amp;page=myappointments", $tabname);
        if (count_records('scheduler_slots', 'scheduler', $scheduler->id) > count_records('scheduler_slots', 'scheduler', $scheduler->id, 'teacher', $USER->id)) {
            $tabname = get_string("allappointments", 'scheduler');
            $row[] = new tabobject($tabname, "view.php?id=$cm->id&amp;page=allappointments", $tabname);
        }
        $tabname = get_string("statistics", 'scheduler');
        $row[] = new tabobject($tabname, "view.php?action=viewstatistics&amp;id=$cm->id&amp;course=$scheduler->course&amp;page=studentbreakdown", $tabname);
        $tabrows[] = $row;
        print_tabs($tabrows, $currenttab);
        // We first have to check whether some action needs to be performed
        switch ($action) {
//=======================================================================================================================
        case 'viewstatistics':
            //display statistics tabs
            $tabs = array('studentbreakdown', 'staffbreakdown','lengthbreakdown','groupbreakdown');
            $tabrows = array();
            $row  = array();
            $currenttab = '';
            foreach ($tabs as $tab) {
                $tabname = get_string("$tab", 'scheduler');
                $row[] = new tabobject($tabname, "view.php?action=viewstatistics&amp;id=$cm->id&amp;course=$scheduler->course&amp;page=".$tab, $tabname);
            }
            $tabrows[] = $row;
    
            print_tabs($tabrows, get_string($page, 'scheduler'));

            //display correct type of statistics by request
            switch ($page) {
            case 'studentbreakdown':
                //display the ammount of time each student has received

                if ($students = get_course_students($course->id, $sort="u.lastname", $dir="ASC")) {
                   $table->head  = array ('Student', 'Duration');
                   $table->align = array ('LEFT', 'CENTER');
                   $table->width = array('','','','','','','');
                   foreach ($students as $astudent) {
                      if ($slots = get_records_sql("SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND student = '".$astudent->id."'")) {
                         $durationcount = 0;
                         foreach($slots as $slot) {
                             $durationcount += $slot->duration;
                         }
                         $table->data[] = array (fullname($astudent), $durationcount);
                      }                 
                   }
                   print_table($table);
                }
                break;
            case 'staffbreakdown':
                //display break down by member of staff
                if ($teachers = get_course_teachers($course->id))  {
                   $table->head  = array ('Staff', 'Duration');
                   $table->align = array ('LEFT', 'CENTER');
                   $table->width = array('','','','','','','');
                   foreach ($teachers as $teacher) {
                      if ($slots = get_records_sql("SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND teacher = '".$teacher->id."' AND student>0")) {
                         $durationcount = 0;
                         foreach($slots as $slot) {
                             $durationcount += $slot->duration;
                         }
                         $table->data[] = array (fullname(get_record('user', 'id', $teacher->id)), $durationcount);
                      }                 
                   }
                  print_table($table);
                }
                break;
            case 'lengthbreakdown':
                //display break down my duration
                if ($slots = get_records_sql("SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND student>0")) {
                   $table->head  = array ('Duration', 'Appointments');
                   $table->align = array ('LEFT', 'CENTER');
                   $table->width = array('','','','','','','');

                   $durationcount = array();
                   foreach($slots as $slot) {
                       if (array_key_exists($slot->duration, $durationcount)) {
                           $durationcount[$slot->duration] ++;
                       } else {
                           $durationcount[$slot->duration] = 1;
                       }
                   }
                   foreach ($durationcount as $key => $duration) {
                       $table->data[] = array ($key, $duration);
                   }        
                  print_table($table);
                }         
                break;
            case 'groupbreakdown':
                //display by number of atendees to one member of staff
                if ($slots = get_records_sql("SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND student>0 ORDER BY teacher,starttime,duration")) {
                   $table->head  = array ('Group Size', 'Occurances', 'Duration');
                   $table->align = array ('LEFT', 'CENTER', 'CENTER');
                   $table->width = array('','','','','','','');

                   $groupcounter = array();
                   $groupsum = array();
                   $previoustime = -1;
                   $previousduration = -1;
                   $previousstaff = -1;
                   $groupcount = 0;
                   foreach($slots as $slot) {
                        if (($slot->starttime != $previoustime)|($slot->duration != $previousduration)|($slot->teacher != $previousstaff)){
                            if ($previoustime > -1){
                                $groupcounter[$groupcount] ++;
                                $groupsum[$groupcount] += $previousduration;
                            }
                            $previoustime = $slot->starttime;
                            $previousduration = $slot->duration;
                            $previousstaff = $slot->teacher;
                            $groupcount = 0;
                        }
                        $groupcount ++;
                   }
                   if (!array_key_exists($groupcount, $groupcounter)) {
                       $groupcounter[$groupcount] = 0;
                       $groupsum[$groupcount] = 0;
                   }
                   $groupcounter[$groupcount] ++;
                   $groupsum[$groupcount] += $previousduration;
                   foreach ($groupsum as $key => $duration) {
                       $table->data[] = array ($key,$groupcounter[$key], $duration);
                   }
                   print_table($table);
                }
           }
           print_continue("$CFG->wwwroot/mod/scheduler/view.php?id=".$scheduler->id);
           /// Finish the page
           print_footer($course);
           return;
//=======================================================================================================================
        case 'viewstudent':
            print_user(get_record('user', 'id', $studentid), $course);
            //print tabs
            $tabrows = array();
            $row  = array();
            if($page == "appointments"){
                $currenttab = get_string("appointments", 'scheduler');
            } else {
                $currenttab = get_string("notes", 'scheduler');
            }
            $tabname = get_string("appointments", 'scheduler');
            $row[] = new tabobject($tabname, "view.php?action=viewstudent&amp;id=$cm->id&amp;studentid=$studentid&amp;course=$scheduler->course&amp;order=$order&amp;page=appointments", $tabname);
            $tabname = get_string("notes", 'scheduler');
            $row[] = new tabobject($tabname, "view.php?action=viewstudent&amp;id=$cm->id&amp;studentid=$studentid&amp;course=$scheduler->course&amp;order=$order&amp;page=notes", $tabname);
            $tabrows[] = $row;
            print_tabs($tabrows, $currenttab);

            //if slots have been booked
            if ($slots = get_records_sql("SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND student = '".$studentid."' ORDER BY starttime ".$order)) {
                //privide link to sort in the opposite direction
                if($order == "DESC"){
                    $orderlink = "<a href=\"view.php?action=viewstudent&amp;id=$cm->id&amp;studentid=".$studentid."&amp;course=$scheduler->course&amp;order=ASC&amp;page=$page\">";
                } else {
                    $orderlink = "<a href=\"view.php?action=viewstudent&amp;id=$cm->id&amp;studentid=".$studentid."&amp;course=$scheduler->course&amp;order=DESC&amp;page=$page\">";
                }
                //print page header and prepare table headers
                if ($page == "appointments"){
                    print_heading(get_string('slots' ,'scheduler'));
                    $table->head  = array ($orderlink.$strdate."</a>", $strstart, $strend, $strseen,get_string("staffmember", 'scheduler'));
                    $table->align = array ('LEFT', 'LEFT', 'CENTER', 'CENTER', 'CENTER');
                    $table->width = array('','','','','','','','');
                } else {
                    print_heading(get_string('notes' ,'scheduler'));
                    $table->head  = array ($orderlink.get_string("notes", 'scheduler')."</a>");
                    $table->align = array ('LEFT');
                    $table->width = array('');
                }
                foreach($slots as $slot) {
                    $startdate = scheduler_userdate($slot->starttime,1);
                    $starttime = scheduler_usertime($slot->starttime,1);
                    $endtime = scheduler_usertime($slot->starttime+($slot->duration*60),1);
                    if ($page == "appointments"){
                        //display appointments
                        if ($slot->attended == 0){
                            $table->data[] = array ($startdate, $starttime, $endtime, "<img src=\"unticked.gif\" border=\"0\">",fullname(get_record('user', 'id', $slot->teacher)));
                        } else {
                            $table->data[] = array ($startdate, $starttime, $endtime, "<img src=\"ticked.gif\" border=\"0\">",fullname(get_record('user', 'id', $slot->teacher)));
                        }
                    } else {
                        //display notes
                        if ($slot->notes != ""){
                            $table->data[] = array ($slot->notes."<br><font size=-2>".$startdate." ".$starttime." to ".$endtime."</font>");
                        }
                    }
                }
                // print slots table
                print_table($table);
            }
            print_continue("$CFG->wwwroot/mod/scheduler/view.php?id=".$scheduler->id);
            /// Finish the page
            print_footer($course);
            return;
//=======================================================================================================================
        case 'saveseen': 
            if (!$slot = get_record('scheduler_slots', 'id', $slotid)) {
                break;
            }
            $slot->attended = $seen;
            if (!update_record('scheduler_slots', $slot)) {
                error('Couldn\'t save data to database');
            }
            scheduler_events_update($slot,$course);
            if ($seen == 0 and $slot->starttime == SCHEDULER_TIMEUNKNOWN) {
                // This was from a student who had not made an appointment yet
                delete_records('scheduler_slots', 'id', $slotid);
            }
            break;
//=======================================================================================================================
        case 'newseen': 
            // The teacher has marked a student as seen that had not made an appointment yet
            // We therefore create a slot with unknow times and mark it as seen
            if (!record_exists('user_students', 'userid', $studentid, 'course', $course->id)) {
                error("No student with this ID in this course");
            }
            if (record_exists('scheduler_slots', 'student', $studentid, 'scheduler', $scheduler->id)) {
                // the student is already marked
                break;
            }
            $slot->attended = 1;
            $slot->scheduler = $scheduler->id;
            $slot->starttime = SCHEDULER_TIMEUNKNOWN;
            $slot->duration = SCHEDULER_TIMEUNKNOWN;
            $slot->student = $studentid;
            $slot->teacher = $USER->id;
            $slot->reuse = 0;
            $slot->timemodiefied = time();  
            if (!insert_record('scheduler_slots', $slot)) {
               error('Couldn\'t save data to database');
            }
            break;
//=======================================================================================================================
        case 'deleteslot': 
            if (!$slotid) {
                error("Slot ID missing");
            }
            
            //update the calendar.
            if ($slot = get_record("scheduler_slots","id",$slotid)) {
                scheduler_delete_calendar_events($slot);
            }
            if (!delete_records('scheduler_slots', 'id', $slotid)) {
                error("Could not delete the slot from the database");
            }
            break;
//=======================================================================================================================
        case 'savesession': 
            // This creates sessions using the data submitted by the user via the form on add.html
            $startday = make_timestamp($year, $month, $day, 0, 0);
            $endday = make_timestamp($yearend, $monthend, $dayend, 0, 0);

            $starttime = make_timestamp($year, $month, $day, $starthour, $startminute);
            $endtime = make_timestamp($yearend, $monthend, $dayend, $endhour, $endminute);
            $slot->starttime = $starttime;
            $slot->appointmentlocation = $appointmentlocation;
            if ($starttime < time()) {
                notice(get_string('startpast', 'scheduler'),
                    "view.php?action=addsession&amp;id=$cm->id&amp;starttime=$starttime&amp;endtime=$endtime&amp;duration=$duration");
            }
            // The following avoids overlapping slots
            // arguments are passed by reference
            if (scheduler_conflict($scheduler->id, $starttime, $endtime, $teacherid)) {
                notice(get_string('conflict', 'scheduler'),
                    "view.php?action=addsession&amp;id=$cm->id&amp;starttime=$starttime&amp;endtime=$endtime&amp;duration=$duration");
            }
            $slot->scheduler = $scheduler->id;
            $slot->attended = 0;
            $slot->timemodified = time();
            $slot->teacher=$teacherid;
            //display appropriate list of appointments
            if ($teacherid != $USER->id){
                $page = "allappointments";
            } else {
                $page = "myappointments";
            }
            $slot->exclusive = $exclusive;
            if ($hasslots) {
                // The teacher wants this set up so that only one student can use each slot
                $slot->reuse = 0;
                $slot->duration = $duration;
                if (!($duration > 0 and $duration <= ($endtime - $starttime)/60)) {
                    notice(get_string('cantfit', 'scheduler', $duration), 
                        "view.php?action=addsession&amp;id=$cm->id&amp;starttime=$starttime&amp;endtime=$endtime&amp;duration=$duration");
                }
                $durationseconds = $duration*60;
            } else {
                
//                $slot->reuse = 1;
                $slot->duration = ($endtime - $starttime)/60 ;
                $durationseconds = ($endtime - $starttime);
            }
            $countslots = 0;
            // Now create as many slots of $duration as will fit between $starttime and $endtime
            $couldnotcreateslots = "";
            $fordays = (($endday-$startday)/86400);
            $startfrom = $starttime;

            for ($d = 0; $d<=$fordays; $d ++){
                $eventdate = usergetdate($startfrom + ($d * 86400));
                $dayofweek = date("l",$startfrom + ($d * 86400));

                if ((($dayofweek == "Monday") & ($monday==1))|(($dayofweek == "Tuesday") & ($tuesday==1))|(($dayofweek == "Wednesday") & ($wednesday==1))|(($dayofweek == "Thursday") & ($thursday==1))|(($dayofweek == "Friday") & ($friday==1))|(($dayofweek == "Saturday") & ($saturday==1))|(($dayofweek == "Sunday") & ($sunday==1))){
                    $slot->starttime = $startfrom + ($d * 86400);
                    $starttime = $startfrom + ($d * 86400);
                    $endtime = make_timestamp(date("Y",$starttime), date("m",$starttime), date("d",$starttime), $endhour, $endminute);
                    if ($displayfrom == "now"){
                        $slot->hideuntil = time();
                    } else {
                        $slot->hideuntil = make_timestamp($eventdate['year'], $eventdate['mon'], $eventdate['mday'], 6, 0)-$displayfrom;
                    }
                    if ($emailfrom == "never"){
                        $slot->emaildate = 0;
                    } else {
                        $slot->emaildate = make_timestamp($eventdate['year'], $eventdate['mon'], $eventdate['mday'], 0, 0)-$emailfrom;
                    }
                    while ($slot->starttime <= $endtime - $durationseconds) {
                        if (scheduler_conflict($scheduler->id, $starttime, $starttime+$durationseconds, $teacherid)) {
                            echo "Could not create a slot";
                        } else {
                            if (!insert_record('scheduler_slots', $slot, false)) {
                                error("Could not insert slot into database");
                            } else {
			       echo "insert record";
			    }
                            $countslots++;
                        }
                        $slot->starttime += $durationseconds;
                        $starttime += $durationseconds;
                    }
                }
            }
            print_heading(get_string('slotsadded', 'scheduler', $countslots));
            break;
//=======================================================================================================================
        case 'savemove': 
            // The teacher has submitted a form with new times for the slot
            if (!$slot = get_record('scheduler_slots', 'id', $slotid)) {
                error("Invalid slot ID");
            }
            $starttime = make_timestamp($year, $month, $day, $starthour, $startminute);

            // Avoid slots starting in the past
            if ($starttime < (time()-60*60*24*3)) {
                notice(get_string('startpast', 'scheduler'), "view.php?action=moveslot&amp;id=$cm->id&amp;slotid=$slotid");
            }

            // Avoid overlapping slots, by asking the user if they'd like to overwrite the existing ones...
            if ($conflicts = scheduler_conflict($scheduler->id, $starttime, $starttime + $duration*60, $USER->id)) {
                if ($confirmdelete && confirm_sesskey()) {
                    foreach ($conflicts as $conflict) {
                        if ($conflict->id != $slot->id) {
                            delete_records('scheduler_slots', 'id', $conflict->id);
                            scheduler_delete_calendar_events($conflict);
                        }
                    }
                } else { 
                    echo "<br><br>";
                    print_simple_box_start("center", "", "");
                        echo get_string("slotwarning","scheduler")."<br><br>";
                        foreach ($conflicts as $conflict) {
                            if ($conflict->student) {
                                $student = get_record("user","id",$conflict->student);
                                $assignedToStudent = true;
                            } else {
                                $assignedToStudent = false;
                            }
                            //print a line for the slot, in bold if it has a student attached to it.
                            echo ($assignedToStudent ? "<b>" : "").userdate($conflict->starttime)." - ".$conflict->duration." ".get_string("minutes","scheduler")." - ".
                                 ($assignedToStudent ? get_string('assignedto','scheduler')." ".fullname($student) : get_string('emptyslot','scheduler')).($assignedToStudent ? "</b>" : "")."<br>";
                        }
                        $options = array();
                        $options['action'] = 'moveslot';
                        $options['id'] = $cm->id;
                        $options['slotid'] = $slotid;
                        print_single_button('view.php', $options, get_string('cancel'));
                        $options['action'] = 'savemove';
                        $options['confirmdelete'] = 'true';
                        $options['sesskey'] = sesskey();
                        $options['year'] = $year;
                        $options['month'] = $month;
                        $options['day'] = $day;
                        $options['starthour'] = $starthour;
                        $options['startminute'] = $startminute;
                        $options['displayyear'] = $displayyear;
                        $options['displaymonth'] = $displaymonth;
                        $options['displayday'] = $displayday;
                        $options['duration'] = $duration;
                        $options['exclusive'] = $exclusive;
                        $options['bookstudent'] = $bookstudent;
                        $options['noteMove'] = $noteMove;
                        $options['appointmentlocation'] = $appointmentlocation;
                        $options['attended'] = $attended;
                        print_single_button('view.php', $options, get_string('deletetheseslots', 'scheduler'));
                    print_simple_box_end(); 
                    print_footer($course);
                    die();  
                }
            }
            $slot->starttime = $starttime;
            $slot->duration = $duration;
            $slot->timemodified = time();
            $slot->exclusive = $exclusive;
            $slot->student = $bookstudent;
            $slot->notes = $noteMove;
            $slot->appointmentlocation = $appointmentlocation;
            $slot->attended = $attended;
            $slot->hideuntil = make_timestamp($displayyear, $displaymonth, $displayday, 6, 0);
            $slot->exclusive = scheduler_noneexclusive($scheduler->id, $starttime, $slot->starttime + $slot->duration*60);
            if (!update_record('scheduler_slots', $slot, false)) {
                error("Could not update slot in database");
            }
            scheduler_events_update($slot,$course);
            break;

//=======================================================================================================================
        case 'newmoveslot': 
                //this is to simplify the process of adding one appointment and goes on to display the move screen to enter details
                $slot->student = 0;
                $slot->teacher = $USER->id;
                $slot->scheduler = $scheduler->id;
                $slot->hideuntil = time();
                $slotid = insert_record('scheduler_slots', $slot, true);
                if ($slotid < 1){
                    error("Could not insert slot into database");
                }
//=======================================================================================================================
        case 'moveslot': 
            // The teacher has clicked on "Change" next to an existing slot and must
            // now be shown a form to choose time and duration
            if (!$slotid) {
                error("Slot ID parameter missing");
            }
            if (!$slot = get_record('scheduler_slots', 'id', $slotid)) {
                error("Slot $slotid does not exist");
            }
            if ($slot->starttime <> SCHEDULER_TIMEUNKNOWN) {
                $starttime = $slot->starttime;
                $duration = $slot->duration;
                print_heading(get_string('moveslot', 'scheduler'));
            } else {
                // we are actually adding a new slot
                print_heading(get_string('addsession', 'scheduler'));
            }
            $exclusiveappointment = $slot->exclusive;
            $hideuntildate = $slot->hideuntil;
            $notes = $slot->notes;
            $bookstudent = $slot->student;
            $appointmentlocation = $slot->appointmentlocation;
            $attended = $slot->attended;
            print_simple_box_start("center", "", "");
            include_once('move.html');
            print_simple_box_end();
            echo '<br />';
            /// Finish the page
            print_footer($course);
            return;
//=======================================================================================================================
        case 'addsession':
            // The teacher needs to be shown the form for adding slots
            print_heading(get_string('addsession', 'scheduler'));
            print_simple_box_start("center", "", "");
            include_once('add.html');
            print_simple_box_end();
            echo '<br />';
            /// Finish the page
            print_footer($course);
            return;
//=======================================================================================================================        
        case 'schedule':
            if (!record_exists('user_students', 'userid', $studentid, 'course', $course->id)) {
                error("No student with this ID in this course");
            }
            if (record_exists('scheduler_slots', 'student', $studentid, 'scheduler', $scheduler->id)) {
                notice("This student is already marked", "view.php?id=$cm->id");
            }
            $slot->scheduler = $scheduler->id;
            $slot->starttime = SCHEDULER_TIMEUNKNOWN;
            $slot->duration = SCHEDULER_TIMEUNKNOWN;
            $slot->student = $studentid;
            $slot->teacher = $USER->id;
            $slot->timemodiefied = time();
            $slot->exclusive = 0;
            $slot->notes = '';
            $slot->appointmentlocation = '';
            $slot->hideuntil = SCHEDULER_TIMEUNKNOWN;
            $slot->attended = 0;
            if (!$slot->id = insert_record('scheduler_slots', $slot)) {
               error('Couldn\'t save data to database');
            }
            $exclusiveappointment = $slot->exclusive;
            $hideuntildate = $slot->hideuntil;
            $notes = $slot->notes;
            $bookstudent = $slot->student;
            $appointmentlocation = $slot->appointmentlocation;
            $attended = $slot->attended;
            $student = get_record('user', 'id', $studentid);
            $studentname = fullname($student, true);
            print_heading(get_string('scheduleappointment', 'scheduler', $studentname));
            print_simple_box_start("center", "", "");
            include_once('move.html');
            print_simple_box_end();
            echo '<br />';
            break;
        }
//=======================================================================================================================
        // No more actions. We can now build the page for the teacher
        print_heading($scheduler->name);
        if ($scheduler->description) {
            print_simple_box(format_text($scheduler->description), 'center');
        }
//        if ($page == "allappointments"){
//            $sql = "SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' ORDER BY starttime ASC, student ASC";
//        } else {
//            $sql = "SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $scheduler->id ."' AND teacher = '".$USER->id."' ORDER BY starttime ASC, student ASC";
//            $page = "myappointments";
//        }

        if ($page == "allappointments"){
            $select = "scheduler = '". $scheduler->id ."'";
        } else {
            $select = "scheduler = '". $scheduler->id ."' AND teacher = '".$USER->id."'";
            $page = "myappointments";
        }
        $sqlcount = count_records_select("scheduler_slots",$select);

	// $start = optional_param('start');  // 2007-02-07 - Dan Clarke 
        if (($start == "") & ($sqlcount > 25)){
            $startcount = count_records_select("scheduler_slots",$select." AND starttime < '".strtotime("now")."'");
            $start = floor($startcount/25);
        }
        $sql = "SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE $select ORDER BY starttime ASC, student ASC LIMIT ".($start*25).",25";

        if ($slots = get_records_sql($sql)) {
            // some slots already exist
            // print instructions and button for creating slots
            print_simple_box_start('center', "", "");
            print_string('addslot', 'scheduler');
            // print add session button
            $options['action'] = 'addsession';
            $options['id'] = $cm->id;
            echo '<center>';
            print_single_button('view.php', $options, get_string('addsession', 'scheduler'));
            $options['action'] = 'newmoveslot';
            print_single_button('view.php', $options, get_string('addsingleslot', 'scheduler'));
            echo '</center>';        
            print_simple_box_end();
            
            // prepare slots table
            if($page == "myappointments"){
                $table->head  = array ($strdate, $strstart, $strend, $strseen, '', $strname, $straction);
                $table->align = array ('LEFT', 'LEFT', 'CENTER', 'CENTER', 'CENTER', 'LEFT', 'CENTER');
                $table->width = array('','','','','','','');
            } else {
                $table->head  = array ($strdate, $strstart, $strend, $strseen, '', $strname,get_string('staffmember', 'scheduler'), $straction);
                $table->align = array ('LEFT', 'LEFT', 'CENTER', 'CENTER', 'CENTER', 'LEFT', 'LEFT', 'CENTER');
                $table->width = array('','','','','','','');
            }
            $previousdate = '';
            $previoustime = '';
            $previousendtime = '';
            foreach($slots as $slot) {
                if ($slot->student == 0 && $slot->starttime+(60*$slot->duration) < time()) {
                    // This slot is in the past and has not been chosen by any student, so delete
                    delete_records('scheduler_slots', 'id', $slot->id);
                    continue;
                }

                /// Parameter $local in scheduler_userdate and scheduler_usertime added by power-web.at
                /// When local Time or Date is needed the $local Param must be set to 1 
                $startdate = scheduler_userdate($slot->starttime,1);
                $starttime = scheduler_usertime($slot->starttime,1);
                $endtime = scheduler_usertime($slot->starttime+($slot->duration*60),1);

                // We now want to make sure that the date or time doesn't get repeated if it is the same for several appointments
                if ($startdate == $previousdate) {
                    $startdate = '';
                    if ($starttime == $previoustime) {
                        $starttime = '';
                    } else {
                        $previoustime = $starttime;
                    }
                    if ($endtime == $previousendtime) {
                        $endtime = '';
                    } else {
                        $previousendtime = $endtime;
                    }
                } else {
                    $previousdate = $startdate;
                    $previoustime = $starttime;
                    $previousendtime = $endtime;
                }

                if ($slot->student) {
                    $student = get_record('user', 'id', $slot->student);
                    $picture = print_user_picture($slot->student, $course->id, $student->picture, false, true);
//                    $name = "<a href=\"../../user/view.php?id=$student->id&amp;course=$scheduler->course\">".fullname($student).'</a>';
                    $name = "<a href=\"view.php?action=viewstudent&amp;id=$cm->id&amp;studentid=$student->id&amp;course=$scheduler->course&amp;order=DESC\">".fullname($student).'</a>';
                    $checkbox = "<a href=\"view.php?action=saveseen&amp;id=$cm->id&amp;slotid=$slot->id&amp;seen=";
                    if ($slot->attended == 1) {
                        $checkbox .= '0"><img src="ticked.gif" border="0"></a>';
                    } else {
                        $checkbox .= '1"><img src="unticked.gif" border="0"></a>';
                    }
                } else {
                    $picture = '';
                    $name = '';
                    $checkbox = '';
                }

                $actions = '<span style="font-size: x-small;">';
                if ($USER->id == $slot->teacher){
                    $actions .= "[<a href=\"view.php?action=deleteslot&amp;id=$cm->id&amp;slotid=$slot->id\">".get_string('delete').'</a>]';
                }
                $actions .= "[<a href=\"view.php?action=moveslot&amp;id=$cm->id&amp;slotid=$slot->id\">".get_string('move', 'scheduler').'</a>]';
//                if((($slot->student > 0)&($slot->exclusive = 0))|($slot->student == 0)){
//                    $actions .= "[<a href=\"view.php?action=moveslot&amp;id=$cm->id&amp;slotid=$slot->id\">".get_string('schedule', 'scheduler').'</a>]';
//                }
                $actions .= '</span>';
                if($page == "myappointments"){
                    $table->data[] = array ($startdate, $starttime, $endtime, $checkbox, $picture, $name, $actions);
                } else {
                    $table->data[] = array ($startdate, $starttime, $endtime, $checkbox, $picture, $name,fullname(get_record('user', 'id', $slot->teacher)), $actions);
                }
            }

            // print slots table
            print_heading(get_string('slots' ,'scheduler'));
            print_table($table);

            // Instruction for teacher to click Seen box after appointment
            echo '<br /><center>';

            if ($sqlcount > 25){
                echo "Page : ";
                $pagescount = ceil($sqlcount/25);
                for ($n = 0; $n < $pagescount; $n ++){
                    if ($n == $start){
                        echo ($n+1)." ";
                    } else {
                        echo "<a href=view.php?id=$cm->id&amp;page=$page&amp;start=$n>".($n+1)."</a> ";
                    }
                }
            }

            echo "</center>";


            // Instruction for teacher to click Seen box after appointment
            echo '<br /><center>'.get_string('markseen', 'scheduler').'</center>';

        } else if ($action <> 'addsession') { // Teacher has to set up slots
            print_simple_box_start('center', "", "");
            print_string('welcomenewteacher', 'scheduler');
            $options['action'] = 'addsession';
            $options['id'] = $cm->id;
            echo '<center>';
            print_single_button('view.php', $options, get_string('addsession', 'scheduler'));
            $options['action'] = 'newmoveslot';
            print_single_button('view.php', $options, get_string('addsingleslot', 'scheduler'));
            echo '</center>';
            print_simple_box_end();
        }
        
        // print table of outstanding students 
        if (!$students = get_course_students($course->id, $sort="u.lastname", $dir="ASC")) {
            notify(get_string('noexistingstudents'));
        } else {
            $mtable->head  = array ('', $strname, $stremail, $strseen, $straction);
            $mtable->align = array ('CENTER','LEFT','LEFT','CENTER','CENTER');
            $mtable->width = array('', '', '', '', '');
            $mtable->data = array();
            // In $mailto the mailing list for reminder emails is built up
            $mailto = '<a href="mailto:';
            $date = usergetdate(time());
            foreach ($students as $student) {
                if (!record_exists('scheduler_slots', 'student', $student->id, 'scheduler', $scheduler->id)) {
                    $picture = print_user_picture($student->id, $course->id, $student->picture, false, true);
                    $name = "<a href=\"../../user/view.php?id=$student->id&amp;course=$scheduler->course\">".fullname($student)."</a>";
                    $email = obfuscate_mailto($student->email);
                    $mailto .= $student->email.', ';
                    $checkbox = "<a href=\"view.php?action=newseen&amp;id=$cm->id&amp;studentid=$student->id\">".
                                '<img src="unticked.gif" border="0"></a>';
                    $actions = '<span style="font-size: x-small;">'.
                             "[<a href=\"view.php?action=schedule&amp;id=$cm->id&amp;studentid=$student->id\">".get_string('schedule', 'scheduler').'</a>]'.
                             '</span>';
                    $mtable->data[] = array($picture, $name, $email, $checkbox, $actions);
                }
            }
            $numm = count($mtable->data);


            //dont print if allowed to book multiple appoinments
            if (($numm > 0)&($scheduler->schedulermode == "oneonly")) { // There are students who still have to make appointments
                // Print number of students who still have to make an appointment
                print_heading(get_string('missingstudents', 'scheduler', $numm));

                // Print links to print invitation or reminder emails
                $strinvitation = get_string('invitation', 'scheduler');
                $strreminder = get_string('reminder', 'scheduler');
                $mailto = rtrim($mailto, ', ');

                $subject = $strinvitation.': '.$scheduler->name;
                $body = "$strinvitation: $scheduler->name\n\n".
                    get_string('invitationtext', 'scheduler').
                    "{$CFG->wwwroot}/mod/scheduler/view.php?id=$cm->id";
                echo '<center>'.get_string('composeemail', 'scheduler').
                    $mailto.'?subject='.htmlentities(rawurlencode($subject)).
                    '&amp;body='.htmlentities(rawurlencode($body)).
                    '"> '.$strinvitation.'</a> ';

                $subject = $strreminder.': '.$scheduler->name;
                $body = "$strreminder: $scheduler->name\n\n".
                    get_string('remindertext', 'scheduler').
                    "{$CFG->wwwroot}/mod/scheduler/view.php?id=$cm->id";
                echo $mailto.'?subject='.htmlentities(rawurlencode($subject)).
                    '&amp;body='.htmlentities(rawurlencode($body)).
                    '"> '.$strreminder.'</a></center><br />';

                // print table of students who still have to make appointments
                print_table($mtable);
            }
        }
    }
    
    if (isstudent($course->id)) { 
        if ($action == 'savechoice') {
            if (!$slotid) {
                notice(get_string('notselected', 'scheduler'), "view.php?id=$cm->id");
            }
            if (!$slot = get_record('scheduler_slots', 'id', $slotid)) {
                error("Invalid slot ID");
            }
////////////////////////////////////////////////////////////////////////
//Eingef�gt Andreas Grabs 10.05.2005
////////////////////////////////////////////////////////////////////////
//Testen, ob bereits ein termin vergeben wurde
            
            if ($slot->student != '0' && $slot->student != $USER->id) {
               print_simple_box_start('CENTER');
               echo '<h2 style="color:red;">'.get_string('slot_is_just_in_use', 'scheduler').'</h2>';
               print_simple_box_end();
               print_continue("$CFG->wwwroot/mod/scheduler/view.php?id=$cm->id");
               print_footer($course);
               exit();
            }
            
////////////////////////////////////////////////////////////////////////
//            if ($oldslot = get_record('scheduler_slots', 'student', $USER->id, 'scheduler', $slot->scheduler)) {
            $sql = "SELECT * FROM ". $CFG->prefix . "scheduler_slots WHERE scheduler = '". $slot->scheduler ."' AND student = '".$USER->id."'";

            if ($scheduler->schedulermode == "onetime"){
                $sql .= " AND starttime > ".time();
            }
            if ($oldslot = get_record_sql($sql)) {
                // This student was already signed up for a different slot. Change
                $oldslot->student = 0;
                if ($oldslot->reuse == 0) {
                    // This slot should be made available to other students again
                    scheduler_events_update($oldslot,$course); 
                    if (!update_record('scheduler_slots', $oldslot)) {
                        error('Couldn\'t delete old choice from database');
                    }
                } else { 
                    // This slot can simply be deleted because there still is the
                    // original reuseable slot around
                    scheduler_delete_calendar_events($oldslot);
                    if (!delete_records('scheduler_slots', 'id', $oldslot->id)) {
                        error('Couldn\'t delete old choice from database');
                    }
                }
            }
            $slot->student = $USER->id;
            if ($slot->reuse == 0) {
                // this is a single-use slot and simply has to have the student id written to it
                if (!update_record('scheduler_slots', $slot)) {
                   error('Couldn\'t save choice to database');
                }
                scheduler_events_update($slot, $course);
            } else {
                // This slot should remain useable and therefore we insert an additional slot.
                $slot->id = '';
                if (!$newSlotID = insert_record('scheduler_slots', $slot)) {
                   error('Couldn\'t save choice to database');
                } else {
                    $slot = get_record("scheduler_slots","id",$newSlotID);
                    scheduler_events_update($slot, $course);
                }
            }
        }

        $teacher = get_record('user', 'id', $scheduler->teacher);
        $description = "<b>$scheduler->name:</b> $scheduler->description";
        print_simple_box($description, 'CENTER', '80%');
        print_simple_box_start('CENTER', '80%');
        if (record_exists('scheduler_slots', 'student', $USER->id)) {
            print_string('welcomebackstudent', 'scheduler');
        } else {
            print_string('welcomenewstudent', 'scheduler');
        }
        print_simple_box_end();
        
        if ($slots = get_records('scheduler_slots', 'scheduler', $scheduler->id, 'starttime ASC, student DESC')) {
            print_heading(get_string('slots' ,'scheduler'));
            $radio = '<input type="radio" name="slotid" value="';
            $table->head  = array ($strdate, $strstart, $strend, get_string('choice', 'scheduler'), get_string('staffmember', 'scheduler'),get_string('groupsession', 'scheduler'));
            $table->align = array ('LEFT', 'LEFT', 'CENTER', 'CENTER', 'LEFT');
            $previousdate = '';
            $previoustime = 0;
            $paststudentslots = 0; //a count of the number of slots already had by a student
            foreach($slots as $slot) {
                if ($slot->student == 0 && $slot->starttime+(60*$slot->duration) < time()) {
                    // This slot is in the past and has not been chosen by any student, so delete
                    delete_records('scheduler_slots', 'id', $slot->id);
                    continue;
                }
                $startdate = scheduler_userdate($slot->starttime,1);
                $starttime = scheduler_usertime($slot->starttime,1);
                $endtime = scheduler_usertime($slot->starttime+($slot->duration*60),1);
                if ($startdate == $previousdate) {
                    $startdate = '';
                    if ($slot->starttime == $previoustime) {
                        continue;
                    }
                }
                if ($slot->exclusive==0){
                    $groupsession = "Yes";
                } else {
                    $groupsession = "No";
                }
                if (!$slot->student) {
                    //if slot is free
                    if (($paststudentslots > 0)&($scheduler->schedulermode == "oneonly")){
                        //if students are only allowed one appointment and this student has already had theirs then skip this record
                        continue;
                    }
                    if ($slot->starttime <= time()){
                        $table->data[] = array ($startdate, $starttime, $endtime, "&nbsp;", "<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>",$groupsession);
                    } else if ($slot->hideuntil >=time()){
                        $table->data[] = array ($startdate, $starttime, $endtime, $radio.$slot->id.'">', "<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>",$groupsession);
                    }
                    $previoustime = $slot->starttime;
                    if ($startdate) {
			$previousdate = $startdate;
		    }
                } else if ($slot->student == $USER->id) {
                    //if slot is booked by this student
                    if ($slot->starttime <= time()){
                        $paststudentslots ++;
                        $table->data[] = array ("<b>$startdate</b>", "<b>$starttime</b>", "<b>$endtime</b>", "<img src=\"ticked.gif\" border=\"0\">", "<b>"."<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>"."</b>","<b>".$groupsession."</b>");
                    } else {
                        $table->data[] = array ("<b>$startdate</b>", "<b>$starttime</b>", "<b>$endtime</b>", $radio.$slot->id.'" checked>', "<b>"."<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>"."</b>","<b>".$groupsession."</b>");
                    }
                    $previoustime = $slot->starttime;
                    if ($startdate) $previousdate = $startdate;
                } else if (!($slot->student == $USER->id) & ($slot->exclusive==0)) {
                    //if slot is booked by another student and group bookings are allowed
                    if ($slot->starttime <= time()){
                        $table->data[] = array ("<b>$startdate</b>", "<b>$starttime</b>", "<b>$endtime</b>", "<img src=\"ticked.gif\" border=\"0\">", "<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>",$groupsession);
                    } else {
                        $table->data[] = array ("<b>$startdate</b>", "<b>$starttime</b>", "<b>$endtime</b>", $radio.$slot->id.'" checked>', "<a href=\"../../user/view.php?id=$slot->teacher&amp;course=$scheduler->course\">".fullname(get_record('user', 'id', $slot->teacher))."</a>",$groupsession);
                    }
                    $previoustime = $slot->starttime;
                    if ($startdate) $previousdate = $startdate;
                }
	
            }
            echo '<center><form action="view.php" method="post">'.
                 '<input type="hidden" name="action" value="savechoice">'.
                 '<input type="hidden" name="id" value="'.$cm->id.'">';
            print_table($table);
            echo '<br /><input type="submit" value="'.get_string('savechoice', 'scheduler').'"></form></center>';
        } else {
            notify(get_string('noslots', 'scheduler'));
        }
    }
    print_continue("$CFG->wwwroot/course/view.php?id=$course->id");

/// Finish the page
    print_footer($course);

?>